/*
	Write by xempo
	Free under LGPL
*/
#include "filesan.h"
#include "orlattr.h"
#include "infor.h"
#include "shellcom.h"
#include "dlist.h"
#include "chMT.h"
#include "ortime.h"
#include "dirext.h"
#include "fculoop.h"
#include "../rtdata/en/target/orlattr.h"

static const char ORLattrib[]="ORLattr";

QPtrList <ORLattr> orlAtts;

char *ORDnam;
int loopMsg;

void getDirNam(__ORD *dir, int msg)
{
loopMsg=msg;
ORDnam=ORDpath(dir, NULL,0);
}

#define  _orlattr_  _cfg_

ORLattr::ORLattr(QWidget *par, __ORD *dir1) : CfgWidget(par, ORLattrib),
	dir(*dir1), pIt((LVItem *)((Filesan *)par)->getTreeView()->selectedItem())
{
orlAtts.append(this);
}

ORLattr::~ORLattr()
{
orlAtts.remove(this);
}

void ORLattr::execu(const int w, const int h, const int id)
{
#define  hg  23
char buf[1200];
CfgWidget::execu(w,h,id);
creatGenTab()
ORDinfors( &dir, buf, 2);
QLabel *brow=new QLabel(QString::fromUtf8(buf), tab1);
brow->setFrameStyle(QLabel::Panel|QLabel::Sunken);
brow->setGeometry( hg, hg, tabw-2*hg,
	tabh-(hg)-fntSz-(fntSz*2)  );
brow->setAlignment( int( QLabel::WordBreak | QLabel::AlignVCenter ) );
setIcon(*pixmapLoad(ORLspacImg));
show();

read=new QCheckBox(QString::fromUtf8(readChs), tab2);
read->setChecked(R=dir.mode&ORL_MR);
write=new QCheckBox(QString::fromUtf8(writeChs), tab2);
write->setChecked(W=dir.mode&ORL_MW);
hide=new QCheckBox(QString::fromUtf8(hideChs), tab2);
hide->setChecked(H=dir.mode&ORL_MH);
subchk=new QCheckBox(QString::fromUtf8(subdirChs), tab2);

nedt=new QLineEdit(tranText(strCodec, dir.name), tab2);
tedt=new QLineEdit(ORasctim(dir.datebuf), tab2);
int combH=fntSz*3/2;
nedt->setGeometry(fntSz, fntSz, tabw-2*fntSz, combH);
read->setGeometry(fntSz*2, fntSz+fntSz*3, tabw-3*fntSz, combH);
write->setGeometry(fntSz*2, fntSz+fntSz*5, tabw-3*fntSz, combH);
hide->setGeometry(fntSz*2, fntSz+fntSz*7, tabw-3*fntSz, combH);
tedt->setGeometry(fntSz, fntSz+fntSz*10, tabw-2*fntSz, combH);
subchk->setGeometry(fntSz*4, tabh-fntSz*4, 12*fntSz, combH);
}

static QMetaObjectCleanUp cleanUp_ORLattr( ORLattrib, &ORLattr::staticMetaObject );

QMetaObject *ORLattr::metaObj = 0;
QMetaObject* ORLattr::staticMetaObject()
{
  if ( !metaObj ){
    static const QMetaData slot_tbl[] = {
	{ "sure()" , &slot_0_0, QMetaData::Private },
	{ fastKey , &slot_int, QMetaData::Private }
    };
    metaObj = QMetaObject::new_metaobject(ORLattrib, QWidget::staticMetaObject(), slot_tbl, 2,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_ORLattr.setMetaObject( metaObj );
    }
  return metaObj;
}

#ifndef QT_NO_PROPERTIES
bool ORLattr::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES

bool ORLattr::qt_invoke( int _id, QUObject* _o )
{
static const char mcmd[]="-M";
int  i, n, sw=_id - staticMetaObject()->slotOffset();
char *pms[5], dtbuf[10], modebuf[10];
Filesan *fs=(Filesan *)parentWidget();
switch(sw){
//case 1 :
case 0 :	{
	bool sub=subchk->isChecked(),
		OpenRoseMsg=fs->getModul()==_OPENROSE,
		_r=read->isChecked(), _w=write->isChecked(), _h=hide->isChecked();
	const QString T(tedt->text().local8Bit());
	const QString S(nedt->text().local8Bit());
	close();
	struct tm dt;
	__ORD *pDir;
	__ORL *orl;
	LVItem *it;
	bool  bm, ch=false;
	fs->fsKillTimer();
	fs->busiedCursor();
	orl=dir.lib;
	if(OpenRoseMsg && (LVItem *)fs->getTreeView()->selectedItem()!=pIt)pDir=&dir;
	else   for(i=0; i<orl->cnt_usedir; i++)
		if(orl->usedirs[i]->own_adr==dir.own_adr){
			pDir=orl->usedirs[i];
			break;
		}

	pms[0]=(char *)".";
	if(sub){ pms[3]=(char *)"-t"; pms[4]=NULL; n=4;  }
	else { pms[3]=NULL; n=3; }
	if( bm=(R!=_r||_w!=W||_h!=H) ){
		i=0;
		if(_r)modebuf[i++]='r';
		if(_w)modebuf[i++]='w';
		if(_h)modebuf[i++]='h';
		modebuf[i]=0;
	}

	if(OpenRoseMsg){
		ORDnam=ORDpath(pDir, NULL, 0);
		it=fs->getTreeView()->seekORD(orl, ORDnam, ORL_chmode);
		free(ORDnam);
		}
	if((bm||sub) && _w){
		ch=true;
		pms[1]=(char *)mcmd;	pms[2]=modebuf;
		chMT(pDir,  n, pms, ORL_chmode);
	}
	if(strcmp(S, pDir->name)){
		__ORD dirbuf, *dir1=ORDread(orl, &dirbuf, NULL, pDir->parent_adr, False);
		if(ORDren(dir1, pDir->name, S)){
			if(OpenRoseMsg){
				it->setText(0, QString::fromUtf8(S));
				it->_setName(S);
				}
			}
		}
	smtime(T, &dt);
	ORtime(mktime(&dt), (BYTE *)dtbuf);
	if( sub || memcmp(dtbuf, pDir->datebuf, sizeof(time_t) > OrlTmLen ? OrlTmLen : sizeof(time_t))!=0 ){
		pms[1]=(char *)"-T";	pms[2]=(char *)(const char *)T;
		chMT(pDir,  n, pms, ORL_chdate);
		}

	if((bm||sub)&&_w==false && ch==false){
		pms[1]=(char *)mcmd;	pms[2]=modebuf;
		chMT(pDir,  n, pms, ORL_chmode); // get ORDnam
		}
	if(bm && OpenRoseMsg)fs->getTreeView()->freshItem(it, pDir, sub);
	fs->fsStartTimer();
	fs->normalCursor();
	}
	break;
case 1 : switch(_o[1].payload.i){
	case 600 : loadSearchModify((Filesan *)parentWidget());
		break;
	case 601 : ((Filesan *)parentWidget())->showTop();
	}
default : return QWidget::qt_invoke( _id, _o );
}
return true;
}

#undef _orlattr_
