/*
	Write by xempo 2016
	Free under LGPL
*/
#include "ordir.h"
#include "dirext.h"
#include "stdfun.h"
#include "infor.h"
#include "conspace.h"
#include "shellcom.h"
#include "jxswitch.h"
#include "export.h"
#include "read.h"
#include "../source/params.def"
#include "../searchmodify/sm.def"
#include "../rtdata/en/target/filesor.h"
#include <utime.h>
#include <sys/time.h>
#include <dirent.h>

#include "cfun.h"
#include "../source/fsico.def"

static char _root[]="/";

extern int uId, gId;

enum bool_t { false, true };

int  *__params;

void strins(char *sc, const char *in)
{
unsigned int  ln=strlen(sc), len=strlen(in);
if(ln)memmove(sc+len, sc, ln);
memcpy(sc,in,len);
sc[ln+len]=0;
}

void fmtInps(char *pth)
{
char *pt;
while( (pt=strstr(pth," /")) )
	*pt='\n';
}

BOOL isWritable(int uid, int gid, struct stat64 *st)
{
if(uid==0)return true;
if(uid==st->st_uid)
    return (st->st_mode&S_IWUSR); 
if(gid==st->st_gid)
    return (st->st_mode&S_IWGRP); 
return (st->st_mode&S_IWOTH);
}

BOOL isReadable(int uid, int gid, struct stat64 *st)
{
if(uid==0)return true;
if(uid==st->st_uid)
    return (st->st_mode&S_IRUSR); 
if(gid==st->st_gid)
    return (st->st_mode&S_IRGRP); 
return (st->st_mode&S_IROTH);
}

BOOL isExecable( int uid, int gid, struct stat64 *st )
{
int  m=st->st_mode;
if( uid==0&&S_ISDIR(m) )return true;
if(uid==st->st_uid)return (m&S_IXUSR); 
if(gid==st->st_gid)return (m&S_IXGRP); 
return (m&S_IXOTH);
}

int operaState(struct stat64 *st)
{
return (isWritable(uId, gId, st) ? mode_w : 0) |(isExecable(uId, gId, st) ? mode_x : 0) |(isReadable(uId, gId, st) ? mode_r : 0);
}

#define  orgcmp  -0x7fff
int namcmp(const char *nam1, const char *nam2, BOOL cs)
{
int n;
const char *ext1=strrchr(nam1, '.'),
	*ext2=strrchr(nam2, '.');
if(*nam1=='.'){
	if(*nam2!='.')return -1;
	if(nam1==ext1)ext1=NULL;
	if(nam2==ext2)ext2=NULL;
	n=1;
}
else {
	if(*nam2=='.')return 1;
	n=0;
	}
int rt,  i, tmp=orgcmp, isNumCmp=0;
const unsigned char *pt1=(unsigned char *)nam1,
	*pt2=(unsigned char *)nam2;

if(ext1){ // as prog-1.1.2 > prog-1.6, so ...
	register const char *pt=ext1;
	while(  is_numb(*pt) )pt++;
	if(*pt)ext1=NULL;
	}
if(ext2){ // as prog-1.1.2 > prog-1.6, so ...
	register const char *pt=ext2;
	while(  is_numb(*pt) )pt++;
	if(*pt)ext2=NULL;
	}
register int ch1, ch2;

_loop_:	i=n;
loop:	ch1=pt1[i];	ch2=pt2[i];
	if(isNumCmp==2&&(is_numb(ch1)==false||is_numb(ch2)==false)){
		if(is_numb(ch2))return -1; // like 2mt, 10mt cmp
		if(is_numb(ch1))return 1;
		return tmp;
		}
	if(cs==false){
		if(ch1>'A'-1 && ch1< 'Z'+1)ch1|=32;
		if(ch2>'A'-1 && ch2< 'Z'+1)ch2|=32;
		}
	rt= ch1 - ch2 ;
	if( rt  || ch1==0||ch2==0 ){
	    if((ch1=='+'||ch1=='-') && (ch2=='+'||ch2=='-') )rt=-rt; // '+' less '-' in ASCII
	    if( (ext1 && ext1<=(char *)(pt1+i) ) &&
		(ch2&&(ext2==NULL||ext2>(char *)(pt2+i))) )return -1;
	    if( (ext2 && ext2<=(char *)(pt2+i)) &&
		(ch1&&(ext1==NULL||ext1>(char *)(pt1+i)) ) ) return 1;

	    if( is_numb(ch1) && is_numb(ch2) ){
		isNumCmp=2;
		if(tmp==orgcmp)tmp=rt;
		}
	    else {
		if(isNumCmp==0 ){
	_re_start_:	if(rt==0&&cs==false){ cs=true; goto _loop_; }
			else return rt;
			}
		if(is_numb(ch2))return -1; // 16x16; 32x32; 128x128 cmp
		if(is_numb(ch1))return 1; // 16x16; 32x32; 128x128 cmp
		// int ret = ( ( pt1+i==(const unsigned char *) ext1)|| (ch1|32)==32  && ch2) ||( ( pt2+i==(const unsigned char *)ext2 )|| (ch2|32)==32 && ch1)  ? rt : tmp;
		goto _re_start_;
		}
	}
	else isNumCmp=is_numb(ch1) ? (isNumCmp==2 ? 2:1) : 0;
	i++;
	goto loop;
}

static const  char SPC[]="";
__ORD *_diropen(__ORD *pdir, const char *dirnam)
{
__ORD *dir=ORDopen(pdir, dirnam, DIR_READ);
if(idxdscpt<0x7ffd){
	char buf[300], *pth;
	sprintf(buf, "ORL-dir : fail to open \"%s/%s\"" , pdir? (pth=ORDpath(pdir, NULL, 0)) : SPC, dirnam);
	if(pdir)free(pth);
	CHBinfo(idxdscpt, buf);
}
return dir;
}

int numbRead(__ORD *dir, int numb, MAU *send, int n, BOOL msg)
{
/* BYTE *stat=NumRead(lib,dir,numb,send,n);
if(_idxdscpt<0x7ffd && msg )pWarning(num_fmts , _idxdscpt, dir? dir->name : SPC, numb);
return stat;*/
BYTE *fcu=NumRead(dir,numb,send,n);
if(fcu){
BYTE m=fcu[1];
free(fcu);
return m;
}
if(msg){
char buf[320], *pth;
sprintf(buf, "ORL-Id : fail to read \"%s/%d\"", dir? (pth=ORDpath(dir, NULL, 0)) : SPC, numb);
if(dir)free(pth);
CHBinfo(idxdscpt, buf);
}
return -1;
}

BOOL numbWrite(__ORD *dir, int numb, MAU *send, int n)
{
if(NumWrite(dir,numb,send,n))return true;
char buf[320], *pth;
sprintf(buf, "ORL-Id : fail to write \"%s/%d\"", dir? (pth=ORDpath(dir, NULL, 0)) : SPC, numb);
if(dir)free(pth);
CHBinfo(idxdscpt, buf);
return false;
}


/* ------------------------------------------------------------------------------------------------*/
extern const char *home, archNam[];
int modeCvtIco(const char *fn)
{
struct stat64 st, lnkst;
BOOL xTag, dir_off;
lstat64(fn, &lnkst);
if(stat64( fn, &st ))return ICO_LINKNONE;
dir_off=S_ISDIR(st.st_mode) ? 14/*DIR_OFF*/ : 0;

if(isReadable( uId, gId, &st )==false)return ICO_NOREAD|dir_off;
xTag=isExecable( uId, gId, &st);
if(dir_off){
	if(strcmp(fn,home)==0)return ICO_HOMEDIR;
	if(!xTag)return ICO_NOEXEC;
	if(S_ISLNK(lnkst.st_mode))return ICO_LINKOBJ|dir_off;
	return isWritable(uId, gId, &st)?  dir_off : ICO_NOWRITE;
	}
if(memstr(fn, 0, ".ora", 4, 1))return ICO_ORL_AR;
if(namefilters(fn, archNam, 1))return ICO_ARCH;
if(S_ISLNK(lnkst.st_mode))return ICO_LINKOBJ;
return (xTag ? ICO_EXEC_FILE : 0);
}

int subDirCount(const char *dirnam)
{
  int cnt=-2;
  DIR *dir=opendir(dirnam);
  if(dir){
	while( readdir(dir) )cnt++;
	closedir(dir);
	}
  return cnt;
}

char *parentDirIndex(const char *dirnam, const char *par)
{
char *pIdx=strrchr( (char *)dirnam, '/');
int t=pIdx-dirnam;
return (memcmp(dirnam, par, t )==0 && par[t]==0) ? pIdx+1 : NULL;
}

int isExist(const char *fnam, struct stat64 *sb)
{
if( lstat64(fnam, sb) )return none_File;
if( S_ISLNK(sb->st_mode) ){
      if( stat64(fnam,sb) ){ 
	sb->st_size=0;
	return lost_Link;
	}
     else return symLink;
}
return 0;
}

char *useSysCmd(const char *cmd)
{
FILE *fp=popen(cmd, "r");
if(fp){
	unsigned int len;
	char buf[2400];
	len=fread(buf,1, 2399,fp);
	pclose(fp);
	if(len==0)return (char *)SPC;
	buf[len]=0;
	return strdup(buf);
}
else return NULL;
}

char *copyInfo(int m, int rclt, int mSz, int sz, int take)
{
#define  FCOPY  32  // #include "../source/fsloop.def"
char takebuf[56], *bu=(char *)malloc(256);
int n=sprintf(bu, cpResultChs, _filesor_[m-FCOPY+Int_copyChs], rclt, mSz, sz);
if(take>60)sprintf(takebuf, takeChs, take/60, take%60);
else sprintf(takebuf, takeChs0,  take);
strcpy(bu+n, takebuf);
return bu;
#undef  FCOPY
}

int chtime(const char *fnam, const struct stat64 *st)
{
	struct  utimbuf  utm;
	utm.actime=st->st_atime;
	utm.modtime=st->st_mtime;
	return utime(fnam, &utm);
}

const char *getImageData(const char *filenam, unsigned int *L)
{
FILE *fp=fopen(filenam, "rb");
if(fp){
	char *buf;
	int len;
	fseek(fp, 0, SEEK_END);
	len=ftell(fp);
	if( (buf=(char *)malloc(len+2)) ){
		rewind(fp);
		fread(buf, len, 1, fp);
		fclose(fp);
		*L=len;
		return buf;
	}
}
return NULL;
}

int creatFile(const char *fnam)
{
if(access(fnam, F_OK)==0)return 1;
FILE *fp=fopen64(fnam, "wb");
if(fp){
	fclose(fp);
	return 0;
	}
return -1;
}

BOOL ORDtest(__ORL *orl, __ORD *dir)
{
if(orl){
  int i;
  for(i=0; i<orl->cnt_usedir; i++)
      if(orl->usedirs[i]==dir)return true;
/*  if(dir==orl->CurDir)orl->CurDir=(__ORD *)orl;*/
}
return false;
}

/*  fn like  /home/xempo/.orllus-3.6.2/Language/zh_CN */
char *divORL(char *fn)
{
char *pt;
struct stat64 st;
if(stat64(fn, &st)==0)return _root;
while( (pt=strrchr(fn, '/')) ){
    *pt=0;
    if(stat64(fn, &st)==0)return pt;
}
return NULL;
}

const char tfile[]="file://", torl[]="orl://";
const char *getDropFN(const char *fn, int *tDrop)
{
const char *pt=strstr(fn, tfile);
if(pt==fn){
	*tDrop=2;
	return fn+sizeof(tfile)-1;
	}
else {
	pt=strstr(fn, torl);
	if(pt==fn){
		*tDrop=4;
		return fn+sizeof(torl)-1;
	}
}
*tDrop=1;
return fn;
}

#define recover(pt, L)   for(r=0;  r<L; r++ )if(pt[r]==0)pt[r]='/';

void idCpFile(char  *fn, const char *dst)
{
    char *pt;
    int L=strlen(fn);
    if( (pt=divORL(fn)) ){
	__ORL *orl;
	if( (orl=ORLuse(fn, ORLerror)) ){
	  char *pms[5];
	  pms[0]=pt;	pms[1]=(char *)dst;
	  pms[2]=(char *)"-f";
	  if(pt!=_root){
		int r;
		L-=pt-fn;
		recover(pt, L)
		}
	  if(adjNumb(pt)){
		pms[3]=NULL;
		releasAr(orl, 3, pms);
		}
	  else {	
		pms[3]=(char *)"-t";	pms[4]=NULL;
	//	ORLexpo(orl, 3, pms, 0);
		ORDimagas(orl, 4, pms);
		}
	  ORLreleas(orl, NULL);
	}
    }
}

int idCp(char *fn, char *dst, int type, __ORD *dir, const char *eng)
{
int ret=2, /* 0 is dir, i is id ,  2 is fail */
	L=strlen(dst);
struct stat64 st;
__ORL *sORL, *dORL;
char *pt, *dpt, buff[3200];
if( (type&32) || (dpt=divORL(dst)) ){
	int r;
	if( !(dORL=ORLuse(dst, ORLerror)) )return 2;
	if(type&32)dpt=(char *)"/";
	else {
		L-=dpt-dst;
		recover(dpt, L )
		}
	switch( (type&7) ){
	case 4 :	L=strlen(fn);	
		pt=divORL(fn);
		if(!pt)goto _ex_;
		L-=pt-fn;
		if( !(sORL=ORLuse(fn, ORLerror)) )goto _ex_;
		recover(pt, L)
		ret=adjNumb(pt);
		sprintf(buff, ret ? "cp.%d.%d %s %s -f" : "dircp.%d.%d %s %s -t",
			sORL->openIdx, dORL->openIdx, pt, dpt);
		break;
	case 1 : 
	case 2 :	if(stat64(fn, &st))goto _ex_;
		ret=!S_ISDIR(st.st_mode);
		if(ret){
			int numb=NumRand(dir);
			if(eng)sprintf(buff, "arfile %s/%d %s %s", dpt, numb, fn, eng);
			else sprintf(buff, "write.f %s/%d %s", dpt, numb, fn);
		}
		else {
			if(eng)sprintf(buff, "ardir %s %s %s", dpt, fn, eng);
			else sprintf(buff, "imagdir %s %s", dpt, fn);
		}
	}
comRun(dORL, buff, 0, NULL);
if(type==4)ORLreleas(sORL, NULL);
_ex_:ORLreleas(dORL, NULL);
}
return ret;
}

BOOL lmtStat(struct stat64 *src_st, const struct findparams *fndpm) /* SearchModify:: */
{
return ( ( (fndpm->sizelmt0>-1&& src_st->st_size<fndpm->sizelmt0) || (fndpm->sizelmt1>-1 && src_st->st_size>fndpm->sizelmt1))
	|| ((fndpm->timelmt0>0 && src_st->st_mtime<fndpm->timelmt0) || (fndpm->timelmt1>0 && src_st->st_mtime>fndpm->timelmt1))
	|| (( _sm_user && fndpm->uId!=src_st->st_uid)||( _sm_group && fndpm->gId!=src_st->st_gid )) );
}

#include <pthread.h>
void __sleep(unsigned int usecs)
{
	    struct timeval tv;
	    gettimeofday( &tv, 0 );
	    struct timespec ti;
	    ti.tv_nsec = ( tv.tv_usec + ( usecs % 1000000 ) ) * 1000;
	    ti.tv_sec = tv.tv_sec + ( usecs / 1000000 ) + ( ti.tv_nsec / 1000000000 );
	    ti.tv_nsec %= 1000000000;
	    pthread_mutex_t mtx;
	    pthread_cond_t cnd;
	    pthread_mutex_init(&mtx, 0);
	    pthread_cond_init(&cnd, 0);
	    pthread_mutex_lock( &mtx );
	    (void) pthread_cond_timedwait( &cnd, &mtx, &ti );
	    pthread_mutex_unlock( &mtx );
	    pthread_cond_destroy( &cnd );
	    pthread_mutex_destroy( &mtx );
}

#define maxVal(a, b)	((b) < (a) ? (a) : (b))
#define minVal(a, b)	((a) < (b) ? (a) : (b))

int doThread(int stackSize, int priority, void *(*func) (void *), void *pms)
{
    int ret;
    pthread_attr_t attr;
    pthread_attr_init(&attr);
    pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);

    switch (priority) {
    case _InheritPriority :
	    pthread_attr_setinheritsched(&attr, PTHREAD_INHERIT_SCHED);
	    break;
    default:
	{
	    int sched_policy, prio_min, prio_max,
		prio;
	    if (pthread_attr_getschedpolicy(&attr, &sched_policy) != 0)break;	    

	    if ( (prio_min = sched_get_priority_min(sched_policy)) == -1 ||
		(prio_max = sched_get_priority_max(sched_policy)) == -1)break;

	    switch (priority) {
	    case _IdlePriority :
		prio = prio_min;
		break;
	    case _HighestPriority :
		prio = prio_max;
		break;

	    default:
		// crudely scale our priority enum values to the prio_min/prio_max
		prio = (((prio_max - prio_min) / _TimeCriticalPriority) *
			priority) + prio_min;
		prio = maxVal(prio_min, minVal(prio_max, prio));
		break;
	    }
	    struct sched_param sp;
	    sp.sched_priority = prio;

	    pthread_attr_setinheritsched(&attr, PTHREAD_EXPLICIT_SCHED);
	    pthread_attr_setschedparam(&attr, &sp);
	    break;
	}
    }
// _POSIX_THREAD_PRIORITY_SCHEDULING

    if ( stackSize > 0 && (ret = pthread_attr_setstacksize( &attr, stackSize)) )return ret;
    pthread_t thr;
    ret = pthread_create( &thr, &attr, func, pms );
    if (ret ==1 /*EPERM*/) {
	pthread_attr_setinheritsched(&attr, PTHREAD_INHERIT_SCHED);
	ret = pthread_create(&thr, &attr, func, pms);
    }
    pthread_attr_destroy( &attr );
    return ret;
}

#include "../ProEdit/txtstyle.c"
