/*
	xempo write in 4-2014
	Free under LGPL 2014, 2015
*/

#include <pthread.h>
#include <qgroupbox.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qdatetimeedit.h>
#include <qlineedit.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qtextcodec.h>
#include <qtextbrowser.h>
#include <qpainter.h>
#include <qfontmetrics.h>
#include "combo.h"
#include "searchmodify.h"
#include "infowidget.h"
#include "inputdlg.h"
#include "orlcon.h"
#include "simpleimage.h"
#include "stdfun.h"
#include "../rtdata/en/target/filesor.h"
#include "../rtdata/en/target/smwdg.h"
#include "fileatt.h"
#include "copypanel.h"
#include "rebuild.h"
#include "shellcom.h"
#include "cfun.h"

#define  pathGroup  group[0]
#define  keywordGroup  group[1]
#define  fileGroup  group[2]
#define  timeGroup  group[3]

#define     subChk  _Chk[0]
#define     pathCaseChk  _Chk[1]
#define     fuser  _Chk[2]
#define     fgroup  _Chk[3]
#define     kwCaseChk  _Chk[4]
#define     kwWordChk  _Chk[5]
#define     bakupChk  _Chk[6]

#define     binChk  _Chk[7]
#define     wholfileChk  _Chk[8]
#define     TDSChk  _Chk[9]

#define     grapShowChk  _Chk[12]


enum SM_Event {
	Event_Error=65201,
	Event_AddItem=65204,
	virtual_notify=65205
	};

#define  divFont(n)  (fntSz/n + ((fntSz%n)*10/n > 4 ? 1 : 0))

#define  __fromUnicode(s, c)  _setCodec(c)->fromUnicode(s)

#define  optListLen  220
#define  LeftWide  54

extern int buttonMsg;

static const char __div[]="\n", *sm_dtfmt, __listSet[]="listSet";
const char search_modify[]="SearchModify";

QStringList smLogList;

unsigned int __uid, __gid,	early_dt, late_dt;

const char slot_find[]=SLOT(find()), slot_find2[]=SLOT(find2()),// find & replace
	slot_stop[]=SLOT(stop());

#define   selAsSrcAct  popAct[0]
#define   selAddAct  popAct[1]
#define   proEditAct  popAct[2]
#define   dirSumAct  popAct[3]
#define   cp2dirAct   popAct[4]
#define   mv2dirAct  popAct[5]
#define   attribAct  popAct[6]
#define   delAct  popAct[7]
#define   vdelAct  popAct[8]
#define   fspConAct  popAct[9]
#define   sImageAct  popAct[10]
#define   renAct  popAct[11]
#define   selAllAct  popAct[12]

void SearchModify::popRightMenu(LVItem *it)
{
if(sm_cnt){
	ActMenu   rightMenu(this);
	QPopupMenu openMenu(this);
	rightMenu.setFont(font());
	if(it){
	  const char *fn=it->fnam;
	  selAsSrcAct->addTo(&rightMenu);
	  selAddAct->addTo(&rightMenu);
	  rightMenu.insertSeparator();
	  rightMenu.insertMenu(dirImg, openPath, this, SLOT(PZpath()), Key_F11 );
	  rightMenu.insertMenu(-1, exefile, this, slot_open, 0);
	  if(creatOpenMenu(openMenu, filesor, fn)){
		openMenu.setFont(font());
		rightMenu.insertItem(QString::fromUtf8(opensChs), &openMenu);
		}
	  renAct->addTo(&rightMenu);
	  struct stat64 st;
	  stat64(fn, &st);
	  rightMenu.insertSeparator();
	  if( S_ISDIR(st.st_mode) ){
		dirSumAct->addTo(&rightMenu);
		if(selAsSrc.count()&&isWritable(uId, gId, &st)&&isExecable(uId,gId, &st) ){
			cp2dirAct->addTo(&rightMenu);
			mv2dirAct->addTo(&rightMenu);
			}
		}
	  else if( isReadable(uId, gId, &st) ){
		proEditAct->addTo(&rightMenu);
		fspConAct->addTo(&rightMenu);
		sImageAct->addTo(&rightMenu);
		rightMenu.insertSeparator();
		}
	  attribAct->addTo(&rightMenu);
	  rightMenu.insertSeparator();
	  delAct->addTo(&rightMenu);
	  rightMenu.insertSeparator();
	  vdelAct->addTo(&rightMenu);
	}
	selAllAct->addTo(&rightMenu);
	rightMenu.exec(QCursor::pos());
}
}

SearchModify::SearchModify(QWidget* parent)
    : QMainWindow(parent, search_modify, WType_TopLevel|WDestructiveClose ),
	smThread(-1), runSearch(false),
	fsels(__AppenAlone),	operalst(__AppenAlone),
	filesor((Filesan *)parent),	operaListTag(false),
	_Params(__params), wheel_SM(0),
	fntSz(fontHeight), listSetMsg(false), freqPix(freqIco),
	SMpms(NULL),
	orgw(0), orgb(0), waitMsg(false), cpEvent(false), startMsg(false),
	pfdat(NULL), sm_preCnt(0), deleting(false),
	kwCodec(sm_kwCodeComboIdx), pathCodec(sm_pathCodeComboIdx)
{
   _smwdg_=charsFromORL(5);
    setFont(filesor->font());
}

void SearchModify::exe()
{
    bool wsz;
    int i, cn;
    if((wsz=setWdgFrame(this, ORLRoot, smSizeId))==false)resize(760, 592);
//    setMinimumSize(minW, minH);
    tb=new QToolBar(search_modify, this, Qt::DockBottom);
    tb->setMovingEnabled(false);
    tabs=new QTabWidget(this);
    QWidget *optsTab=new QWidget(tabs);
    setCentralWidget(tabs);
    smLogListAct=creatTA(this, tb, findLogImg, smLogListChs, SLOT(smLog()), CTRL+Key_L);
    smLogListAct->setEnabled(smLogList.count());
    saveResultAct=creatTA(this, tb, saveImg, saveResult, SLOT(saveResult()), 0);
    saveResultAct->setEnabled(false);
    tb->addSeparator();
    creatTA(this, tb, helpImg, helpChs, SLOT(hlp()), Key_F1);
    sbar=new StatusPanel(tb, sbar_SearchModify);
    findAct=creatTA(this, tb, findImg, findChs, slot_find, CTRL+Key_F);
    replAct=creatTA(this, tb, searchModifyImg, replActChs, slot_find2, CTRL+Key_R);
    replAct->setEnabled(!sm_reset);
    searchCutAct=creatTA(this, tb, searchCutImg, searchCut, SLOT(smCut()), CTRL+Key_C);
    searchCutAct->setEnabled(!sm_reset);
    resetAct=addTA(this, tb, resetImg, resetChs, NULL, SLOT(reset()), CTRL+Key_F7, true, sm_reset);
    operaListAct=addTA(this, tb, operaListImg, operaListChs, NULL, SLOT(OL()), Key_F7, true, false);
    operaListAct->setEnabled(false);
    tb->addSeparator();

    stopAct=creatTA(this, tb, stopImg, stopChs, slot_stop, ALT+Key_S);
    stopAct->setEnabled(false);
    tb->addSeparator();
    creatTA(this, tb, closeImg, exitFndwdg, SLOT(smClose()), CTRL+Key_X);
    tb->setStretchableWidget(sbar);

    MAU mau;
    numbRead(ORLRoot, sm_colOptId, &mau, 1, true);
    smColOpt=mau.buf;
    if(numbRead(ORLRoot, sm_datasId, &mau,1, false)>-1){
	int *ipt=(int *)mau.buf;
	__uid=ipt[0];		__gid=ipt[1];
	early_dt=ipt[2];	late_dt=ipt[3];
	}
    else { __uid=uId; __gid=gId; }
    timChkChs=_smwdg_+Int_tmChksChs;
    sizChkChs=_smwdg_+Int_szChksChs;

    tabs->addTab(optsTab,*pixmapLoad(genSetImg), QString::fromUtf8(findSetChs));
    _vList=(ListContent *)creatFileList(tabs, (void *)FindListChs, smColOpt, smUseCols, 2);
    memcpy(colsbak, smColOpt, colOptCnt*2);
    tabs->addTab(_vList, QString::fromUtf8(findResultChs));
    listSet=new QWidget(tabs, __listSet);
    tabs->addTab(listSet, *pixmapLoad(listSetImg), QString::fromUtf8(listSetChs));
    listSetInit(listSet, &optList, QRect(54, 26, optListLen, 270), &upBtn, &downBtn, smColOpt);
    orgStyleBtn=new QPushButton(QString::fromUtf8(orgStyle), listSet);

    sm_dtfmt=sm_dtfmtlst.lstIndex(sm_dtfmtCombIdx);
    dtfmtLab=new QLabel(QString::fromUtf8(dtfmtChs)+QDateTime::currentDateTime().toString(sm_dtfmt), listSet);
    dtfmtCombo=creatCombo( false, listSet, "smdtfmt", p_sm_dtfmtlst, -1 );   

    for(i=0; i<4; i++)
	group[i]=new QGroupBox( QString::fromUtf8( _smwdg_[13+i]), optsTab );
    for(i=0; i<chkCount; i++){
	_Chk[i]=new QCheckBox( QString::fromUtf8(_smwdg_[17+i]), i<10 ? group[ i<2 ? 0 : (i>3 ? 1 : 2 )] : listSet );
	if(i>6 && i<12){
		_Chk[i]->setChecked(_Params[i+18]);
		QToolTip::add( _Chk[i], QString::fromUtf8(_smwdg_[i+Int_BMTip-7]) );
		}
	}

    for(i=0; i<5; i++)
	_labs[i]=new QLabel( i>2 ? NULL : QString::fromUtf8(
	_smwdg_[ i==0 ? (sm_TDS  ? Int_findChs-1 : (sm_wholfile ? Int_findChs-2 : Int_findChs)) : Int_findChs+i ] ),
		i!=2 ? group[i!=4 ? 1:0] : listSet );
#define    kwfind   _labs[0]
#define    kwrepl   _labs[1]
#define    lmtSiz    _labs[2]
#define    codeLab2  _labs[3]
#define    codeLab1  _labs[4]
//    initFndwdg();

    grapCombo=creatCombo( false, listSet, "grapLmt", p_graplmtlst, -1 ); // create must late than lmtSiz
    static const char *slot_szBtns[]={ SLOT(Sz1()), SLOT(Sz2()),SLOT(Sz3()) },
	*slot_tmBtns[]={ SLOT(T1()),SLOT(T2()),SLOT(T3()) };
    pathCombo = creatCombo(true, pathGroup, "smpath", p_smpath, -1);
    pathCombo->setCurrentText( filesor->getDirNam() ? tranText(strCodec, filesor->getDirNam()) : (pathStr.isEmpty() ? pathCombo->currentText() : pathStr) );

    filterCombo = creatCombo(true, pathGroup, filterCombChs, p_smfilter, -1);

    if(sm_filterNull){
	filterNull=true;
	filterCombo->insertItem(*pixmapLoad(smfilterImg), 0);
	filterCombo->setCurrentItem(0);
	}
    else if( filterStr.isEmpty() ){
	if(filterNull=filterCombo->currentText().isEmpty())
		filterCombo->insertItem( *pixmapLoad(smfilterImg) );
	}
	else filterCombo->setCurrentText( filterStr );

    pathCodeCombo=new QComboBox( false, pathGroup, "pthCode" );

    connect(TDSChk, clickSig, this, SLOT(TDS()));
    kwfind->setPaletteForegroundColor(sm_TDS ? 0x000090 : (sm_wholfile ? 0x903020 : 0x000000));
    kwfind->setAlignment( int( QLabel::AlignCenter ) );
    keywordCombo = creatCombo( true, keywordGroup, "keyword", p_kwFindlst, -1 );
    keywordCombo->setCurrentText(kwFind.isEmpty() ? keywordCombo->currentText() : kwFind );
    kwrepl->setAlignment( int( QLabel::AlignCenter ) );
    replaceCombo = creatCombo( true, keywordGroup, replCombChs,  p_kwRepllst, -1);
    replaceCombo->setCurrentText(kwRepl.isEmpty() ? replaceCombo->currentText() : kwRepl );
    kwCaseChk->setChecked(sm_runCase);
    kwWordChk->setChecked(sm_wholeWord);
    connect(wholfileChk, clickSig, this, SLOT(wholfile()));
    bakupChk->setChecked(sm_bakup);
 
    const QPixmap *pix=pixmapLoad(codecImg);
    codeLab1->setPixmap(*pix);
    codeLab2->setPixmap(*pix);
    kwCodecCombo=new QComboBox(false, keywordGroup, "kwCode");
    QToolTip::add( kwCodecCombo, QString::fromUtf8(codeToFword) );
    codecComb(kwCodecCombo, kwCodec);
//____________________________________________________________________
    for(i=0; i<3; i++){
	chk[i]= new QCheckBox( QString::fromUtf8(sizChkChs[i]), fileGroup );
	connect(chk[i], clickSig, this, slot_szBtns[i]);
	}
    if(sm_szChk)chk[sm_szChk-1]->setChecked(true);

    fsizeCombo0 = creatCombo( true, fileGroup, "Small", p_fsize0lst, -1 );
    fsizeCombo0->setEnabled(sm_szChk>0&&sm_szChk<3);
    fsizeCombo1 =creatCombo( true, fileGroup, "Large", p_fsize1lst, -1);
    fsizeCombo1->setEnabled(sm_szChk>1);

    fuser->setChecked(sm_user);
    connect(fuser, clickSig, this, SLOT(fuser()));

    fgroup->setChecked(sm_group);
    connect(fgroup, clickSig, this, SLOT(fgroup()));

    userCombo = creatCombo( false, fileGroup, "usr", usrList , userImg);
    userCombo->setEnabled(sm_user);
    cn=usrList->count();
    for(i=0; i<cn&&usrIDs[i]!=__uid; i++);
    userCombo->setCurrentItem( cn-1-i );
    groupCombo = creatCombo( false, fileGroup, "group",  grpList, groupImg );
    groupCombo->setEnabled(sm_group);
    cn=grpList->count();
    for(i=0; i<cn&&groupIDs[i]!=__gid; i++);
    groupCombo->setCurrentItem(cn-1-i);
//____________________________________________________
    for(i=0; i<3; i++){
	tmChk[i]= new QCheckBox( QString::fromUtf8(timChkChs[i]), timeGroup );
	connect(tmChk[i], clickSig, this, slot_tmBtns[i]);
	}
    if(sm_tmChk)tmChk[sm_tmChk-1]->setChecked(true);
    QDateTime dt;
    dt.setTime_t(early_dt);
    earlyDateTime = new QDateTimeEdit( early_dt ? dt : QDateTime::currentDateTime(), timeGroup );
    earlyDateTime->setEnabled(sm_tmChk>0&&sm_tmChk<3);

    dt.setTime_t(late_dt);
    lateDateTime = new QDateTimeEdit( late_dt ? dt : QDateTime::currentDateTime(), timeGroup );
    lateDateTime->setEnabled(sm_tmChk>1);

    grapCombo->setEnabled(sm_grapShow);
    grapCombo->setCurrentItem(sm_grapSizIdx);
    grapSizLmt=atoi(grapCombo->currentText());
    setIcon(*pixmapLoad(diskfindImg));
//    setRightJustification(true); // 确保拉伸
    if(sm_isMax)showMaximized();
    else {
	show();// statLab->setScaledContents(true);
	if(wsz)move(wx, wy);
	}
 // sizeAdjust();
    setCaption( QString::fromUtf8( SearchModifyChs ) );
    connect(tabs, SIGNAL(currentChanged(QWidget *)), this, SLOT(chTab()));
    connect(orgStyleBtn, clickSig, this, SLOT(orgStyle()) );
    dtfmtCombo->setCurrentItem( (dtfmtCombo->count()-1) - sm_dtfmtCombIdx);
    connect(dtfmtCombo, sigactIdx, this, SLOT(smDtFmt()));

    grapShowChk->setChecked(sm_grapShow);
    connect(grapShowChk, SIGNAL(clicked()), this, SLOT(grapChk()) );

    connect(grapCombo, sigactIdx, this, SLOT(selSiz()));
    pathCombo->lineEdit()->selectAll();
    QToolTip::add( filterCombo, QString::fromUtf8(filterChs) );
    subChk->setChecked(sm_includeSub);
    pathCaseChk->setChecked(sm_pathCase);

    QToolTip::add( pathCodeCombo, QString::fromUtf8(codeToFnam) );
    codecComb(pathCodeCombo, pathCodec);

    SMpms=(struct findparams *)zalloc(sizeof(struct findparams));
    sizeAdjust();

//_____________________________________________________________
    cn=sbar->height();
    fntBPos=(cn*2+fntSz) / 4; // - fontHeight/4 "base line"
    pixBPos=(cn-22)/2;
    static const int	keys[13]={CTRL+Key_S, Key_F3, Key_F6, CTRL+Key_F4, CTRL+Key_G, CTRL+Key_I, Key_F4, 
		Key_Delete, Key_F8, CTRL+Key_Return, Key_F9, Key_F2, CTRL+Key_A	};
    static const char *__slots[13]={ slot_asSrc, slot_addSrc, slot_proedit, slot_dsum, slot_cp2dir, slot_mv2dir, 
	slot_attrib, slot_del, SLOT(vdel()), SLOT(orlZone()), SLOT(sImage()),
	slot_ren, slot_selall  };
    for(i=0; i<13; i++)popAct[i]=creatTA(this, NULL, i<11 ? selectImg+i : -1, _smwdg_[i], __slots[i], keys[i]);
    sortAcc(this, 9+1);
//    clearWState( WState_Polished );
    startTimer(180);
}

void SearchModify::adjustkwSiz()
{
    int b=fontMetrics().width(kwfind->text())+fntSz/2;
    kwfind->setGeometry( divFont(3), H0+_H, b, H0 );
    keywordCombo->setGeometry( divFont(2)+b, H0-comD/2+_H, panelLen-b-divFont(2)-fntSz*3/4, combH );
    kwrepl->setGeometry( divFont(3), H2, b, H0 );
    replaceCombo->setGeometry( b+divFont(2), H2-comD/2, panelLen-b-divFont(2)-fntSz*3/4, combH );
}

void SearchModify::sizeAdjust()
{
    QFontMetrics fmtr(font());
    const int combW=10*fntSz, _fixW=25*fntSz;
    int H3, i, j, ahd, b, h2, d, ahead, L, mvH, adj,
	div=divFont(2);
    int cs, ww, bn, bk, chksz;
    d=comD;	ahd=divFont(4)*3;
    combH=inputH;
    H0=fntSz+div;
    i=fntSz+div;
    h2=i+(combH+div)+(H0+div);
    mvH=(i+combH+div)+div+combH + H0+div +
	combH+div+ i+h2 + fntSz +
	h2+fntSz+h2;
    j=height() - sbar->height() - fntSz*3;
    if(mvH<j){
	_H=(j-mvH)/14;
	adj=_H ? _H : (j-mvH)/4;
	}
    else {
	_H=0;	adj=0;
	}
    mvH=H0+_H;
    H2=mvH+combH+div+_H;
    h2=H2+(H0+adj+div);
    ahead=fntSz*3/2;
    panelLen=width()-2*ahead;
    pathGroup->setGeometry( ahead, div+_H, panelLen, h2 );
    b=(panelLen-ahd-ahd-2)/4;
    pathCombo->setGeometry( ahd, mvH, b*3, combH );
    filterCombo->setGeometry( ahd+2 + b*3, mvH, panelLen-(ahd+2 + b*3)-ahd, combH );

    cs=fmtr.width(subChk->text())+22;
    ww=fmtr.width(pathCaseChk->text())+22;
    b=cs+ww;
    bn=panelLen - combW-ahd;
    if(bn>_fixW)L=combW;
    else {
	bn=_fixW;
	while( (L=panelLen-(bn-25+26)-ahd) < fntSz*2 && bn>b+1)bn-=2;
	}
    bk=(bn-b)/2;
    subChk->setGeometry(ahd, H2, cs, H0  );
    pathCaseChk->setGeometry(ahd+cs+bk, H2, ww, H0);

    pathCodeCombo->setGeometry(bn-25+24+2, H2-d/2, L, combH);
    codeLab1->setGeometry(bn-25, H2, 24, H0);

//____________________________________________________
    mvH+=h2;
    H3=H2+div+combH;
    j=H3+H0+div+_H;
    keywordGroup->setGeometry( ahead, mvH, panelLen, j+combH+div+adj  );
    adjustkwSiz();

    cs=fmtr.width(kwCaseChk->text())+22;
    ww=fmtr.width(kwWordChk->text())+22;
    bn=fmtr.width(binChk->text())+22;
    bk=fmtr.width(bakupChk->text())+20;
    L=cs+ww+bn+bk;
    b=(panelLen-L-ahd-ahd)/3;
    kwCaseChk->setGeometry( ahd, H3, cs, H0 );
    kwWordChk->setGeometry( ahd+cs+b, H3, ww, H0 );
    binChk->setGeometry( ahd+cs+b+ww+b, H3, bn, H0 );
    bakupChk->setGeometry( panelLen-bk-ahd, H3, bk, H0 );

    cs=fmtr.width(wholfileChk->text())+22;
    ww=fmtr.width(TDSChk->text())+22;
    b=cs+ww;
    bn=panelLen - combW-ahd;
    if(bn>_fixW)L=combW;
    else {
	bn=_fixW;
	while( (L=panelLen-(bn-25+26)-ahd) < fntSz*2 && bn>b+1)bn-=2;
	}
    bk=(bn-b)/2;
    wholfileChk->setGeometry(ahd, mvH+d/2, cs, H0  );
    TDSChk->setGeometry(ahd+cs+bk, mvH+d/2, ww, H0);

    kwCodecCombo->setGeometry(bn-25+24+2, mvH, L, combH);
    codeLab2->setGeometry(bn-25, mvH+d/2, 24, H0);
//______________________________________________________
    mvH+=j+combH+div+adj + fntSz;
    fileGroup->setGeometry( ahead, mvH, panelLen, h2 );
    L=fmtr.width(fuser->text())+22;
    fuser->setGeometry( ahd, H0+_H, L, H0 );
    userCombo->setGeometry( L+ahd+2, H0+_H-d/2, panelLen/2-L-ahd-6, combH );
    L=fmtr.width(fgroup->text())+22;
    fgroup->setGeometry( panelLen/2+4, H0+_H, L, H0 );
    groupCombo->setGeometry( panelLen/2+6+L, H0+_H-d/2, panelLen/2-6-L-ahd, combH );

    int chkLen[3];
    L=0; b=ahd;
    for(i=0; i<3; i++){
	chkLen[i]=fmtr.width(chk[i]->text())+22;
	L+=chkLen[i];
	}

    j=panelLen-L-ahd-ahd-4*4;
    for(i=0; i<3; i++){
	chk[i]->setGeometry( b, H2, chkLen[i], H0 );
	b+=j/2+chkLen[i]+4;
	}
    fsizeCombo0->setGeometry( ahd+chkLen[0]+4, H2-d/2, j/2, combH );
    fsizeCombo1->setGeometry( ahd+chkLen[0]+4+j/2+chkLen[1]+4, H2-d/2, j/2, combH );
//____________________________________________

    mvH+=h2+fntSz+_H;
    timeGroup->setGeometry( ahead, mvH, panelLen, h2  );
    i=(panelLen-fntSz-fntSz+2)/2;
    earlyDateTime->setGeometry( fntSz, H0+_H, i, combH-d/2 );
    lateDateTime->setGeometry( fntSz+i+2, H0+_H, i, combH-d/2 );
    int tmLen[3]; L=0;
    for(i=0; i<3; i++){
	tmLen[i]=fmtr.width(tmChk[i]->text())+22;
	L+=tmLen[i];
	}
    b=fntSz*2;
    j=panelLen-L-fntSz*4;
    for(i=0; i<3; i++){
	tmChk[i]->setGeometry( b, H2, tmLen[i], H0 );
	b+=j/2+tmLen[i];
	}
#define  hg  (3*fntSz/2)
    upBtn->setGeometry(/*scaleRect(*/LeftWide, 40+270, 3*fntSz, hg+8 );
    downBtn->setGeometry(/*scaleRect(*/LeftWide+3*fntSz+6, 40+270, 3*fntSz, hg+8 );
    b=optList->x()+optList->width()+fntSz*2;
    j=optList->y();
    orgStyleBtn->setGeometry(/*scaleRect(*/LeftWide+optListLen-6*fntSz, 40+270, 6*fntSz, hg+8);
    i=fntSz/2;
    L=fmtr.width(_Chk[10]->text())+i;
    _Chk[10]->setGeometry(b, j, L+20, combH);
    _Chk[11]->setGeometry(b+L+30, j, 20+fmtr.width(_Chk[11]->text())+2, combH);

    dtfmtLab->setGeometry(b, j+combH+fntSz-3, width()-b-fntSz, combH );
    dtfmtCombo->setGeometry(b, j+combH*2+(fntSz-3)*2, width()-b-2*fntSz, combH);

    grapShowChk->setGeometry(b, j+combH*3+(fntSz-3)*3-3, width()-b-fntSz, combH );
    L=fmtr.width(lmtSiz->text())+i; // QString::fromUtf8(sizLmt/*_smwdg_[ Int_findChs+2 ])*/ )
    lmtSiz->setGeometry(b, j+combH*4+(fntSz-3)*4-3, L, combH );
    grapCombo->setGeometry(b+L, j+combH*4+(fntSz-3)*4-3, width()-b-L-2*fntSz, combH );
}

/*
 *  Destroys the object and frees any allocated resources
 */
SearchModify::~SearchModify()
{
free((void *)_smwdg_[0]);
free((void *)_smwdg_);
free(SMpms);
if(sm_preCnt>0)free(sm_pms);
MAU mau;
int  ibu[4];
mau.buf=(char *)ibu;
ibu[0]=__uid;	ibu[1]=__gid;
ibu[2]=early_dt;	ibu[3]=late_dt;
mau.len=sizeof(int)*4;	mau.alen=0; //sizeof(int)*4;
numbWrite(ORLRoot, sm_datasId, &mau, 1);
if(pfdat && pfdat!=TDS)FreeTD(pfdat, true);
mau.buf=smColOpt;
mau.len=colOptCnt*2;
// mau.alen=0;
numbWrite(ORLRoot, sm_colOptId, &mau, 1);
sm_filterNull=filterNull;
sm_kwCodeComboIdx=kwCodec;
sm_pathCodeComboIdx=pathCodec;
if(smThread==-3)
	QApplication::postEvent( qApp, new QCloseEvent );
}

void SearchModify::codecComb(QComboBox *combo, int c)
{
    QTextCodec *code;
    int i;
    char buff[80];
    combo->insertItem("*");
    sprintf(buff, localSet, QTextCodec::codecForLocale()->name());
    combo->insertItem(QString::fromUtf8(buff));
    combo->insertItem(QString::fromUtf8(Union16));
    combo->insertItem(QString::fromUtf8(Union8));
    for(i=0; ( code=QTextCodec::codecForIndex(i) ); i++)
	combo->insertItem(code->name());
    combo->setCurrentItem(c+1);
}

QTextCodec *sm_PathCodec;

void SearchModify::logEnabled(const QString &str)
{
QApplication::beep();
smLog.append(str);
}

int SearchModify::smBackup(const char *fname, FastBlock *bakup)
{
static const char ext[]=".smb";
int rt=0, fnLen=strlen(fname);
char *pt, *fnbuf=(char *)malloc(fnLen+5);
strcpy(fnbuf,fname);
if(memstr(fname, fnLen+1, ext, 5, 3)==NULL)strcpy(fnbuf+fnLen, ext);
if(access(fnbuf, W_OK)==0)remove(fnbuf); // include to test
if(rename(fname, fnbuf))rt=-2;
else {
	pt=strrchr(fnbuf,'/');
	if(pt)pt++;
	else pt=fnbuf;
	bakup->add(pt);
	}
if(rt==-2)logEnabled(QString::fromUtf8(backupFail)+sm_PathCodec->toUnicode(fname));
free(fnbuf);
return rt;
}

void SearchModify::addList(const char *chs)
{
	shwCnt++;
	while(shwCnt - sm_cnt > veloc || waitMsg )__sleep(600); // usec
	struct sm_params *smpms=(struct sm_params *)zalloc(sizeof(struct sm_params)); // z => mdf=0;
	smpms->fnam=strdup(chs);
	appPost(Event_AddItem, smpms, this);
}

void SearchModify::doSM(const char *chs, struct stat64 &src_st, int Msg, const struct findparams *fndpm, FastBlock *bakup)
{
const char *ptr;
if(lmtStat(&src_st, fndpm)){
	if(sm_reset==false)return;
	else goto _ex_;
	}

if( (ptr=strrchr(chs, '/')) )ptr++;
else ptr=chs;
if(bakupChk->isChecked() &&
	(Msg==FIND_RE_PLACE||Msg==FIND_CUT) &&
	bakup->find(ptr)>-1 )return;
if(fndpm->filters&&namefilters(ptr, fndpm->filters, 1|(pathCaseChk->isChecked() ? 2:0) )==false){
	if(sm_reset==false)return;
	else goto _ex_;
	}
if(Msg!=FIND_NAME){
	int rt=-1;
	if(is_dev(src_st.st_mode))return;
	if(binChk->isChecked()||(smTag&4)){
		rt=SMfile(chs, &fndpm->kw_find, &fndpm->kw_repl,
			smTag|(Msg==FIND_RE_PLACE ? 8:0)|(Msg==FIND_CUT ? 16:0)|(kwCaseChk->isChecked() ? 2:0)|(kwWordChk->isChecked() ? 512 : 0)|(bakupChk->isChecked() ? 1:0)
			,bakup);
	}
	else {
		FILE *fp=fopen64(chs, "rb");
		if(fp){
		    long long sz=src_st.st_size;
		    QTextCodec *code=kwCodec>-1 ? _setCodec(kwCodec) : strCodec;
		    QString str, fnd;
		    char *pt=(char *)malloc(sz+2);
		    if(pt==NULL){
			logEnabled(tranText(strCodec,strerror(errno))+tranText(sm_PathCodec,chs));
			sbar->showMsg("Out of mem !");
			return;
			}
		    fread(pt, sz, 1, fp);
		    pt[sz]=0;
		    fclose(fp);
		    str=code->toUnicode(pt);
		    free(pt);
		    fnd=code->toUnicode(fndpm->kw_find.dat);
		    rt=0;
	_find_:	    rt=str.find(fnd, rt, kwCaseChk->isChecked());
		    if(rt>-1){
			if(kwWordChk->isChecked()){
				if(strchr(div_syb, ((const char *)str)[rt+strlen(fnd)])==NULL||
					(rt>0&&strchr(div_syb, ((const char *)str)[rt-1])==NULL)){
						rt++;	goto _find_;
					}
			}
			if(Msg==FIND_RE_PLACE||Msg==FIND_CUT){
				if(bakupChk->isChecked())smBackup(chs, bakup);
				FILE *wf=fopen(chs,"wb");
				if(wf){
				  str.replace(fnd, Msg==FIND_CUT ? "" : code->toUnicode(fndpm->kw_repl.dat));
				  QCString s(code->fromUnicode(str));
				  fwrite(s, s.length(),1,wf);
				  fclose(wf);
				}
				else rt=-2;
			}
		   }
	       } /* fp */
	}
	if(sm_reset)
		switch(rt){
		case -2 :
		case -3 : logEnabled(sm_PathCodec->toUnicode(chs)+QString::fromUtf8(_smwdg_[rt+4+Int_canotOpen]));
		case 1 : return;
//		default : /* -1, -4  */
		}
	else 
		switch(rt){
		case -1 : return;
		case -2 :
		case -3 : 
		case -4 : QApplication::beep(); 
			logEnabled(sm_PathCodec->toUnicode(chs)+QString::fromUtf8(_smwdg_[rt+4+Int_canotOpen]));
			if(rt==-4)return;
		}
}
if(Msg==FIND_RE_PLACE||Msg==FIND_CUT)chmod(chs, src_st.st_mode);
_ex_: addList(chs);
}

inline int SearchModify::SMfile(const char *fname, const VarStru *chkStru, const VarStru *repStru, int msg, FastBlock *bakup)
{/*
msg=> is -1 is return 1; (no scan). all bit no effect,
0 bit: back file(1), 1 bit: CS(2), 2 bit: use loaddata(4),
3 bit: replace(8),
4 bit: if 3 bit is 0,4 bit setbit, then del chs(16)
*/
static const char FWB[]="wb+", 
repltmp[]="repl_tmp.smd", repltmp2[]="repl2tmp.smd";
int memstr_Msg, result;
FILE *repf, *fptr, *swp;
long long fsz, fwtlen, /* must long, as wtlen=fpos in code */
 sCount; /* read(src) file size & count read dk */
unsigned int ctn, /* use to calc pfdat->toluse */
txtbufsz=0, oldbsz,/* alloc mem sz for buff */
realsz, /* mm len which read src (txtbuf len) */
rdlen,
mwtlen, /* don't take fwtlen as mwtlen is easy, as int use smart more than long */
wtDatlen,/* scan part of txtbuf len */
mem_off, bufpos, i, t,  Idx, // for holl-word
chklen, replen, rScanLen;
char *fcreat=NULL, *fcreat2=NULL, *flast,
*pAlloc=NULL, *txtbuf, *cmpRt;
const char *chk, *rep, *wtDat;
bool MultSch, readinto, ReplFind=false;/* init for readinto depend on */

memstr_Msg=1|(msg&2)|(msg&128); // 128 => ? Tong
if( (MultSch=(msg&SCAN_TDS)) ){
	ctn=0;	
	if(pfdat->toluse==0)return 1;
	}
else { 
	chk=chkStru->dat;	chklen=chkStru->len;
	if(chklen==0&&chk)chklen=strlen(chk);
	rep=repStru->dat;	replen=repStru->len;
	if((msg&8) && rep && replen==0)replen=strlen(rep);/* TDS & input have defence null */
	}

if(msg&(8|16)){
	fname=realpath(fname, NULL);
	if(sm_cnt>0){
		flast=(char *)malloc(2048);
		t=1;
		for(i=0; i<sm_cnt&&t; i++){
			realpath(sm_pms[i].fnam, flast);
			t=strcmp(flast, fname);
		}
		free(flast);
		if(t==0)return -1;
	}
}
if(bakup->find(fname)>-1)return 1;
if((fptr=fopen64(fname,"rb"))==NULL){
	result=-4;
	goto _ex_;
	}

result=-1;

#define reallmt 0x20000
chkstart:	mem_off=0;
fseek(fptr,0,2);
if((fsz=ftell(fptr))==0)
	goto breakloop;
/* fsz change every times, don't use filelenght */

if( (readinto=(ReplFind||fsz>txtbufsz)) )rewind(fptr);

if(MultSch){
	chk=pfdat->oDat[ctn]; rep=pfdat->nDat[ctn];
	chklen=pfdat->oLen[ctn];	replen=pfdat->nLen[ctn];
	}

fwtlen=0;	sCount=0;
rScanLen=chklen-1;
oldbsz=txtbufsz;
txtbufsz=fsz>reallmt? reallmt:fsz;
if(txtbufsz>oldbsz){
	if(pAlloc)free(pAlloc);
	pAlloc=(char *)malloc(txtbufsz+4);
	txtbuf=pAlloc+1; // for holl-word
}
pAlloc[0]='\n';
bufpos=0; ReplFind=false; /* init every time */

_begin_: Idx=0;	rdlen=txtbufsz-bufpos;
realsz=fsz > (sCount+rdlen) ? rdlen : fsz-sCount;
if(readinto)fread(txtbuf+bufpos+mem_off,realsz+1-mem_off,1,fptr);
mem_off=1; // for holl-word
sCount+=realsz;	realsz+=bufpos;
// txtbuf[realsz+2]=0;
_search_: cmpRt=memstr(txtbuf+Idx, realsz-Idx, chk, chklen, memstr_Msg);

if(cmpRt){
   if( (msg&512) &&
	(strchr(div_syb, cmpRt[chklen])==NULL||/*cmpRt!=txtbuf && */strchr(div_syb, cmpRt[-1])==NULL) ){
	Idx=cmpRt-txtbuf + 1;
	if(Idx>=realsz)goto _noFind_;
	goto _search_;
	}
  result=1;
  if(msg&24){ // (8|16)==24
	if(fcreat==NULL){ /* create repalce file */
		fcreat=fixpath(fname, repltmp);
		if((repf=fopen64(fcreat,FWB))==NULL){/* mem have chk, main is disk error */
			result=-3; // dir no write
			goto breakloop;
			}
		flast=fcreat;
		}	/* create file end */

     if(!ReplFind && sCount>realsz ){ /* skip have scaned blk(begin_file) to write current found */
	fwtlen=sCount-realsz; fseek(repf,fwtlen,0);
	}
/*  write (have read into mem)txtbuf to repf 	*/
	wtDat=txtbuf;	wtDatlen=realsz;
	_loop_: Idx=0;
	  mwtlen=cmpRt-wtDat;
	  if(mwtlen>0)fwrite(wtDat,mwtlen,1,repf);
	  if((msg&8)&&rep)fwrite(rep,replen,1,repf);/* replace */
	  if(wtDatlen<=mwtlen+chklen){
		pAlloc[0]='\n';
		bufpos=0;
		txtbuf[0]=txtbuf[realsz];
		goto skpwt;
		}
	  wtDat=cmpRt+chklen;
	  wtDatlen-=mwtlen+chklen;
	  _search2_: cmpRt=memstr(wtDat+Idx, wtDatlen-Idx, chk, chklen,memstr_Msg);
	  if( cmpRt ){ 
		if((msg&512)&&(strchr(div_syb, cmpRt[chklen])==NULL|| strchr(div_syb, cmpRt[-1])==NULL) ){
			Idx=cmpRt-wtDat + 1;
			if(Idx<wtDatlen)goto _search2_;
		}
		else goto _loop_;
	  }

	if(sCount<fsz){ /* this must rescan next loop */
		if(wtDatlen>rScanLen){
		  wtDatlen-=rScanLen;
		  bufpos=rScanLen;
		  fwrite(wtDat,wtDatlen,1,repf);
		  pAlloc[0]=txtbuf[realsz-bufpos-1];
		}
		else { bufpos=wtDatlen;	pAlloc[0]='\n';  }
//		memcpy(txtbuf,txtbuf+realsz-bufpos,bufpos+1); // word right-bind
		for(t=realsz-bufpos, i=0; i<bufpos+1; i++)txtbuf[i]=txtbuf[t+i];
		}
	else fwrite(wtDat,wtDatlen,1,repf);
  skpwt:  ReplFind=true;
  }/* modify */
  else goto breakloop;/* Only-find & found it */
}/* cmpRt!=null(find it) */
else { // last edit by xempo 2014-6-16
_noFind_:if(sCount<fsz)realsz-=rScanLen;
	if(ReplFind)fwrite(txtbuf,realsz,1,repf);
	if(sCount>=fsz)goto _out_;
	bufpos=rScanLen;
//	memcpy(pAlloc, txtbuf+realsz-1, chklen+1); // +1 is word right-bind
	for(t=realsz-1, i=0; i<chklen+1; i++)pAlloc[i]=txtbuf[t+i];
}/* as have mdf, so write data to it at once */

if(smThread>0 && sCount < fsz )goto _begin_;

_out_: if(ReplFind){
  if(MultSch)ftruncate(repf->_fileno, ftell(repf));/* every mdf must fix lenght */
  if(fwtlen){ /* write begin blk which no found */
	/*long fpos=ftell(repf); next write pos */
	rewind(fptr);        rewind(repf);
	while(fwtlen>0){
	  rdlen=fwtlen<(long long)txtbufsz ? fwtlen:txtbufsz;
	  fread(txtbuf,rdlen,1,fptr);
	  fwrite(txtbuf,rdlen,1,repf);
	  fwtlen -= rdlen;
		}
	/*fseek(repf,fpos,0);*/ /* rego next write pos */
     }
}

if(MultSch){
 if(++ctn<pfdat->toluse){
  if(ReplFind){/* here is modify-mode */
   if(fcreat2==NULL){
	fclose(fptr);	/*fflush(repf);*/
	fptr=repf;
	fcreat2=fixpath(fname, repltmp2);
	if((repf=fopen64(fcreat2,FWB))==NULL){/* mem have test, perhan is disk error */
	//	RunMsg=3; /* disable modify org-file */
		result=-3; // dir no write
		goto breakloop;
		}
	}
	else {	
		swp=fptr; fptr=repf; repf=swp;
		rewind(repf);
	}
	flast=flast==fcreat? fcreat2:fcreat;
  }/* found it */
  goto chkstart;
}
if(ReplFind==false && fcreat2 )flast= flast!=fcreat2? fcreat2:fcreat;
}

breakloop: fclose(fptr);

if(result==1&&(msg&24)){
/* file and its statue is deffer, and the fclose in follow. */
   if(repf){
	fclose(repf);
	if(msg&1)smBackup(fname, bakup);
	else remove(fname);
	if(rename(flast,fname))result=-2; // file no write
	if(fcreat2){
		remove(flast!=fcreat2? fcreat2:fcreat);/* remove other temp file */
		free(fcreat2);
		}
	}
	free(fcreat);
}/* result=1 */
if(pAlloc)free(pAlloc);
_ex_: if(msg&(8|16))free((void *)fname);
return result;
}

#define onlyFindName(pms) (pms->uId==-1&&pms->gId==-1 && pms->sizelmt0==-1 && pms->sizelmt1==-1&& pms->timelmt0==0 && pms->timelmt1==0)
#include <dirent.h>
int  SearchModify::acceDir(int Msg, const char *dirnam,   const struct findparams *pms)
{
 struct stat64  src_st;
 if(stat64(dirnam, &src_st)){
	if(firstLoop==false)posterrInfo(this, ErrorQ, dirnam, warnChs);
	return  none_File;
	}
 if( isReadable(uId, gId, &src_st)==false ){
	if(firstLoop==false)postInfoWidget(this, ErrorQ, dirnam, noRightOpera, warnChs );
	return no_Right;
	}
  int i, rt2=0, L, info;
  const char *fnam;
  struct dirent *dire;
  char *chs, *pth2;
  DIR *dir;
  FastBlock bakup;
  if( S_ISDIR(src_st.st_mode) ){
	if( !isExecable(uId, gId, &src_st) &&Msg!=FIND_NAME){
		if(firstLoop==false)postInfoWidget(this, ErrorQ, dirnam, dirNoExe, NULL );
		return dir_no_exe;
		}
	}
  else {
	doSM(dirnam, src_st, Msg, pms, &bakup);
	return 1;
	}
  firstLoop=true;

  pth2=(char *)malloc(6400);
  chs=pth2+3200;
  realpath(dirnam, chs);
  for(i=0; i<dns.count() ; i++){
	realpath(dns.lstIndex(i), pth2);
	if(strcmp(chs, pth2)==0){
		free(pth2);
		return 1;
		}
	}
  free(pth2);
  dns.add(dirnam);
  L=strlen(dirnam);
  chs=(char *)malloc(L+258);
  strcpy(chs, dirnam);
  if(chs[L-1]!=ROOT_CH)chs[L++]=ROOT_CH;
  dir=opendir(dirnam);
  while( smThread>0&&rt2!=opera_cancel && ( dire=readdir(dir))!=NULL ){ // && rt2!=cp_ignoreThrow && rt2!=opera_error
    fnam=dire->d_name;
    if( ! (fnam[0]=='.' && (fnam[1]==0 ||( fnam[1]=='.'&&fnam[2]==0))) ){
	strcpy(chs+L, fnam);
	info=stat64(chs, &src_st);
	if( info==0 && S_ISDIR(src_st.st_mode)){
		if(subChk->isChecked())rt2=acceDir(Msg, chs, pms);
		if((smTag&SCAN_TDS)==0 && pms->kw_find.dat==NULL && lmtStat(&src_st, pms)==false &&
			namefilters(fnam, pms->filters, 1|(pathCaseChk->isChecked() ? 2:0) ) )
			addList(chs);
	  }
	else if(info==0||(Msg==FIND_NAME && onlyFindName(pms)) )doSM(chs, src_st, Msg, pms, &bakup);
	}
  }
  free(chs);
  closedir(dir);
  return rt2; //!=opera_cancel ? (rt2<0 ? 128 : 0) : opera_cancel; 
}

void SearchModify::adjFindMode()
{
if(sm_cnt==0&&operaListTag==true){
	operaListTag=false;
	operaListAct->setOn(false);
}
}

void SearchModify::removeItem(LVItem *it, int idx)
{
	memmove( sm_pms+idx, sm_pms+idx+1, sizeof(struct sm_params)*(--sm_cnt - idx));
	_vList->takeItem(it);
	filesor->delLVItem(it);
	if(smThread!=1){
		setRunStatus();
		saveResultAct->setEnabled(sm_cnt);
		operaListAct->setEnabled(sm_cnt);
		adjFindMode();
	}
}

void *thrSearch(void *sm)
{
((SearchModify *)sm)->run();
return NULL;
}

void SearchModify::quitThread()
{
if(smThread>0)smThread=-1;
while(runSearch)
	__sleep(300);
__sleep(200); // safe
}

void SearchModify::run()
{
   runSearch=true;
   dns.resetMem(NULL);
   logRecorde(smLog, startChs);
   if(operaListTag){
	struct stat64 st;
	char *fn;
	int cn=operalst.memDiv(NULL), i, L;
	FastBlock bak;
	L=strlen(SMpms->pth);
	for(i=0; i<cn&&smThread>0; i++){
		fn=operalst.lstIndex(i);
		if(stat64(fn, &st)==0 && strstr(fn, SMpms->pth)==fn&&(fn[L]=='/'||fn[L-1]=='/'||fn[L]==0) )
			doSM(operalst.lstIndex(i), st, smCmd, SMpms, &bak);
	}
	operalst.resetMem(NULL);
	}
    else {
	firstLoop=false;
	acceDir(smCmd, SMpms->pth, SMpms);
	}
   logRecorde(smLog, endChs);
   if(smLogList.count()==0)
	appPost(Event_Error, NULL, this);
   smLogList+=smLog;
   smLog.clear();
   runSearch=false;
   if(smThread>-2) smThread=-4; // stop status
}

const char *SearchModify::getchs(const QString &str, int code)
{
return strdup(code>-1 ? __fromUnicode(str, code) : __from_unicode(str));
}

void SearchModify::getbdat(const QString &str, int code, VarStru *bdat)
{
bdat->dat=ReadFile((code>-1 ? __fromUnicode(str, code) : __from_unicode(str)),
	&bdat->len, False, this, &pathList);
}

void SearchModify::resetList(bool res)
{
int i, cn;
if(res){
	LVItem *it=(LVItem *)_vList->firstChild();
	while(it){
		operalst.add(it->fnam);
		it=(LVItem *)it->nextSibling();
	}
}
cn=_vList->columns(); // perhans change list-column in main-view
for(i=2; i<cn; i++)_vList->removeColumn(2);
creatFileList(this, _vList, smColOpt, smUseCols, 3);
}

void SearchModify::findStart(int sw)
{
quitThread();
if(sw==10){ // returnPressed in replaceComb
	startMsg=true; sw=1;
}
if(sw<8){
  kwRepl=replaceCombo->currentText();
  if(kwRepl.isEmpty()){
	if( sm_TDS==0 && sw==1 )sw=2;
	}
  else replaceCombo->comboAdd(kwRepl);
  kwFind=keywordCombo->currentText();
  if( kwFind.isEmpty() )sw=3; // only find name
  else keywordCombo->comboAdd(kwFind);
}
if((sw==1||sw==2) &&
	infoWidget(NULL, NULL, SearchModifyWarn+sw-1, this) )return;
if(operaListTag)resetList(true);
smTag=0;
if(SMpms->pth)free((void *)SMpms->pth);
if(SMpms->kw_find.dat)free((void *)SMpms->kw_find.dat);
if(SMpms->kw_repl.dat)free((void *)SMpms->kw_repl.dat);
if(SMpms->filters)free((void *)SMpms->filters);
memset(SMpms,0,sizeof(findparams));

pathCodec=pathCodeCombo->currentItem()-1;

pathStr=pathCombo->currentText();
if(pathStr.isEmpty()){
	pathCombo->setCurrentText(QString::fromLocal8Bit(filesor->getDirNam()));
	pathStr=pathCombo->currentText();
	}

SMpms->pth=(char *)getchs(pathStr, pathCodec);
pathCombo->comboAdd(pathStr);

filterStr=filterCombo->currentText();
if(filterStr.isEmpty()==false){
	SMpms->filters=(char *)getchs(filterStr, pathCodec);
	filterCombo->comboAdd(filterStr);
}

sm_PathCodec=curCodec(); // pathCodec>-1 ? _setCodec(pathCodec) : strCodec;

kwCodec=kwCodecCombo->currentItem()-1;

if(fsizeCombo0->isEnabled()&&fsizeCombo0->currentText().isEmpty()==false){
	SMpms->sizelmt0=atoll(fsizeCombo0->currentText());
	fsizeCombo0->comboAdd(fsizeCombo0->currentText());
	}
else SMpms->sizelmt0=-1;
if(fsizeCombo1->isEnabled()&&fsizeCombo1->currentText().isEmpty()==false){
	SMpms->sizelmt1=atoll(fsizeCombo1->currentText());
	fsizeCombo1->comboAdd(fsizeCombo1->currentText());
	}
else SMpms->sizelmt1=-1;
if(earlyDateTime->isEnabled())SMpms->timelmt0=earlyDateTime->dateTime().toTime_t();
else SMpms->timelmt0=0;
if(lateDateTime->isEnabled())SMpms->timelmt1=lateDateTime->dateTime().toTime_t();
else SMpms->timelmt1=0;
early_dt=SMpms->timelmt0;
late_dt=SMpms->timelmt1;
SMpms->uId=-1;
SMpms->gId=-1;
if( sm_user ){
	__uid = usrIDs[usrList->count()-1-userCombo->currentItem()];
	SMpms->uId=__uid;
	}
if( sm_group ){
	__gid=groupIDs[grpList->count()-1-groupCombo->currentItem()];
	SMpms->gId=__gid;
	}

if(sw<8){  // findStart(8) is save setting when exit
	if(sm_TDS){
	    char *pt;
	    pt=(char *)getchs(kwFind,/*kwCodec*/-1); // strdup(curCodec()->fromUnicode(keywordCombo->currentText()));
	    if(pt[0]=='*' && pt[1]==0){
		if(pfdat && pfdat!=TDS)FreeTD(pfdat,true);
		pfdat=TDS; /* from OpenRose.so */
		}
	    else {
		if(pfdat && pfdat!=TDS)FreeTD(pfdat, false);
		else pfdat=(TxtDat *)zalloc(sizeof(TxtDat));
		fmtInps(pt);
		CreatTD(pfdat, pt, 1, this, &pathList);
		}
	    free(pt);
	    if(pfdat==NULL || pfdat->toluse<1){
_abort_:		sbar->showMsg(abortSearch, 60, true, 0xb02018);
		return;
		}
	    smTag=SCAN_TDS;
	}
	else if(sm_wholfile){
		if(kwFind.isEmpty()==false){
			getbdat(kwFind, kwCodec, &SMpms->kw_find);
			if(SMpms->kw_find.dat==NULL)goto _abort_;
			}
		if(kwRepl.isEmpty()==false)getbdat(kwRepl, kwCodec, &SMpms->kw_repl);
		}
	else {
		if(kwFind.isEmpty()==false)SMpms->kw_find.dat=getchs(kwFind,kwCodec);
		if(kwRepl.isEmpty()==false)SMpms->kw_repl.dat=getchs(kwRepl,kwCodec);
		}
	shwCnt=0;
	sm_cnt=0;
	if(sm_preCnt>360){
		free(sm_pms);
		sm_preCnt=0;
	}
	_vList->clear();
	smCmd=sw+FIND_KEYWORD;
	findAct->setEnabled(false);
	replAct->setEnabled(false);
	searchCutAct->setEnabled(false);
	resetAct->setEnabled(false);
	operaListAct->setEnabled(false);
	stopAct->setEnabled(true);
	_vList->header()->setSortIndicator(-1, false);
	sortA=false;
	tms=2;
	sbar->showMsg(NULL,-1); // must clear
	tabs->showPage(_vList);
	smThread=1;
	veloc=_Chk[10]->isChecked() ? 2 : 1;
	doThread(_Chk[11]->isChecked() ? PTHREAD_STACK_MIN*68+PTHREAD_STACK_MIN*sizeof(void*) : PTHREAD_STACK_MIN*38+PTHREAD_STACK_MIN*sizeof(void*),
		_IdlePriority, thrSearch, this);
}
}

void SearchModify::setResult()
{
	char buf[200];
	sprintf(buf, smCmd!=FIND_RE_PLACE&&smCmd!=FIND_CUT ? foundChs : modifyChs, sm_cnt);
	sbar->showMsg(buf, 0, false, 0x232399);
	tms=-10;
}

void SearchModify::setRunStatus()
{
if(smThread==1){
	char buf[200];
	sprintf(buf, foundChs, sm_cnt);
	QString s(QString::fromUtf8(buf));
	tms=0;
	int Len=sbar->width(), ft=divFont(4);
	QPainter pn(sbar);
	pn.eraseRect(QRect(orgb, 0, orgw, sbar->height()));
	orgw=ft+26+fontMetrics().size(Qt::SingleLine, s).width();
	orgb=Len-orgw;
	if(++wheel_SM>2)wheel_SM=0;
	pn.drawPixmap(Len-ft-26, pixBPos, *freqPix[wheel_SM+ICO_SEARCH] );
	pn.drawText(orgb, fntBPos, s );
	}
else setResult();
}

bool SearchModify::event(QEvent *e)
{
int i, E;
switch( (E=e->type()) ){
case QEvent::Timer : 
	switch(smThread){
	case -2 :
	case -3 : if(runSearch==false)close();
	case -1 : // during quitThread
		break;
	case 0 : if(tms++>11&&runSearch==false){
			tms=0;
			smThread=2;
			appPost( virtual_notify, NULL, this);
			}
		break;
	case -4 : replAct->setEnabled(!sm_reset/* sm_reset && sm_cnt&&smCmd==FIND_KEYWORD*/);
		searchCutAct->setEnabled(!sm_reset/*&& sm_cnt&&smCmd==FIND_KEYWORD*/);
		saveResultAct->setEnabled(sm_cnt);
		operaListAct->setEnabled(sm_cnt);
		adjFindMode();
		findAct->setEnabled(true);
		replAct->setEnabled(true);
		searchCutAct->setEnabled(true);
		resetAct->setEnabled(true);
		stopAct->setEnabled(false);
		smThread=0;
		goto _statu_;
	case 1 :  if(tms++>0)_statu_: setRunStatus(); //statusLab->repaint();
	}
	return false;
case QEvent::Close : 
	if(cpEvent){ 
		if(smThread>0)smThread=-2;
		return false;
		}
	if(runSearch){
		if(smThread>0)smThread=-2; // perhan is -3
		else runSearch=false; // safe to exit for next close
		return false;
	}
	if(!(sm_isMax=isMaximized()))saveWdgFrame(this, ORLRoot, smSizeId);
	filesor->setSMW(NULL);
	findStart(8/* save pms */);
	saveListColWidth(_vList, SM_ColumnWidthsId);
	keywordCombo->comboTo(p_kwFindlst);
	replaceCombo->comboTo(p_kwRepllst);
	pathCombo->comboTo(p_smpath);
	filterCombo->comboTo(p_smfilter);
	fsizeCombo0->comboTo(p_fsize0lst );
	fsizeCombo1->comboTo(p_fsize1lst );
	for(i=18; i<30; i++)
		_Params[i]=_Chk[i-18]->isChecked();
	break;
case QEvent::KeyPress : 
	switch(((QKeyEvent *)e)->key()){
	case Key_Return :
		if(startMsg==false)findStart(0);
		else startMsg=false; // Press return in comboboxes
		break;
	case Key_F12 : filesor->showTop();
		break;
	case Key_F5 : /* recent() 40 */
		if(proEditList.count())proEditList.at(0)->showTop();
		break;
	case Key_Q : if( ((QKeyEvent *)e)->state()==ControlButton)smThread=-3;
	}
	break;
case QEvent::ShowMaximized :
case QEvent::ShowNormal : 
	if(_isMax==16){
		appPost(65201, this, parentWidget() );
		}
	_isMax=E!=QEvent::ShowMaximized ? 0 : 1;
//	return true;
	break;
case QEvent::Resize : if(SMpms)sizeAdjust();
}
return QMainWindow::event(e);
}

QMetaObject *SearchModify::metaObj=NULL;
static QMetaObjectCleanUp cleanUp_SearchModifyPan( search_modify, &SearchModify::staticMetaObject );

QMetaObject* SearchModify::staticMetaObject()
{
if(metaObj==NULL){
    static const QMetaData slot_tb[]={
	{"find()", &slot_0_0, QMetaData::Private },
	{"find2()", &slot_0_0, QMetaData::Private }, // replace
	{"smCut()", &slot_0_0, QMetaData::Private },
	{"vdel()", &slot_0_0, QMetaData::Private },
	{"hlp()", &slot_0_0, QMetaData::Private },
	{"addSrc()", &slot_0_0, QMetaData::Private },
	{"saveResult()", &slot_0_0, QMetaData::Private },
	{ "clearPElst()" , &slot_0_0, QMetaData::Private }, // 7
	{ "attrib()" , &slot_0_0, QMetaData::Private },
	{ "quitPrg()",&slot_0_0, QMetaData::Private },
	{"Sz1()", &slot_0_0, QMetaData::Private }, //10
	{"Sz2()", &slot_0_0, QMetaData::Private },
	{"Sz3()", &slot_0_0, QMetaData::Private },
	{"T1()", &slot_0_0, QMetaData::Private },
	{"T2()", &slot_0_0, QMetaData::Private },
	{"T3()", &slot_0_0, QMetaData::Private }, // 15
	{"smClose()", &slot_0_0, QMetaData::Private },
	{ "orgStyle()", &slot_0_0, QMetaData::Private },
	{"popFophonix()" ,&slot_0_0, QMetaData::Private },
	{ "PZpath()", &slot_0_0, QMetaData::Private },
	{"fuser()", &slot_0_0, QMetaData::Private }, 
	{"fgroup()", &slot_0_0, QMetaData::Private }, // 21

	{ "cp2dir()", &slot_0_0, QMetaData::Private }, // 22 - 24 don't change
	{ "selSiz()", &slot_0_0, QMetaData::Private },
	{ "mv2dir()", &slot_0_0, QMetaData::Private }, // 22 - 24 don't change
	{ "orlZone()" , &slot_0_0, QMetaData::Private },
	{ "wholfile()" , &slot_0_0, QMetaData::Private },
	{"TDS()", &slot_0_0, QMetaData::Private },
	{ "selall()" , &slot_0_0, QMetaData::Private },
	{ "del()" , &slot_0_0, QMetaData::Private },
	{"reset()", &slot_0_0, QMetaData::Private },// 30
	{"smLog()", &slot_0_0, QMetaData::Private },
	{ "asSrc()" , &slot_0_0, QMetaData::Private },
	{ "proEdit()", &slot_0_0, QMetaData::Private }, //33
	{ "Sort(int)", &slot_int, QMetaData::Private},
	{ "dbclick()", &slot_ptr, QMetaData::Private },// 35
	{ "enter()", &slot_ptr, QMetaData::Private },
	{ "open()" , &slot_0_0, QMetaData::Private },
	{ "opens(int)" , &slot_int, QMetaData::Private }, // 38

	{ "chSel()" , &slot_0_0, QMetaData::Private },
	{ "recent()",&slot_0_0, QMetaData::Private },
	{ "menuOpen(int)", &slot_int,  QMetaData::Private },
	{ "lCurCh(QListViewItem*)", &slot_ptr, QMetaData::Private },
	{ "grapChk()", &slot_0_0, QMetaData::Private },
	{"stop()", &slot_0_0, QMetaData::Private },
	{ "toggRen()" , &slot_0_0, QMetaData::Private },
	{ "doRen()" , &slot_ptr, QMetaData::Private },
	{"OL()", &slot_0_0, QMetaData::Private }, // 47
	{ "Up()" , &slot_0_0, QMetaData::Private },
	{ "Down()" , &slot_0_0, QMetaData::Private },
	{ "smDtFmt()", &slot_0_0, QMetaData::Private }, // 50
	{ "chTab()", &slot_ptr, QMetaData::Private },
	{ "sImage()" , &slot_0_0, QMetaData::Private },
	{ "dirsum()", &slot_0_0, QMetaData::Private },
	};
    metaObj = QMetaObject::new_metaobject(search_modify, QMainWindow::staticMetaObject(), slot_tb, 54,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_SearchModifyPan.setMetaObject( metaObj );
}
return metaObj;
}

QTextCodec *SearchModify::curCodec()
{
return 	(pathCodec>-1 ? _setCodec(pathCodec) : strCodec);
}

void SearchModify::chSelect()
{
fsels.resetMem(NULL);
_vList->selectedCollect(&fsels, sbar);  // flist selectedChange, can use currentItem() ?
}

void SearchModify::insertList(struct sm_params *pms, int M)
{
	if(sm_cnt>=sm_preCnt){
	  struct sm_params *tmp;
	  sm_preCnt+=32;
	  tmp=(struct sm_params *)malloc(sm_preCnt*sizeof(struct sm_params));
	  if(sm_cnt>0){
		memcpy(tmp, sm_pms, sm_cnt*sizeof(struct sm_params));
		free(sm_pms);
		}
	  sm_pms=tmp;
	}
	vInsertItem(_vList, pms->fnam, M,
		grapSizLmt, smUseCols, sm_dtfmt, sm_PathCodec, &pms->opt);
	sm_pms[sm_cnt++]=*pms;
}

void SearchModify::adjListView(bool res)
{
        int i, t;
        tms=-1000;
        getListOpts(optList, smColOpt+colOptCnt);
        if(memcmp(colsbak, smColOpt, 2*colOptCnt)||orgDtfmtIdx!=sm_dtfmtCombIdx||
	org_grapShow!=sm_grapShow||grapSizLmt!=org_SizLmt){
	resetList(res);
	memcpy(colsbak, smColOpt, 2*colOptCnt);
	if(res==false)goto _ex_;
	struct sm_params pms;
	t=operalst.memDiv(NULL);

	shwCnt=0;	sm_cnt=0;
	if(sm_preCnt>360){
		free(sm_pms);
		sm_preCnt=0;
		}
	QListViewItem *it=_vList->firstChild();
	for(i=0; i<t; i++){
		memset(&pms, 0, sizeof(struct sm_params));
		pms.fnam=strdup(operalst.lstIndex(i));
		pms.opt.item=it;
		insertList(&pms, ListSet_Chang  );
		it=it->nextSibling();
		}
	operalst.resetMem(NULL);
        }
_ex_:        tms=0;
}

void QWidget::paintEvent(QPaintEvent *e)
{
if(name() && strcmp(__listSet,name())==0)((SearchModify *)topLevelWidget())->grapDemo(false);
}

void SearchModify::grapDemo(bool erase)
{
	QPainter pn(listSet);
	QImage img;
	if(sm_grapShow)img=*pixmapLoad(search128Img); // : *filepix;
	int x=grapCombo->x()+fntSz,
		y=grapCombo->y()+fntSz*3;
	if(erase)pn.eraseRect(x, y, 128, 128);
	pn.drawPixmap( x, y, sm_grapShow ? img.smoothScale(grapSizLmt,grapSizLmt) : *freqPix[ICO_NORM] );
}

bool SearchModify::qt_invoke(int _id, QUObject *_uo)
{
int i, t, sw=_id-staticMetaObject()->slotOffset();
LVItem *it;
switch(sw){
case 2 :
case 1 :
case 0 :	if(tabs->currentPage()==listSet){
	    quitThread();
	    adjListView(listSetMsg);
	    listSetMsg=false;
	}
	findStart(sw); // 3 is search name only
	break;
case 42 :
case 39 : chSelect();
	break;
case 10 : // large
case 11 :
case 12 : if(sm_szChk!=sw-9){
		if(sm_szChk)chk[sm_szChk-1]->setChecked(false);
		fsizeCombo0->setEnabled(sw<12);
		fsizeCombo1->setEnabled(sw>10);
		sm_szChk=sw-9;
		}
	   else {
		sm_szChk=0;
		fsizeCombo0->setEnabled(false);
		fsizeCombo1->setEnabled(false);
		}
	break;
case 13 :
case 14 :
case 15 : if(sm_tmChk!=sw-12){
		if(sm_tmChk)tmChk[sm_tmChk-1]->setChecked(false);
		earlyDateTime->setEnabled(sw<15);
		lateDateTime->setEnabled(sw>13);
		sm_tmChk=sw-12;
		}
	   else {
		sm_tmChk=0;
		earlyDateTime->setEnabled(false);
		lateDateTime->setEnabled(false);
		}
	break;
case 18 : filesor->showTop();
	break;
case 20 : userCombo->setEnabled(!sm_user);
	goto _reset_;
case 21 : groupCombo->setEnabled(!sm_group);
	goto _reset_;
case 30 : // kw reset
	replAct->setEnabled(sm_reset);
	searchCutAct->setEnabled(sm_reset);
	resetAct->setOn(!sm_reset);
_reset_:	_Params[sw]=!_Params[sw];
	break;
case 27 : // txtdat
	if(sm_wholfile){
		wholfileChk->setChecked(false);
		sm_wholfile=False;
	}
	kwfind->setText(QString::fromUtf8( _smwdg_[sm_TDS ? Int_findChs : Int_TDScript]));
	kwfind->setPaletteForegroundColor(sm_TDS ?  0x000000 : 0x000090);
_adj_:	adjustkwSiz();
	goto _reset_;
case 26 : // wholfile
	if(sm_TDS){
		TDSChk->setChecked(false);
		sm_TDS=False;
	}
	kwfind->setText(QString::fromUtf8( _smwdg_[sm_wholfile ? Int_findChs : Int_wholfileLab]));
	kwfind->setPaletteForegroundColor(sm_wholfile ?  0x000000 : 0x903020);
	goto _adj_;
case 19 : {
	filesor->showTop();
	it=(LVItem *)_vList->curSelItem();
	char *pt, *ptxt=strdup(it->fnam);
	i=listViewIndex(_vList, it);
	if(S_ISDIR(sm_pms[i].opt.mode)==0){
		pt=strrchr(ptxt, '/');
		if(pt!=ptxt)*pt=0;
	}
	filesor->seekPath(ptxt);
	free(ptxt);
	break;
	}
case 7 :	menulst.resetMem(NULL);
	break;
case 8 : if( (it=(LVItem *)_vList->curSelItem()) ){// attrib
	const char *fn= it->fnam ;
	for(i=0; i<attWdgs.count(); i++)
		if(strcmp(fn, attWdgs.at(i)->pathnam())==0){
			attWdgs.at(i)->showTop();
			return true;
		}
	FileAttrib  *fRslt=(FileAttrib  *)zalloc(sizeof(FileAttrib));
	fRslt->inView=SM_View;
	t=stat64(fn, &fRslt->sb);
	fRslt->lostLnk=( t && access(fn, F_OK));
	fRslt->fn=(char *)fn;
	fRslt->isDir = t ? false : S_ISDIR(fRslt->sb.st_mode);
	fRslt->sels.copy(fsels);
	(new FileAtt(this, fRslt))->execu( 25, fRslt->isDir ? 29 : 27, 2);
	}
	break;
case 28 : _vList->selectAll(true);
	break;
case 3 :  // vdel
	if( smThread==2 )quitThread();
	LVItem *nx;
	it=(LVItem *)_vList->firstChild();
	while(it){
	    nx=(LVItem *)it->nextSibling();
	    if(it->isSelected()){
		waitMsg=true;
		--shwCnt;
		removeItem(it, listViewIndex(_vList, it));				// fsels.rem(i--);
		waitMsg=false;
		}
	    it=nx;
	}
	break;
case 29 : if(deleting==false){
	  deleting=true;
	  FastBlock dels(fsels);
	  int j, cn=dels.memDiv(NULL);
	  t=0;
	  if( smThread==2 )quitThread();
	  i=0;
	  while( i<cn ){
	      tms=0;
	      if( t!=AllDel && cfg_warnDel==false){
		t=infoWidget( dels.lstIndex(i), NULL, cn-i>1 ? delsInfo : delInfo, this);
		switch(t){
		case NoDel : continue;
		case CancelDel :
		case NO_BTN_ID : // click closeBox in title or Esc
			goto _ex_del_;
		}
	        }
	  _delFile(this, dels.lstIndex(i));
	  LVItem *it=(LVItem *)_vList->firstChild(), *nx;
	  for(j=0; j<sm_cnt; j++){
		nx=(LVItem *)it->nextSibling();
		if(strcmp(dels.lstIndex(i), sm_pms[j].fnam)==0){
			waitMsg=true;
			--shwCnt;
			removeItem(it, j--);
			waitMsg=false;
			goto _out_;
			}
		it=nx;
		}
	  _out_: i++;
	  }
	}
	_ex_del_: deleting=false;
		tms=20; // chSelect();
	break;
case 6 : {
	char *fsr=catstr(Fophonixcwd, "searchResult.txt",'/');
	FILE *fp=fopen(fsr, access(fsr, F_OK) ? "w":"a");
	if(fp){
/*	time_t tm;QDateTime dt;time(&tm);dt.setTime_t(tm);*/
	  QCString s(QDateTime::currentDateTime().toString(sm_dtfmt).utf8()+noEncode+__div);
	  fwrite(s, s.length(), 1, fp);
	  it=(LVItem *)_vList->firstChild();
	  while(it){
		fwrite(it->fnam, strlen(it->fnam), 1, fp);
		fwrite(__div, 1, 1, fp);
		it=(LVItem *)it->nextSibling();
		}
	  fwrite(__div, 1, 1, fp);
	  fclose(fp);
	}
	free(fsr);
	}
	break;
case 5 :
case 32 : filesor->selectAsSrc(fsels, sw!=32);
	break;
case 33 : fsels.memDiv(NULL);	i=0;
	while( i<fsels.count() )
		filesor->doProEdit(strdup(fsels.lstIndex(i++)), menuClickStat&Qt::ControlButton);
//	menuClickStat=0;
	break;
case 38 :
case 35 :
case 36 :
case 37 : filesor->execProg(sw, &fsels, _uo[1].payload.i);
	break;
case 34 : { // sort
	int  idx, Sort=_uo[1].payload.i;
	LVItem *it=(LVItem *)_vList->firstChild();
	if(Sort<0||Sort>=_vList->columns() || it==NULL)break;
	if(smThread==2)quitThread();
	struct sm_params tmp;
	char *pt1, *pt2;
	bool Case=(bool)pms_case;
	_vList->header()->setSortIndicator(Sort, sortA=!sortA);
	if(Sort>1)Sort=smUseCols[Sort-2]+1;
	for(i=0; i<sm_cnt; i++){
	  idx=i;	//opt=&sm_pms[idx].opt;
	  for( t=idx+1; t<sm_cnt; t++){
	    switch(Sort){
	    case 0 : if( (namcmp(strrchr(sm_pms[idx].fnam, '/')+1, strrchr(sm_pms[t].fnam, '/')+1, Case)>0) == sortA )idx=t;
		break;
	    case 1 : pt1=strrchr(sm_pms[idx].fnam, '/');
		*pt1=0;
		pt2=strrchr(sm_pms[t].fnam, '/');
		*pt2=0;
		if( (namcmp(sm_pms[idx].fnam, sm_pms[t].fnam,Case)>0) == sortA )idx=t;
		*pt1='/';	*pt2='/';
		break;
	    case 2 : if( (sm_pms[idx].opt.siz>sm_pms[t].opt.siz)== sortA)idx=t;
		break;
	    case 3 : if((sm_pms[idx].opt.mtm>sm_pms[t].opt.mtm)== sortA)idx=t;
		break;
	    case 4 : if((sm_pms[idx].opt.atm>sm_pms[t].opt.atm)== sortA)idx=t;
		break;
	    case 5 : if( (namcmp(sm_pms[idx].opt.uName, sm_pms[t].opt.uName, Case)>0) == sortA )idx=t;
		break;
	    case 6 : if( (namcmp(sm_pms[idx].opt.gName, sm_pms[t].opt.gName, Case)>0) == sortA )idx=t;
		break;
	    case 7 : if((sm_pms[idx].opt.mode>sm_pms[t].opt.mode)== sortA)idx=t;
		break;
	    case 8 : if( (namcmp(sm_pms[idx].opt.type, sm_pms[t].opt.type, Case)>0) == sortA )idx=t;
		}
	  }
	  if(idx!=i){
	    tmp=sm_pms[idx];
	    sm_pms[idx]=sm_pms[i];
	    sm_pms[i]=tmp;
	  }
	  vInsertItem(_vList, sm_pms[i].fnam, SM_Sort,
		grapSizLmt, smUseCols, sm_dtfmt, NULL, it);
	  it=(LVItem *)it->nextSibling();
	}
	}
	break;
case 41 : filesor->doProEdit(menulst.lstIndex(_uo[1].payload.i), menuClickStat&Qt::ControlButton);
//	menuClickStat=0;
	break;
case 44 :	// stopAct
	smThread=0;
	break;
case 9 : smThread=-3;  // { "quitPrg()",&slot_0_0, QMetaData::Private }
	break;
case 16 : // quitThread(); //
	if(runSearch==false)close();
	else smThread=-2;
	break;
case 31 : showLog(filesor, smLogList, findLogImg, smLogListChs);
	break;
case 40 : if(proEditList.count())proEditList.at(0)->showTop(); /* F5 */
	break;
case 45 : if(tabs->currentPageIndex()==1 && (it=_vList->curSelItem()) ){
	_vList->clearSelection();
	p_renam=strdup( it->fnam );
	_vList->setCurrentItem(it);
	it->startRename(0);
	}
	break;
case 46 : {
	LVItem *it=(LVItem *)_vList->currentItem();
	char *fn, *pt, *rn;
	struct stat64 st;
	fn=strdup(p_renam);
	pt=strrchr(fn, '/');
	*pt=0;
	rn=catstr( fn, strCodec->fromUnicode(it->text(0)) , '/');
	i=listViewIndex(_vList, it);
	sm_pms[i].mdf=true;
	if(strcmp(p_renam, rn)==0)free(rn);
	else if(isExist(rn, &st)==0){
		QApplication::beep();
		char *chs=catstr(rn, fnamExist,'\n');
		infoWidget(chs, warnChs, normError, this);
		free(chs);	goto _skp_;
	  }
	  else {
	     if(rename(p_renam, rn)){
		ErrorQuestion(this, normError, rn, renError );
	_skp_:	it->setText(0, pt+1);
		free(rn);
	    }
	    else {
		free(it->fnam);
		it->fnam=rn;
		sm_pms[i].fnam=rn;
	    }
	}
	sm_pms[i].mdf=false;
	free(fn);
	free((void *)p_renam);
	}
	break;
case 4 : ORLLink(this, 5, 2/* newWidget */);
	break;
case 47 : {
	LVItem *it=(LVItem *)_vList->firstChild();
	operaListTag=!operaListTag;
/*	findAct->setIconSet(*pixmapLoad(operaListTag ? listFindImg : findImg));
	replAct->setIconSet(*pixmapLoad(operaListTag ? listReplaceImg : searchModifyImg));
	searchCutAct->setIconSet(*pixmapLoad(operaListTag ? listCutImg : searchCutImg));*/
	while(it){
		it->setType(operaListTag ? OLO : 0);
		it->repaint();
		it=(LVItem *)it->nextSibling();
	}
	}
	break;
case 48 :
case 49 : moveListSet(optList, smColOpt, sw-48);
	break;
case 51 : if(listSet!=_uo[1].payload.ptr){
	    if(listSetMsg){
	        switch(smThread){
	        case 1 : waitMsg=true;
		break;
	        case 2 : quitThread();
	        }
	        adjListView(true);
	        waitMsg=false;
	        listSetMsg=false;
	   }
	}
	else {
		listSetMsg=true;
		orgDtfmtIdx=sm_dtfmtCombIdx;
		org_grapShow=sm_grapShow;
		org_SizLmt=grapSizLmt;
		}
	break;
case 50 : 
_skip2_:	sm_dtfmtCombIdx=(dtfmtCombo->count()-1)-dtfmtCombo->currentItem();
	sm_dtfmt=sm_dtfmtlst.lstIndex(sm_dtfmtCombIdx);
	dtfmtLab->setText(QString::fromUtf8(dtfmtChs)+QDateTime::currentDateTime().toString(sm_dtfmt));
	break;
case 43 : grapCombo->setEnabled( sm_grapShow=grapShowChk->isChecked() );
	goto _modulGraph_;
case 23 :
	sm_grapSizIdx=grapCombo->currentItem();
	grapSizLmt=atoi(grapCombo->currentText());
	_modulGraph_ :  grapDemo(true);
	break;
case 24 : //  don't change it easy
case 22 : if(selAsSrc.count()){
	    LVItem *it=(LVItem *)_vList->currentItem();
	    if(it && it->isSelected())
		new CopyThread(this, filesor, selAsSrc, it->fnam, sw-22+FCOPY);
	}
	break;
case 53 : {
	CopyThread dirsum(this, filesor, fsels, NULL, EXE_COUNT);
	}
	break;
case 25 : if( (it=((LVItem *)_vList->curSelItem())) )
		filesor->popORLcons(((LVItem *)_vList->currentItem())->fnam);
	break;
case 52 : if( (it=((LVItem *)_vList->curSelItem())) )
		(new SimpleImage(filesor))->exe(strdup(it->fnam));
	break;
case 17 : {
	static const char cols[]={ 1,2,3,4,5,6,7, 1,1,0,1,0,1,0 },
	*pval=cols+colOptCnt;
	LVItem *it=(LVItem *)optList->firstChild();
	memcpy(smColOpt, cols, 2*colOptCnt);
	for(i=0; i<colOptCnt; i++){
		it->setType(pval[i] ? 0x207020<<8 : 0);
		it->setText(0, QString::fromUtf8(colName[ cols[i]-1] ) );
		it->setText(1, pval[i] ? "Yes" : "No");
		it=(LVItem *)it->nextSibling();
	}
	dtfmtCombo->setCurrentItem( (dtfmtCombo->count()-1) - 0);
	sm_grapShow=true;
	sm_grapSizIdx=3;	grapSizLmt=64;
	grapCombo->setCurrentItem(3);
	listSetMsg=true;
	grapDemo(true);
	goto _skip2_;
	}
	break;
default : return QMainWindow::qt_invoke(_id, _uo);
}
return true;
}

#ifndef QT_NO_PROPERTIES
bool SearchModify::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES

void SearchModify::customEvent(QCustomEvent *e)
{
int sw;
switch(sw=e->type()){
case Event_Error : for(int i=0; i<filesors.count(); i++)
			filesors.at(i)->getSMW()->smLogListAct->setEnabled(true);
	return;
case Event_AddItem : {
	struct sm_params *pms=(struct sm_params *)e->data();
	while(waitMsg)__sleep(1000);
	insertList(pms, operaListTag ? LO_SM_Add : SM_Add);
	free(pms);
	if(smThread<1)setResult();
	}
	return;
case virtual_notify : {
	runSearch=true;
	LVItem *it=(LVItem *)_vList->firstChild(), *nx;
	int i, rt;
	bool lnk;
	struct stat64 st;
	for(i=0; i<sm_cnt&&smThread==2; i++){
	    nx=(LVItem *)it->nextSibling();
	    rt=lstat64(sm_pms[i].fnam, &st);
	    if(rt){ // lstat can read lostlink-file
		if(sm_pms[i].mdf==false)removeItem(it, i--);
	    }
	    else {
		lnk=S_ISLNK(st.st_mode);
		if(stat64(sm_pms[i].fnam, &st)==0){
		ListOptions *opt=&sm_pms[i].opt;
		  if( opt->isLnk!=lnk || (S_ISDIR(st.st_mode)==0&&opt->siz!=st.st_size) || opt->mtm!=st.st_mtime || opt->mode!=st.st_mode || opt->uId!=st.st_uid || opt->gId!=st.st_gid){
		    ListOptions optbuf;
		    optbuf.isLost=false;	optbuf.isNoRead=false;
		    setListOption(&optbuf, st, lnk, S_ISDIR(st.st_mode) ? subDirCount(sm_pms[i].fnam) : 0);
		    vInsertItem(_vList, sm_pms[i].fnam, SM_Notify,
			grapSizLmt, smUseCols, sm_dtfmt, &optbuf, it);
		    sm_pms[i].opt=optbuf;
		  }
		}
	    }
	    it=nx;
	}
	if(smThread==2)smThread=0;
	runSearch=false;
	return;
      }
case ErrorQ :
case CopyQuest : {
	struct infowdg_params *pms=(struct infowdg_params *)e->data();
	pms->ret=infoWidget(pms->dst, pms->cap, pms->info_id, CopyQuest && panelStatus==1 ? (QWidget *)cpThrPanel : this);
	pms->hold=false;
	}
	return;
case 65040 : _delFile(this, (const char *)e->data());
	free(e->data());
	break;
case 65119 :  cpThrPanel=new CopyPanel(sbar); // (NULL, NULL,WX11BypassWM);
	cpThrPanel->execu(this);
	break;
case 65109 : { // cp over ?
	del_params *delpms=(del_params *)e->data();
	delpms->ret=_delFile(this, delpms->fn);
	delpms->hold=false;
	}
	break;
case 65130 : {
	char *info=copyInfo(copyMode, copyResult, cpSzM, copySize, take);
	sbar->showMsg(info, 99);
	free(info);
	}
}
cpEvent=false;
}

