/*
	write & edit by LinJiangHua(xempo) 10-2014
	Free undef LGPL
*/

#include "copypanel.h"
#include "statuspanel.h"

const char copyPanel[]="CopyPanel";

QListView *cpListView;
int panelStatus, // 0 no panel, 1 normal-panel, 2 inTimer, 3 init
	copyThreadCount;

//____________copy______________
int copyResult, copyMode, copiedTimes;
unsigned long copySize, cpSzM;
time_t cp_tm, take;
bool stopCopyForExit;

CopyPanel::CopyPanel(StatusPanel *bar) :
	QWidget(NULL, copyPanel, /*WDestructiveClose|*/WType_TopLevel),
	sbar(bar), _H(fontHeight)
{
// panelStatus=2;
setFont(bar->font());
}

CopyPanel::~CopyPanel()
{
// panelStatus=0;
// cpThrPanel=NULL; 
}

void CopyPanel::execu(QWidget *wdg) // init panel
{
int i;
cpListView=new QListView(this);
stopCpBtn=new QPushButton(QString::fromUtf8(stopCp), this);
cpListView->setSorting(-1);
for(i=0; i<7; i++)cpListView->addColumn(QString::fromUtf8(cpListCols[i]));
QToolTip::add( stopCpBtn, QString::fromUtf8(stopCpTip) );
connect(stopCpBtn, clickSig, this, SLOT(killcp()) );
resize(wdg->width()-2*_H, _H*10);
move( wdg->x()+_H, wdg->y()+wdg->height()-_H*11 );
tms=5;
startTimer(120);
setIcon(*pixmapLoad(copyImg));
show();
setCaption(QString::fromUtf8(copyingChs));
panelStatus=1;
}

inline void CopyThread::inCpPanel()
{
if(isPop<2&&panelStatus==1){
	panelStatus=2;
	if(isPop==1)isPop=2;
	time_t tm, t1, T;
	char tmbuf[56], perbuf[32], sizbuf[32];
	int pers=tsz ? csz*100/tsz : 0;
	cpListView->setColumnText(3, mv2cp ? QString::fromUtf8(curCpProgress) : QString::fromUtf8(cpListCols[3]) );
	sprintf(perbuf, " %d%c ", pers, '%');
	sprintf(sizbuf, " %luM %lu ", szM, size);
	if(tsz&&csz){
		time(&tm);
		t1=tm - retm - th_take;
		T=t1*tsz/csz -t1;
	}
	else T=0;
	if(T>60)sprintf(tmbuf, takeChs, T/60, T%60);
	else sprintf(tmbuf, takeChs0,  T);

	if(it==NULL)it=new QListViewItem(cpListView, NULL);
	if(curdst){
		char *pt, *fn=strdup(curdst);
		pt=strrchr(fn, '/');
		if(pt!=fn)*pt++=0;
		else *(++pt)=0;
		it->setText(0,tranText(codec, pt)+" ");
		it->setText(5, tranText(codec, fn));
		free(fn);

		it->setText(1, sizbuf);
		it->setText(2, tranText(codec, tmbuf));
		it->setText(3, perbuf);
		it->setText(4, QString::fromUtf8(cp_IsDir ? dirCp : fileCp));
		if(cursrc){
			fn=strdup(cursrc);
			pt=strrchr(fn,'/');
			if(pt!=fn)*pt++=0;
			else *(++pt)=0;
			it->setText(6, tranText(codec, fn));
			free(fn);
		}
	}
	else  {
		it->setText(0,QString::fromUtf8(cpWait));
		it->setText(3,QString::fromUtf8(counting));
	}
panelStatus=1;
}
}

bool CopyPanel::event( QEvent *e)
{
int i;
switch(e->type()){
case QEvent::Timer : if(++tms>4){
	tms=-9999;
	for(i=0; i<copy_thr.count(); i++)
		copy_thr.at(i)->inCpPanel();
	tms=0;
	}
	break;
case QEvent::Close : if(copyThreadCount>0)return false;
	break;
case QEvent::Resize : {
	cpListView->setGeometry(_H, _H, width()-2*_H, height() - 5*_H);
	stopCpBtn->setGeometry((width()-2*_H)/2-40, height()-_H*3, 60+2*_H, 2*_H);
	}
}
return QWidget::event(e);
}

QMetaObject *CopyPanel::metaObj = 0;
static QMetaObjectCleanUp cleanUp_CopyPanel( copyPanel, &CopyPanel::staticMetaObject );
QMetaObject* CopyPanel::staticMetaObject()
{
  if ( !metaObj ){
    static const QMetaData slot_tbl[] = {
	{ "killcp()" , &slot_0_0, QMetaData::Private }
    };
    metaObj = QMetaObject::new_metaobject(copyPanel, QWidget::staticMetaObject(), slot_tbl, 1,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_CopyPanel.setMetaObject( metaObj );
    }
  return metaObj;
}

#ifndef QT_NO_PROPERTIES
bool CopyPanel::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES

bool CopyPanel::qt_invoke( int _id, QUObject* _o )
{
int i, sw=_id - staticMetaObject()->slotOffset();
switch(sw){
case 0 : {
 	QListViewItem *itm, *it=cpListView->firstChild();
	while(it){
		itm=it->nextSibling();
		if(it->isSelected()){
			CopyThread *thr;
			for(i=0; (thr=copy_thr.at(i)); i++ ){
			  if(thr->cell()==it){ thr->setTag(-1); break; }
			}
		}
		it=itm;
		}
	}
	break;
default : return QWidget::qt_invoke(_id, _o);
}
return true;
}
