/*
    LinJiangHua(xempo) write in 2011
    Copyright LinJiangHua 2011
*/

#include <qapplication.h>
#include <qcursor.h>
#include "dirext.h"
#include "dirloop.h"
#include "jxswitch.h"
#include "shellcom.h"
#include "conspace.h"
#include "filesan.h"
#include "xfun.h"
#include "infowidget.h"
#include "treeview.h"
#include "searchmodify.h"
#include "stocks/stocks.h"
#include "../rtdata/en/target/filesor.h"

#define  ListViewCount  7

const char treeViewChs[]="treeView", FileListChs[]="FileLst", OptListChs[]="OptLst", LnkTogListChs[]="LnkTogLst",
	stocksChs[]="stocksLst", ORLListChs[]="ORLLst", FindListChs[]="FindLst", 
	*listName[ListViewCount]={ treeViewChs, FileListChs, OptListChs, LnkTogListChs, ORLListChs, FindListChs, stocksChs };

const char showY[]="Yes", showN[]="No";

extern bool canBeDrop(QStrList &lst, const char *dst, bool isTree);

#define  RootColor  0x9b4510

QPixmap *drgpix;

void LVItem::fixColor()
{
if(uId==0){
  int id=((ListContent *)listView())->getId();
  if(id==T_TreeView || id==T_FileList ){
	type=RootColor<<8;
	return;
  }
}
type=0;
}

LVItem::LVItem(LVItem *p, LVItem *after, const char *txt, QTextCodec *codec) : 
	QListViewItem(p, after, tranText(codec,txt)), fnam(strdup(txt))
{
fixColor();
}

LVItem::LVItem(LVItem *p, const QString txt) : QListViewItem(p, txt),
	fnam(strdup(strCodec->fromUnicode(txt)))
{
fixColor();
}

LVItem::LVItem(QListView *v, LVItem *after, const char *txt, QTextCodec *codec, bool isdir) :
	QListViewItem(v, after, tranText(codec,txt)),
	fnam(strdup(txt)), _dir(isdir)
{
fixColor();
}

LVItem::LVItem(QListView *view, const QString txt) :
	QListViewItem(view, txt), fnam(strdup(strCodec->fromUnicode(txt)))
{
fixColor();
}

// above would be dir

LVItem::LVItem(QListView *view, LVItem *after, int T) : QListViewItem(view, after),
	type(T), fnam(NULL)
{
}

LVItem::LVItem(LVItem *p, LVItem *after) : type(0),
	QListViewItem(p, after), fnam(NULL)
{
}

void LVItem::paintCell( QPainter *p, const QColorGroup &cg,
				 int column, int width, int alignment )
{
    if ( type>0xff ){ // 24bit + 8bit(0xff)
	QColorGroup _cg( cg );
	_cg.setColor( QColorGroup::Text, type>>8 );
	QListViewItem::paintCell( p, _cg , column, width, alignment );
	}
    else QListViewItem::paintCell( p, cg , column, width, alignment );
}

LVItem::~LVItem()
{
if(fnam)free(fnam);
}

void LVItem::cancelRename(int col)
{
if(listView()->name()&&strcmp(listView()->name(), stocksChs)==0&&
	((FinaStocks *)listView()->topLevelWidget())->modified(this))return;
QListViewItem::cancelRename(col);
}

void LVItem::_setName(const char *nam)
{
if(fnam)free(fnam);
fnam=strdup(nam);
}

char *treeFullPath(LVItem *it, bool renMsg)
{
char *pth=strdup(renMsg ? __from_unicode(it->text(0)) : it->fnam),
	*tmp=pth;
while((it=(LVItem *)it->parent())){
	pth=catstr(it->fnam, pth, '/');
	free(tmp);
	tmp=pth;
	}
 return pth;
}

ListContent::ListContent(QWidget *wdg, const char *name, int id, Filesan *fs) : QListView(wdg, name),
	filesor(fs), Id(id),
	pressMouse(false),  itemCanDrop(true),
	tms(0), dropTim(0), lostId(0),
	diskItem(NULL),  startDrag(NULL)
//	stayItem(NULL), dropMeet(NULL) in every contentsDragEnterEvent 
{
setAcceptDrops( true );
viewport()->setAcceptDrops(true);
}

LVItem *ListContent::Index(int idx)
{
int i;
LVItem *item=(LVItem *)firstChild();
for(i=0; i<idx; i++)item=(LVItem *)item->nextSibling();
return item;
}

inline bool TreeView::testLost(/*LVItem *it*/)
{ 
bool rt= lostTag;
lostTag=false;
return rt;
}

inline void Filesan::PEAct()
{
bool B=Idsels.count() && _orllist->hasFocus(); /*modul==_OPENROSE && */
proEditAct->setEnabled(B);
selectDoneAct->setEnabled(B);
selectAddAct->setEnabled(B);
deleteAct->setEnabled( B );
}

char *ListContent::itemFullName(LVItem *item)
{
switch(Id){
case T_TreeView : return filesor->getModul()!=_FASTTAGS ? treeFullPath(item) : ((TreeView *)this)->tagFullPath(item);
case T_SearchList : return item->fnam;
}
return  filesor->itemFullPath(item);
}

void ListContent::contentsMousePressEvent( QMouseEvent* e )
{
 msgboxSignal=-1;
 QListView::contentsMousePressEvent(e);
// 此时会发生中断信号selectionChanged
 if(msgboxSignal==-1){
	int M=filesor->getModul();
	presspos = e->pos();
	QPoint point=contentsToViewport(presspos);
	LVItem *it = (LVItem *)itemAt( point ); 
	switch(Id){
	case T_SearchList : 
		if( e->button()==Qt::RightButton){
			((SearchModify *)topLevelWidget())->popRightMenu(it);
			break; // return;
			}
		else goto _jmp_;
	case T_OptList :	{
		LVItem *itm=(LVItem *)it;
		int r;
		if(it && point.x() > columnWidth(0)){
			r=strcmp(itm->text(1), showY);
			itm->setType(r ? 0x206020<<8 : 0);
			itm->setText(1, r ? showY : showN);
			}
		}
		break; // return;
	case T_ORLList :
		filesor->PEAct();
		filesor->stBar()->showMsg(NULL);
		goto _treeview_;
	case T_LnkTogList : // link-relate(pop-dialog)
	case T_StocksList :	// person
		break; // return;
	case T_FileList :
		setFocus();
		filesor->objsUpdate();
		filesor->imageInfo();
		goto _treeview_;
	case T_TreeView : if(((TreeView *)this)->testLost())return;
		if(it!=selectedItem())goto _treeview_;
		else if( (it=(LVItem *)selectedItem())!=NULL ){ // it(home), and mainlist = .xxx;  that dirNam != it(home)
			char *tmp;
			switch( M ){
			case _FASTTAGS : if(it==(LVItem *)firstChild()){
						if( e->button()==Qt::RightButton)filesor->getTagMenu()->exec(QCursor::pos());
						return;
						}
					tmp=((TreeView *)this)->tagFullPath(it);
					goto _jmp2_;
			case _PLACE : 
			case _OSROOT :
				tmp=treeFullPath(it);
			_jmp2_:	if(isHideDir(tmp)==NULL && strcmp(tmp, filesor->getDirNam()) ){
					((TreeView *)this)->setItemCurDir( it );
					if(M==_PLACE)((TreeView *)this)->selPart(it);
				}
				filesor->treeUpdateObjs(tmp);
				free(tmp);
			}
		}
_treeview_:	if( e->button()==Qt::RightButton){
			if(M==_OPENROSE&& Id!=1 )
				filesor->ORLrightmenu(it, Id ); // Id==0 or 5
			else filesor->popRightMenu(it, /*filesor->dirId()!=winId()*/ Id==1 );
		}
		else  _jmp_:if ( it )pressMouse = true; 
	} // switch
    }
}

void Filesan::showMountInfo(LVItem *it)
{
if(it && it->parent()==NULL){
  char txt[2000];
  FastBlock lst;
  lst.add(pdklst.lstIndex(listViewIndex((QListView *)treeview, it)), ",");
  int sz=atol(lst.lstIndex(4));
  if(sz>1024*1024){
	sprintf(txt, "%s => %s, Free: %.2f GB",
	lst.lstIndex(0), lst.lstIndex(lst.count()-1), ((float)sz)/(1024*1024) );
	}
  else {
	sprintf(txt, sz>1024 ? "%s => %s, Free: %u MB" : "%s => %s, Free: %u KB",
	lst.lstIndex(0), lst.lstIndex(lst.count()-1), sz>1024 ? sz/1024 : sz );
	}
  bPanel->showMsg(txt , 90, 1, 0x000090 );
}
}

void ListContent::contentsMouseMoveEvent( QMouseEvent* e ) // mouse move every time to active
{
    if ( msgboxSignal==-1 && pressMouse && ( presspos - e->pos() ).manhattanLength() > QApplication::startDragDistance() ) {
	LVItem *item = (LVItem *)itemAt( contentsToViewport(presspos) );
	pressMouse = false;
	msgboxSignal=0;
	itemCanDrop=true;
	if ( item ) {
	    if( isTagsRoot(item) )return;
	    QStrList slist;
	    switch( Id ){
	    case T_OptList :
	    case T_LnkTogList :
	    case T_StocksList : return;
	    case T_TreeView : {
		char *fnam=itemFullName(item),
		*ofn=catstr(Id==T_TreeView && filesor->getModul()==_OPENROSE ? torl : tfile, fnam, 0);
		free(fnam);
		slist.append(ofn);
		free(ofn);
		}
		break;
	    case T_SearchList : ((SearchModify *)topLevelWidget())->getFSels()->cvtQStrList(tfile, &slist);
			break;
	    case T_ORLList : {
			char *tmp=treeFullPath( (LVItem *)filesor->getTreeView()->currentItem() ),
				*pt; //=ORDpath(filesor->getTreeView()->getORD(), NULL, 0);
			const char *pdpth=catstr(torl, tmp, '/');
			free(tmp);
			int i, cn;
			FastBlock *blk=filesor->getIdSels();
			cn=blk->memDiv(NULL);
			for(i=0; i<cn ; i++){
				pt=catstr(pdpth, blk->lstIndex(i), '/');
				slist.append(pt);
				free(pt);
				}
			free((void *)pdpth);
			}
			break;
	    case T_FileList : filesor->getFSels()->cvtQStrList(tfile, &slist);
	    }
	    if(slist.count()>0){
		QUriDrag *ud= new QUriDrag( slist, viewport());
		startDrag=item;
		ud->setPixmap(*item->pixmap(0));
		ud->drag();
		if(Id==T_TreeView)filesor->setDragDel(true);
		itemCanDrop=true;
		startDrag=NULL;
// follow is : contentsDragEnterEvent, contentsDragMoveEvent, contentsDropEvent
// contentsDragLeaveEvent 是脱离原起动drag的（大）容器 (out)
		endTimer();
	    }
	}
   }
   else if(Id==T_TreeView&&filesor->getModul()==_PLACE){
	filesor->showMountInfo((LVItem *)itemAt( contentsToViewport(e->pos()) ));
	}
}

void ListContent::contentsMouseReleaseEvent( QMouseEvent *e )
{
    pressMouse = false;
    msgboxSignal=0;
    itemCanDrop=true;
}

void ListContent::contentsDragEnterEvent( QDragEnterEvent *e ) // 进入任一容器 (in)
{
QUrlDrag::decode(e, lstbuf); 
dropMeet=NULL;
stayItem=NULL;
}

void ListContent::contentsDragLeaveEvent( QDragLeaveEvent *e ) // 脱离任一容器 (out)
{
if(stayItem)stayItem->setPixmap(0, *drgpix);
endTimer();
lstbuf.clear();
}

bool ListContent::isTagsRoot(LVItem *it)
{
return Id==T_TreeView && filesor->getModul()==_FASTTAGS && it->parent()==NULL ;
}

void ListContent::contentsDragMoveEvent( QDragMoveEvent *e )
{
char *pt;
QPoint point=contentsToViewport( e->pos() );
LVItem *it =point.x()<columnWidth(0) ? (LVItem *)itemAt( point ) : NULL;
bool isORL=filesor->getModul()==_OPENROSE;
switch(Id){
case T_FileList : if(canBeDrop(lstbuf, filesor->getDirNam(), false))break;
case T_ORLList : goto _ign_;
case T_TreeView : if(isORL)isHome=-1;
case T_SearchList :
	if( it ){
		if(isTagsRoot(it)){
			dropMeet=it;	itemCanDrop=true;
			goto _jmp_;
		}
		pt=itemFullName(it);
		bool  b=canBeDrop(lstbuf, pt, true);
		if(Id!=T_SearchList)free(pt);
		if(b==false)goto _ign_;
    	}
}

if ( it  || Id==T_FileList ){
    if(dropMeet != it){
	dropMeet=it;
	tms=0;
	if(Id==T_TreeView && isORL){
		if(it){
			__ORD *dir=((TreeView *)this)->itemORD(it);
			itemCanDrop=(dir->mode&ORL_MW) && (dir->mode&ORL_OEM)==0;
			ORDclose(dir, 2);
		}
		goto _jmp_;
	}
	if(it){
		struct stat64 st;
		pt=itemFullName(it);
		if(stat64(pt, &st)){
			itemCanDrop=false;
			isHome=3;
			goto _ign_;
			}
		isHome=strcmp(pt, home)==0 ? 0 : 1;
		if(Id!=T_SearchList)free(pt);
		itemCanDrop=( S_ISDIR(st.st_mode) && (operaState(&st)&(mode_w|mode_x))==(mode_w|mode_x) );
		if( itemCanDrop==false && Id==T_FileList && e->action()==QDropEvent::Copy && S_ISDIR(st.st_mode)==false ){
			itemCanDrop=true;	isHome=2;
		}
	}
	else isHome=1;
	if(itemCanDrop==false)goto _ign_;
       }
       else {
	if( it==NULL && Id==T_FileList){
		itemCanDrop=((filesor->getCDM()&(mode_w|mode_x))==(mode_w|mode_x));
		}
	if(itemCanDrop==false)goto _ign_;
	}

_jmp_:	if(dropTim==0)dropTim=startTimer(80);
	if(dropMeet!=stayItem && stayItem){
		stayItem->setPixmap(0, *drgpix); 	stayItem=NULL;
	}
  e->acceptAction();
//  e->accept();
  }
else {
_ign_:	endTimer();
	if(stayItem)stayItem->setPixmap(0, *drgpix);
	stayItem=NULL;
	e->ignore();
	e->acceptAction(false);
  }
}

void ListContent::contentsDropEvent( QDropEvent *e )
{
    char *dst;
    LVItem *item = (LVItem *)itemAt( contentsToViewport(e->pos()) );
    endTimer();
    if(startDrag && item==startDrag){ // self
	if(stayItem)stayItem->setPixmap(0, *drgpix);
	goto _ex_;
	}
    if ( item ){
	int i, d;
	const char *fn;
	if(isTagsRoot(item)){
		struct stat64 st;
		// if(lstbuf.count()>0)
		for( i=0; i<lstbuf.count(); i++){
			fn=getDropFN(lstbuf.at(i), &d);
			if(stat64(fn, &st)==0 && S_ISDIR(st.st_mode))filesor->addTag( fn );
			else {
				char *msg=catstr(fn, notAsTag,32);
				filesor->stBar()->showMsg(msg, 50, 1, 0xa62018);
				free(msg);
				}
		}
		e->accept();
	}
	else if(item==stayItem ){
		if(Id==T_TreeView && isHome==-1){
			bool num=false, pd=false;
			QStrList lst;
			QUriDrag::decode( e, lst );
			__ORD *dir=((TreeView *)this)->itemORD(item);
			dst=treeFullPath(item);
			for( i=0; i<lst.count(); i++){
				fn=getDropFN( lst.at(i), &d );
				if(item->parent()==NULL)d|=32;
				switch(idCp((char *)fn, dst, d, dir, SPC)){
				case 0 : pd=true;
					break;
				case 1 : num=true;
				}
			}
			free(dst);
			if(dir->own_adr==((TreeView *)this)->getORD()->own_adr){
				if(num)NumBrowth(dir, _selORLNum);
				if(pd)((TreeView *)this)->freshItem(item, dir, 1);
			}
			ORDclose(dir, 2);
		} /*  Id=T_TreeView && _ORLlus*/
		else {
			dst=itemFullName(item);
		_doCp_:	procDrop(topLevelWidget(), filesor, e,  dst);
			if(dst!=filesor->getDirNam()&&Id!=T_SearchList)free(dst);
		         }
	}
	else goto _skip_;
	if(stayItem)stayItem->setPixmap(0, *drgpix);
    }
    else {
_skip_:	if( Id==T_FileList  && // stayItem==NULL &&
		(e->action()==QDropEvent::Copy||startDrag==NULL) /*not start-listview */ ){
		dst=filesor->getDirNam();
		goto _doCp_;
		}
	_ex_: e->ignore();
	}
}

void ListContent::endTimer()
{
if(dropTim)killTimer(dropTim);
dropTim=0;
tms=0;
// pressMouse = false; // popbox : noRight ...
}

bool ListContent::event( QEvent *e )
{
switch( e->type() ){
case QEvent::Timer :
	if(lostId){
		killTimer(lostId);
		lostId=0;
		((TreeView *)this)->treeRemove(NULL/* is sendItem */); // remove lost dir
		return true;
		}
	if(startDrag!=dropMeet && stayItem!=dropMeet && ++tms>6 ){
		bool tagRoot;
		if(stayItem)stayItem->setPixmap(0, *drgpix);
		stayItem=dropMeet;
		if(stayItem){
			if( (tagRoot=isTagsRoot(stayItem)) )goto _jmp3_;
			if( itemCanDrop && isHome<2 ){
	_jmp3_:			if(drgpix)*drgpix=*stayItem->pixmap(0);
				else drgpix=new QPixmap(*stayItem->pixmap(0));
				if(tagRoot){
				 	stayItem->setPixmap(0, *pixmapLoad(tagMvAddImg));
					filesor->stBar()->showMsg(willCreateTag, 50);
					}
				else stayItem->setPixmap(0, *pixmapLoad(isHome==0 ? homeOpenImg : (isHome==-1&&stayItem->parent()==NULL ? orlDropImg :
					(Id==0&&filesor->getModul()==_PLACE&&stayItem->parent()==NULL ? diskDragImg : dirOpenImg))) );
				}
			else stayItem=NULL;
		}
	}
	break;
case QEvent::KeyPress :
	if( /*strcmp(name(), OptListChs)==0 */ Id==T_OptList){
		QListViewItem *itm=currentItem();
		int k=((QKeyEvent *)e)->key();
		switch(k){
		case Key_Space : itm->setText(1, strcmp(itm->text(1), showY)? showY : showN);
			break;
		case Key_N :
		case Key_Y : char buf[2];
			buf[0]=k;	buf[1]=0;
			itm->setText(1, buf);
		}
		}
		break;
case QEvent::FocusIn :	switch(Id){
			case T_TreeView :
				char *tmp;
				LVItem *it;
				it=(LVItem *)currentItem();
				switch(filesor->getModul()){
				case _FASTTAGS : tmp=((TreeView *)this)->tagFullPath(it);
					goto _jmp_;
				case _PLACE : 
				case _OSROOT : tmp=treeFullPath(it);
				_jmp_:  if(tmp){
					filesor->treeUpdateObjs(tmp);
					free(tmp);
					}
				  else filesor->setObjsStat(0, false);
				}
				break;
			case T_FileList : filesor->objsUpdate();
				break;
			case T_ORLList : filesor->PEAct();//  because before IdSelects() , so pressmouse must call PEAct()
				
			}
}
return QListView::event(e);
}

void ListContent::selectedCollect(FastBlock *sels, StatusPanel *sbar)
{
  LVItem  *curIt;
  if( (curIt=(LVItem *)currentItem()) ){
  struct stat64 st;
  char *pt;
  int idx;
  sels->setIndex(0);
  LVItem *item=(LVItem *)firstChild();
   while( item ){
	if( isSelected(item) && item->fnam ){
	  pt = Id!=T_SearchList ? filesor->itemFullPath(item) : item->fnam;
	  switch( isExist(pt, &st) ){
//	  case none_File : goto _jmp_; //  item=(LVItem *)item->nextSibling();	if(!isSearch)free(pt);	  continue;
	  case lost_Link : if( curIt==item )showLink(sbar, lnkNone,pt, 0xe03b0a);
		break;
	  case symLink : if( curIt==item )showLink(sbar, linkAs, pt, 0x208020);
	  }
	  idx=sels->add(  pt );
	  if( curIt==item )sels->setIndex(idx);
	  if(Id!=T_SearchList)free(pt);
	}
	item=(LVItem *)item->nextSibling();
      }
  sels->memDiv(NULL);
  }
}

LVItem  * ListContent::curSelItem()
{
LVItem *selIt=NULL, *curIt;
if( (curIt=(LVItem *)currentItem()) ){
   LVItem  *item=(LVItem *)firstChild();
   while( item ){
	if( isSelected(item) ){
		if(curIt==item)return item;
		selIt=item;
	}
	item=(LVItem *)item->nextSibling();
   }
}
return selIt ? selIt : curIt;
}
