/*
	Write by xempo 2015
	Free under LGPL
*/

FastBlock noUseDisk, unmount, devMap;

static const char divchs[]="\t ", *dfcmd="df -T";

#define	 disktype	4
static const char *dknam[disktype]={ "sd", "hd", "loop", "part"  }, devSyb[]="/dev/";

#define	 devtype	2
static const char tdev[devtype][5]={ "hda", "sda" }, *devnam[devtype]={"ide", "scsi" };

static bool sameDevName(const char *str, const char *nam)
{
const char *pt, *ptr=strstr(str, nam);
if(ptr){
	pt=ptr+strlen(nam);
	if( (*pt==32||*pt==9 || *pt==',' ||*pt==0) && // str must /dev/...
		strstr(str,devSyb)==str)return true;
}
return false;
}

bool isMount(const char *dnam)
{
char *mnt=useSysCmd(dfcmd);
if(mnt&&mnt!=SPC){
 const char *pt;
 int i;
 FastBlock fasttmp(mnt,"\n");
 for(i=1; i<fasttmp.count(); i++)
	if( (pt=strrchr(fasttmp.lstIndex(i), 32)) || (pt=strrchr(fasttmp.lstIndex(i), 9)) ){
		if( strcmp(pt+1, dnam)==0 )return true;
	}
}
return false;
}

void getMount(FastBlock  *lst, FastBlock &part)
{
char *mnt=useSysCmd(dfcmd);
if(mnt&&mnt!=SPC){
 int i, t, j, C, M;
 char *pt, *chs, tmp[12];
 FastBlock fasttmp(mnt,"\n"), *pDev;
 if( (chs=ReadFile("/proc/partitions", NULL, 0, NULL, NULL)) ){
   FastBlock tmplst(chs, "\n");
   devMap.resetMem(NULL);
   for(j=0; j<tmplst.count(); j++){
	for(t=0; t<disktype&&(pt=strstr(tmplst.lstIndex(j), dknam[t]))==NULL; t++);
	if(pt){
	   for(i=0;(pt[i] |32)!=32&&pt[i]!='\n';i++)tmp[i]=pt[i];
	   if(t>2){ /* dknam[t] is part */
		if(is_numb(tmp[i-1]))devMap.add(tmp);
		for(t=0; t<devtype && strstr(tmplst.lstIndex(j), devnam[t])==NULL; t++);
		strcpy(tmp, tdev[t]);
		pt+=4;
		for(i=0; is_numb(*pt); i++)tmp[3+i]=*pt++;
		i+=3;
		}
	  tmp[i]=0; 
	  if( is_numb(tmp[i-1]) )part.add(tmp);
	}
   }
 }

  pDev = (M=devMap.count()) ? &devMap : &part;
  C=pDev->count();
  lst->resetMem(NULL);	i=1;
  while( i<fasttmp.count() ){
	if(!(pt=fasttmp.lstIndex(i)) || *pt==0)goto _skp_;
	for(t=0; t<C; t++)
		if( sameDevName(pt, pDev->lstIndex(t)) )goto _get_; // is useful
	if(uId==0&&strstr(pt, devSyb)==pt){
		char buf[200];
		chs=strchrs(pt, divchs);
		if(chs)*chs=0;
		sprintf(buf, "umount %s",  pt);
		system(buf);
	}
	goto _skp_;
_get_: 	if((chs=strchrs(pt, divchs))==NULL)pt=catstr(pt, fasttmp.lstIndex(++i), 32);
	fmtinp(pt, NULL, divchs, ',');
	    if(M){
		int L=strlen(pt);
		char *P=strchr(pt, ',');
		j=strlen(P);
		strcpy(pt+sizeof(devSyb)-1, part.lstIndex(t));
		memmove(pt+strlen(pt),P,L-j+1);
		}
	    lst->add(pt);
	    if(chs==NULL)free(pt);
	    _skp_: i++;
  }
}//	free(mnt); don't lst->rem(i--) for strlen(pt)<3, because use org-memblock;
}

void doMount(FastBlock *lst)
{
 char *pt, *dir, *dev,*cmd, *mnt;
 int  i, t;
 FastBlock part;
 getMount(lst, part);
  i=0;
  while( i<part.count() ){
	pt=part.lstIndex(i);
	for(t=0; t<lst->count(); t++)
		if(sameDevName(lst->lstIndex(t),pt))goto _skp_;
	for(t=0; t<noUseDisk.count(); t++)
		if(sameDevName(noUseDisk.lstIndex(t), pt))goto _skp_;
	for(t=0; t<unmount.count(); t++)
		if(sameDevName(unmount.lstIndex(t), pt))goto _skp_;
	dir=catstr("/mnt", pt, '/');
	if(access(dir, F_OK))mkdir(dir, 0777);
	dev=catstr(devSyb, pt,0);
	mnt=catstr("mount -t auto", dev, 32);
	cmd=catstr(mnt, dir, 32);
	free(mnt);
	if( (pt=useSysCmd(cmd)) ){
		if(*pt)free(pt);
		noUseDisk.add(dev);
		remove(dir);
		}
	free(cmd); free(dev); free(dir);
	_skp_:  i++;
	}
}
#undef	disktype

