/*
	Write by xempo 12-2014
	Free under LGPL
*/

#include <qlistbox.h>
#include <qtextbrowser.h>
#include <qaction.h>
#include <qlineedit.h>
#include <qcombobox.h>
#include "infor.h"
#include "shellcom.h"
#include "write.h"
#include "jxswitch.h"
#include "conspace.h"
#include "dirloop.h"
#include "dirext.h"
#include "dlist.h"

#include "filesan.h"
#include "orlcon.h"
#include "orlattr.h"
#include "helpwdg.h"
#include "inputdlg.h"
#include "../rtdata/en/target/filesor.h"
#include "../rtdata/en/target/orlcon.h"
#include "OpenRose/objcom/comm.h"

#include "combo.cpp"


extern const char slot_find[], slot_find2[]; // searchmodify.h

const char ORLcons[]="ORLcons",
	slot_help[]=SLOT(help());

ORLcon *ORL_con;

ORLcon::ORLcon(QWidget *par) : QMainWindow(par, NULL, WType_TopLevel|WDestructiveClose),
	filesor((Filesan *)par), treeview(filesor->getTreeView()),
	enter(false), clib(NULL)
{
setFont(par->font());
resize(screenWidth*4/5, screenHeight*4/5);
_orlcon_=charsFromORL(10);
}

__ORL *testORL(__ORL *fsp)
{
if(fsp){
int i;
for(i=0; i<SPACELIMIT; i++)if(workspace[i]==fsp)return fsp;
}
return NULL;
}

__ORL *ORLcon::getCurLib()
{
if(clib)clib=testORL(clib);
return clib;
}

inline void Filesan::setLib(__ORL *fsp)
{ cORL=fsp; }

Filesan *actFilesor()
{
  int i;
  for(i=0;i<filesors.count();i++)
	if(filesors.at(i)==qApp->activeWindow() )return filesors.at(i);
  return NULL;
}

void writeCon(__ORD *dir, const char *txt)
{
ProEdit *pe=new ProEdit( ORL_con ?  (Filesan *)ORL_con->parentWidget() : actFilesor(), NULL, -1);
pe->setORD(dir);
pe->exec(PRO_ORL_WRITE, txt); // -3
}

void ORLcon::exe()
{
QToolBar *tbar=new QToolBar("tb", this, Qt::DockTop),
	*bbar=new QToolBar("bb", this, Qt::DockBottom);
bbar->setMovingEnabled(false);
tbar->setMovingEnabled(false);
brow=new QTextBrowser(this);
brow->setWrapPolicy(QTextEdit::AtWordOrDocumentBoundary);
// connect( brow, SIGNAL(linkClicked(const QString & link)), this, SLOT(recClicked()) );
setCentralWidget(brow);
creatTA(this, tbar, publicImg, orlPub, SLOT(CopyRight()), Key_F6);
creatTA(this, tbar, ORLspacImg, orlVer, SLOT(ver()), Key_F2);
tbar->addSeparator();
infoAct=creatTA(this, tbar, ORLinfoImg, infoChs, SLOT(info()), Key_F4);
closeCurAct=creatTA(this, tbar, closeImg, closeCur, SLOT(closeCur()), Key_F5);
sbar=new StatusPanel(tbar, sbar_OpenRose);
tbar->setStretchableWidget(sbar);
creatTA(this, tbar, faqImg, helpChs, slot_help, Key_F1);

creatTA(this, bbar, setPathImg, chPath, SLOT(pwd()), Key_F8);
input=creatCombo(true, bbar, orlInpChs, p_ORL_Inp, -1);
creatTA(this, bbar, searchImg, screenFind, slot_find, CTRL+Key_F);
creatTA(this, bbar, fastFindImg, screenFindNext, slot_find2, Key_F3);
bbar->setStretchableWidget(input);
setCaption("OpenRose console");
setIcon(*pixmapLoad(orlZoneImg));
show();
}

void menuPlusDo(void *lib)
{
menuPlus.add( ((__ORL *)lib)->fname );
}

void ORLcon::updateZone(__ORL *lib)
{
__ORL *tmp=getCurLib();
ORL_con=this;
if(lib)clib=lib;
filesor->setORLcons(this);
if(clib){
    if(clib!=tmp||enter==false){
	char  buf[1024];
	ORLinfo(clib, buf);
	strcat(buf,"<br/>");
	ORDinfo(clib->CurDir, buf+strlen(buf));
	strins(buf, "<table width=100%><tr><td bgcolor=#5CABFF>");
	strcat(buf, "</td></tr></table>");
	tableMsg=true;
	showInfo(buf, NULL);
	if(filesor->getModul()==_OPENROSE){
		treeview->setFsp(clib);
		treeview->setRecent(clib);
		treeview->createOpenRose(false);
	}
	}
}
//else showInfo("  .", NULL);
infoAct->setEnabled(clib);
closeCurAct->setEnabled(clib);
}

void ORLcon::fspCom()
{
strcpy(InpBuf, input->currentText().local8Bit());
if(InpBuf[0]){
	__ORL *fsp=getCurLib(), *tmp;
	__ORD *dir1=fsp ? fsp->CurDir : NULL;
	int j, L=strlen(InpBuf);
	bool space;
	char *pt, *pth;
#define  ORL_InpList			_List[20]
	if(ORL_InpList.add(InpBuf)>-1)
		input->load(p_ORL_Inp, -1);
	OverWrite=0;
	bakdscpt=0x7fff;
	showdata=showdata+(tableMsg ? "<font color=#005400><b>" : "<br /><font color=#105010><b>") + InpBuf+ "</b></font>";
	tmp=comRun(fsp, InpBuf, 0, NULL);
	switch(lock){
	case 1 :	lock=0;
	default :	showInfo(NULL,NULL);
//		break;
//	case 2 : break;
	}
	if( (space=(tmp!=fsp)) )
		updateZone(tmp);
	tableMsg=false;
	if(filesor->getModul()==_OPENROSE && bakdscpt>0x7ffd)
	  switch(CommNumb){
	  case ORL_cd : if(dir1!=clib->CurDir){
			// treeview->deelORD(clib->CurDir, ORL_cd);
			char *pth=ORDpath(clib->CurDir, NULL,0);
			treeview->setORD(clib->CurDir);
			(void)treeview->seekORD(clib, pth, ORL_cd);
			free(pth);
			}
			break;
	  case ORL_rescudir : /*if( isCurOpera )*/{
				treeview->selORD((LVItem *)treeview->currentItem(), treeview->getORD(), 2/*|128*/);
				goto _info_;
			}
		//	break;
	  case ORL_chmode : {
			LVItem *it=treeview->seekORD(clib, ORDnam, ORL_chmode);
			free(ORDnam);
			dir1=treeview->itemORD(it);
			treeview->freshItem(it, dir1, (loopMsg&LoopDirSub) ? 1 : 0 );
			ORDclose(dir1, 2);
			}
		break;
	  case ORL_creat :
	  case ORL_newspace :
	  case ORL_workspace :
	  case ORL_open : if(space)filesor->ORLsettime(6);
		break;
	  case ORL_rescue :
	  case ORL_rescues :
	  case ORL_arfile :
	  case ORL_write : 
	  case ORL_insert : 
	  case ORL_append :
	  case ORL_add :	NumBrowth(treeview->getORD(), _selORLNum);
			/*if(clib)*/goto _info_;
	  case ORL_ren :
	  case ORL_del :
	  case ORL_rmdir :
	  case ORL_mkdir :
	  case ORL_ardir :
	  case ORL_erase :
	  case ORL_rm :	pt=InpBuf+strlen(InpBuf)+1;
			if(isNumb(pt)){//  sure vlist-showing ...
				LVItem *it1=filesor->getItem(pt);
				if(CommNumb!=ORL_ren)delete it1;
				else {
					j=strlen(pt);
					pt[j]=32;	pt[j]=0;
					it1->_setName(pt);
					}
			}
			else {
				j=strlen(pt);
				if(pt+j<InpBuf+L)pt[j]='/';
				if(*pt!='/'){
					pth=ORDpath(clib->CurDir,NULL,0);
					pt=catstr(pth, pt, strlen(pth)>1 ?  '/' : 0);
					free(pth);
					}
				treeview->seekORD(clib, pt, CommNumb);
			}
			_info_: filesor->ORL_infor(clib->CurDir);
	}
	switch(CommNumb){
	case ORL_exit :
	case ORL_quit : 
		for(j=LASTSPACE; j>0; j--)if(workspace[j])ORLreleas(workspace[j], menuPlusDo);
		close();
		return;
	}
}
input->lineEdit()->selectAll();
}

bool ORLcon::event( QEvent *e )
{
int k, m, E;
switch( E=e->type() ){
case QEvent::KeyPress :
	k=((QKeyEvent *)e)->key();
	m=((QKeyEvent *)e)->state();
	switch(k){
	case Key_Q :
		if(m==ControlButton)QApplication::postEvent( qApp, new QCloseEvent );
		return true;
	}
	break;
case QEvent::WindowActivate :
	ORL_con=this;	orlX=this;
	break;
case QEvent::ShowMaximized :
case QEvent::ShowNormal : 
	if(_isMax==16){
		appPost(65201, this, parentWidget() );
		}
	_isMax=E!=QEvent::ShowMaximized ? 0 : 1;
	return true;
case QEvent::Close :
	filesor->setLib(getCurLib());
	filesor->setORLcons(NULL);
	ORL_con=NULL;
	free((void *)_orlcon_[0]);
	free(_orlcon_);
//	break;	
}
return QMainWindow::event(e);
}

void getMess(const char *buf)
{
if(ORL_con&&(ORL_con==qApp->activeWindow()||lock==-1)){
  if(buf==NULL)ORL_con->getBrowser()->clear();
  else if(buf[0]==0)ORL_con->getInput()->listBox()->clear();
     else ORL_con->showInfo(buf, NULL);
}
else {
  Filesan *pfs=actFilesor();
  if(pfs){
	pfs->stBar()->showMsg(buf, 99, 1, bakdscpt>0x7ffd ? 0x000099 : 0x600604);
	bakdscpt=0x7fff;
	return;
	}
  CHBinfo(-1, buf);
  }
}

int showMess(const char *txt)
{
if(txt==NULL){
  Filesan *pfs=actFilesor();
  if(pfs){
	char *pt=HBinfo(idxdscpt, 1);
	pfs->stBar()->showMsg(pt, 99, 1, 0x600604);
	free(pt);
	}
}
else if(ORL_con&&(ORL_con==qApp->activeWindow()||lock==-1))ORL_con->showInfo(txt, NULL);
     else getMess(txt);
return 0;
}

void outText(int x, int attrib, const char *buf)
{
#define  colorCnt   7
static const char fmt[]="<font color=#%06x>%s</font>";
static int color[colorCnt]={ 31, 32, 3, 7,14, 34, 33};
static int cvc[colorCnt]={0xa01212, 0x189020, 0xba7035, 0x008989, 0x307060, 0x284eff, 0xab9020};
int i;
char *txt;
for(i=0; i<colorCnt; i++)if(color[i]==attrib){
	attrib=cvc[i];
	break;
	}
txt=(char *)malloc(x+strlen(buf)+32);
for(i=0;i<x;i++)txt[i]=32;
sprintf(txt+i, fmt, attrib, buf);
if(ORL_con&&ORL_con==qApp->activeWindow()){
	getMess(txt);
	ORL_con->setEnter(false);
}
// else CHBinfo(-1, buf);
free(txt);

}

void ORLcon::addInfo(const char *txt)
{
if(txt){
	static const char enterChs[]="\n";
	int i, len, T=0;
	for(i=0; txt[i]==32 || txt[i]==9 || txt[i]=='\n'; i++ );
	if(txt[i]!='<' && strstr(txt, "<font")==NULL && strstr(txt,"<table")==NULL){
		char *dat;
		for(i=0; txt[i]; i++)if(txt[i]=='<')T++;
		if(T){
		  dat=(char *)malloc(i+T*3+2);
		  for(i=0, T=0; txt[i]; i++){
			if(txt[i]=='<'){
				dat[T++]='&';
				dat[T++]='l';
				dat[T++]='t';
				dat[T++]=';';
			}
			else dat[T++]=txt[i];
		  }
		  dat[T]=0;
		  txt=dat;
		}
	}
#define  SizLmt  10000
	len=showdata.length();
	if(len>SizLmt){
		i=showdata.find(enterChs, len-SizLmt);
		if(i<0)i=showdata.find("<br/>", len-SizLmt);
		showdata=showdata.right( len- i );
	}
	if(enter&&showdata.isEmpty()==false)showdata=showdata +  enterChs  + txt;
	else showdata+=txt;
	if(T)free((void *)txt);
	showdata.replace("\n\n", enterChs);
	showdata.replace("\n<table", "<br/><table"); // init-widget,  "<table ..." has some wrong
	showdata.replace("</table>\n", "</table>");
}
}

void ORLcon::showTop()
{
if(isMinimized()){
	if(_isMax)showMaximized();
	else showNormal();
	_isMax=16;
	}
else {
	raise(); setActiveWindow();
	}
}

void ORLcon::showInfo(const char *txt, const char *cap)
{
addInfo(cap);
addInfo(txt);
if(lock<1){
	if(this/*ORL_con*/!=qApp->activeWindow())showTop();
	setUpdatesEnabled(false);
	brow->setText(QString::fromUtf8(QString("<html><pre>") + showdata + "</pre></html>"));
	brow->moveCursor(QTextEdit::MoveEnd, false);
	setUpdatesEnabled(true);
}
enter=true;
}

QMetaObject *ORLcon::metaObj = 0;
static QMetaObjectCleanUp cleanUp_ORLcon( ORLcons, &ORLcon::staticMetaObject );

QMetaObject *ORLcon::staticMetaObject()
{
if( ! metaObj ){
 static const QMetaData btn_tbl[]={
	{ "help()" , &slot_0_0, QMetaData::Private },
	{ "ver()" , &slot_0_0, QMetaData::Private },
	{ "CopyRight()" , &slot_0_0, QMetaData::Private },
	{ "info()" , &slot_0_0, QMetaData::Private },
	{ "closeCur()" , &slot_0_0, QMetaData::Private },
	{ "closeAll()", &slot_0_0,  QMetaData::Private },
	{ "pwd()" , &slot_0_0, QMetaData::Private },
	{ "lnkopen()" ,&slot_0_0, QMetaData::Private },
	{"selAs()", &slot_0_0, QMetaData::Private },
	{ "quitPrg()",&slot_0_0, QMetaData::Private },
	{ "popAct(int)", &slot_int,  QMetaData::Private },
	{"find()", &slot_0_0, QMetaData::Private },
	{"find2()", &slot_0_0, QMetaData::Private }, // replace
	{"popFophonix()" ,&slot_0_0, QMetaData::Private }
	
	};
 metaObj= QMetaObject::new_metaobject(ORLcons, QMainWindow::staticMetaObject(), btn_tbl, 14,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
cleanUp_ORLcon.setMetaObject(metaObj);
}
return metaObj;
}

#ifndef QT_NO_PROPERTIES
bool ORLcon::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES

QString fspfnd;
bool ORLcon::qt_invoke(int _id, QUObject *_o)
{
int  sw=_id-staticMetaObject()->slotOffset();
static const char *coms[7]={"help", "ver", "copyright", "info", "close", "closeall", "pwd"};
switch(sw){
case 6 : if( chdir(filesor->getDirNam()) )break;
case 5 :
case 4 :	// for(j=LASTSPACE; j>0; j--)if(workspace[j])ORLdestroy(workspace[j], menuPlusDo);	break;
case 3 : // ORLdestroy(clib, menuPlusDo);	break;
case 2 :
case 1 :
case 0 : {
	__ORL *fsp;
	strcpy(InpBuf, coms[sw]);
	ORL_con=this;
//	if((sw==3 ||sw==4) && clib)showInfo(NULL, " .");
	fsp=getCurLib();
/*	if(fsp)ORDtest(fsp, fsp->CurDir);*/
	clib=comRun(fsp, InpBuf, 0, NULL);
	if(fsp!=clib)updateZone(clib);
	tableMsg=false;
	}
	break;
case 7 : //	lnk{ "open()" , &slot_0_0, QMetaData::Private } ......
	filesor->doProEdit( __from_unicode(brow->selectedText()), false);
	break;
case 8 : // 	{"selAs()", &slot_0_0, QMetaData::Private } ......
	selAsSrc.resetMem(strdup(brow->selectedText()), ";\n");
	filesor->setCopyStats(selAsSrc.bufferString('\n') );
	break;
case 9 : //	{ "closeAll()", &slot_0_0,  QMetaData::Private }
	QApplication::postEvent( qApp, new QCloseEvent );
	break;
case 10 : updateZone(workspace[_o[1].payload.i]);
	filesor->ORLsettime(6);
	break;
case 11 :
case 12 :
	if( sw==11 || fspfnd.length()<1 ){
	InputDlg fndwdg(this, 1, pms_fspConChks, searchImg);
	Msg=fndwdg.exe(fspfnd, brow->selectedText(), p_ORL_Find, NULL, NULL);
	if((Msg&7)!=0/* btn-index */)return false;
	pms_fspConChks=Msg;
	}
	if(brow->find( fspfnd, Msg&chkCase, Msg&chkWord, (Msg&chkBackward)==0)==false )
		infoWidget( fspfnd, NULL, infoNoFound, this );
	break;
case 13 : filesor->showTop();
	break;
default : return QMainWindow::qt_invoke(_id, _o);
}
return true;
}
