/*
	Write by LinJiangHua(xempo) 01-2015
	Free under LGPL
*/
#include <qtoolbutton.h>
#include "filesan.h"
#include "treeview.h"
#include "orlcon.h"
#include "xfun.h"
#include "conspace.h"
#include "dirloop.h"
#include "dirext.h"
#include "OpenRose/objcom/comm.h"
#include "../rtdata/en/target/filesor.h"

extern __ORL *testORL(__ORL *orl); // orlcon.cpp

const QPixmap *_OEMdir;

#define  OldTag  1

void removeLeft(LVItem *it)
{
LVItem *sit;
while(it){
	sit=(LVItem *)it->nextSibling();
	delete it;
	it=sit;
}
}

__ORL *TreeView::itemORLRoot(LVItem *it)
{
while(it->parent()!=NULL)
	it=(LVItem *)it->parent();
return workspace[it->getTypeOr()];
}

__ORD *TreeView::itemORD(LVItem *it)
{
// char *pth=ORDPath(it);
static const char _root[]="/";
char *pth=NULL, *tmp;
while(it->parent()){
	if(pth){
		pth=catstr(it->fnam, pth, '/');
		free(tmp);
		}
	else pth=strdup(it->fnam);
	tmp=pth;
	it=(LVItem *)it->parent();
	}
if(pth){
	pth=catstr(_root, pth, 0);
	free(tmp);
	}
//else return strdup(_root);

__ORD *dir=ORDopen((__ORD *)workspace[it->getTypeOr()], pth, DIR_READ);
if(pth)free(pth);
return dir;
}

__ORD *TreeView::testORD(LVItem * it)
{
orlLib=itemORLRoot(it);
if((__ORD *)orlLib==ORD)return ORD;
if(ORDtest(orlLib, ORD)){
/*	setCurDir(ORD); */
	orlLib->CurDir=ORD;
	return ORD;
}
treeLostDel( it );
return NULL;
}

inline void TreeView::chORD(LVItem *it)
{
__ORL *lib;
lib=itemORLRoot(it);
filesor->cORL=lib;
if(ORD && ORDtest(lib, ORD) )ORDclose(ORD, 2);
ORD=selORD(it, NULL, 1|2|64);
lib->CurDir=ORD;
if(filesor->orlZone)filesor->orlZone->setCurLib(lib);
}


void TreeView::freshItem(LVItem *it, __ORD *dir, int sub)
{
	bool B;
	if(sub){
		dir->lib->x_msg|=1;
		selORD(it, dir, 128|(it==selectedItem() ? 1|2|64 : 2));
		dir->lib->x_msg&=~1;
		if(sub==2)return;
	}
	B=(dir->mode&ORL_MW);
	it->setPixmap(0, *freqIco[B ? ICO_NORM+DIR_OFF : ICO_NOWRITE]);
	it->setRenameEnabled(0, B );
	it->setRenameEnabled(3, B );
}

LVItem *TreeView::seekORD(__ORL *fsp, const char *path, int msg)
{
int i;
char *dnam, *pt, *pCreat, tmp[strlen(path)+2];
LVItem *it;
for(i=0; i<SPACELIMIT&&workspace[i]!=fsp; i++);
it=(LVItem *)firstChild();
while(it && it->getTypeOr()!=i)it=(LVItem *)it->nextSibling();
// org=it;
strcpy(tmp, path);
pt=tmp;
switch(msg){
case ORL_mkdir : pCreat=strrchr(tmp, '/')+1;
	if(pCreat==tmp+1)goto _jmp_; // like :  /input
	break;
}
_start_ : dnam=pt+1;
while(*dnam=='/')dnam++;
if( pt=strchr(dnam, '/') )*pt=0;
if(*dnam==0) goto _jmp_;
for(it=(LVItem *)it->firstChild(); it; it=(LVItem *)it->nextSibling() ){
    if(strcmp(dnam, it->fnam)==0){
   _jmp_: switch(msg){
	case ORL_chmode :
	case ORL_cd :
		if(pt){
			selORD(it, NULL, 128|2);
			it->setOpen(true);
			goto _start_;
		}
		else {
			if(msg==ORL_cd){
			   if(it!=(LVItem *)currentItem()){
				skpslot=true;
				setSelected(it,true);
				}
		_vis_:	    ensureItemVisible(it);
			}
			else if(it==selectedItem())goto _vis_;
			}
		goto _end_;
	case ORL_del :
	case ORL_rmdir : if(pt)goto _start_;
		treeDel(it);
		goto _end_;
	case ORL_mkdir : if(pt){
			if(pCreat==pt+1){
			_jmp1_:	LVItem *itm=(LVItem *)it->firstChild();
				while(itm && itm->nextSibling())itm=(LVItem *)itm->nextSibling();
				itm=new LVItem(it, itm, pCreat);
				itm->setPixmap(0, *freqIco[ICO_NORM+DIR_OFF]);
				goto _end_;
			}
			goto _start_;
			}
	}
	}
}

/*---------- no seeked item :
switch(msg){
case ORL_del :
case ORL_rmdir : qWarning("rmdir fail");
	break;
case ORL_cd : qWarning("cd fail");
		break;
case ORL_mkdir : qWarning("no expand yet");
	break;
}
//---------- no seeked item ----------------
*/
_end_: return it;
}

void TreeView::createOpenRose(bool init)
{
int i;
__ORL *fsp;
const char *pt, *tmp;
LVItem *it, *after, *sit, *sel=(LVItem *)selectedItem();
filesor->ORLtm=0;
if(init){
	filesor->modul=_OPENROSE;
	ORD=NULL;
	clear();
	setRootIsDecorated(true);
}
fspSel=NULL;
it=(LVItem *)firstChild();
after=it;
if(_OEMdir==NULL)_OEMdir=new QPixmap(*pixmapLoad(OEMdirImg));
i=0;
recentORL=testORL(recentORL);
while( i<SPACELIMIT ){
	if(workspace[i]){
		fsp=workspace[i];
		tmp=fsp->fname;
		if(access(tmp, F_OK)){ // be delete ...
			fclose(fsp->fpt);
			free(fsp);
			workspace[i]=NULL;
			goto _skp_;
			}
		while(it){
			if(strcmp(it->fnam, tmp)==0){
				after=it;
				if(fsp==recentORL)fspSel=it;
				it=(LVItem *)it->nextSibling();
				goto _skp_;
				}
			sit=(LVItem *)it->nextSibling();
			delete it;
			it=sit;
		}
		pt=strrchr(tmp, '/');
		it=new LVItem(this, after, pt ? pt+1 : tmp);
		if(fsp==recentORL)fspSel=it;
		it->_setName(tmp);
		it->setPixmap(0,*pixmapLoad(fsp->openMode&OpenAlway? OpeningRoseImg : ORLspacImg));
		it->setTypeOr(i);
		selORD(it, (__ORD *)fsp, 2|128);
		sit=(LVItem *)it->nextSibling();
		after=sit ? sit : it;
		it=sit;
		}
	_skp_:	i++;
	}
removeLeft(after ? (LVItem *)after->nextSibling() : NULL);
if(init)filesor->treeDescendBtn->setOn(pms_treeDescend<0);
else {
    if(fspSel){
	recentORL=NULL;
	while(sel){
		if(sel==fspSel)return;
		sel=(LVItem *)sel->parent();
		}
	setSelected(fspSel, true);
	return;
    }
    if(selectedItem()==NULL)setSelected(currentItem(), true);
}
}

inline LVItem *TreeView::sortItem(LVItem *tk, int sort, const char *nam)
{
LVItem *itm, *T, *new_tk;
if(tk->firstChild()){
    bool exp=tk->isOpen();
    new_tk=new LVItem(this, tk, nam);
    new_tk->setPixmap(0, *tk->pixmap(0));
    while( (itm=(LVItem *)tk->firstChild())!=NULL ){
	T=itm;
	while( (itm=(LVItem *)itm->nextSibling() ) )
		if( (namcmp( T->fnam, itm->fnam, pms_case)>0)==(sort>0) )T=itm;
	new_tk->insertItem(T);
    }
    delete tk;
    new_tk->setOpen(exp);
    return new_tk;
}
return tk;
}

void TreeView::sortSub()
{
int t;
LVItem *it, *sit;
char *chs;
filesor->ORLtm=0;
it=(LVItem *)firstChild();
disconnect(this, sig_expand, this, slot_expand );
while(it){
	chs=strdup(it->fnam);
	t=it->getType();
	it=sortItem(it, -pms_treeDescend, strrchr(chs,'/')+1);
	free(it->fnam);
	it->fnam=chs;
	it->setType(t);
	it=(LVItem *)it->nextSibling();
}
connect(this, sig_expand, this, slot_expand );
}

int _selORLNum(__ORD *pdir, BYTE *unit)
{
int i, cnt=pdir->Num_FCUs_Block, unitlen=pdir->Num_FCU_Len;
Filesan *fs=(Filesan *)pdir->lib->xParent;
for(i=0; i<cnt; i++, unit+=unitlen)fs->addNumb(pdir, unit, false /* wait ...*/);
return 1;
}

int digei;
int _selORD(__ORD *pdir, __ORD *dir)
{
const QPixmap *pix;
LVItem  *sub, *sorg, *nx, *it=(LVItem *)pdir->pX;
sorg=(LVItem *)it->firstChild();
nx=sorg;
while(nx){
	if(strcmp(dir->name, nx->fnam/*text(0).local8Bit()*/)==0){
		sub=nx;	sub->setTypeOr(0);
		if(pdir->lib->x_msg&1)goto _skp1_;
		else goto _skp2_;
		}
	nx=(LVItem *)nx->nextSibling();
}

nx=NULL;
while(sorg){
	if((namcmp(sorg->fnam, dir->name, _pms_case)>0)==(_pms_treeDescend>0) )break;
	nx=sorg;
	sorg=(LVItem *)sorg->nextSibling();
	}
sub=new LVItem(it, nx, dir->name);
_skp1_: if(dir->mode&ORL_OEM)pix=_OEMdir;
else if((dir->mode&ORL_MW)==0)pix=freqIco[ICO_NOWRITE];
     else {
	pix=freqIco[ICO_NORM+DIR_OFF];
	sub->setRenameEnabled(0, true);
	}
sub->setPixmap(0, *pix);
_skp2_: dir->pX=sub;
if(++digei<2)
	ORDbrowth(dir, 2, NULL, _selORD);
digei--;
return 1;
}

__ORD *TreeView::selORD(LVItem *it, __ORD *pdir, int msg)
{
if(pdir==NULL)pdir=itemORD(it);
if(pdir){
	if(msg&64)filesor->ORL_infor(pdir);
	if(msg&1)filesor->_orllist->clear();
	pdir->lib->xParent=filesor;
	pdir->pX=it;
	digei=0;
	ORDbrowth(pdir, msg, _selORLNum, _selORD);
	LVItem *sit=(LVItem *)it->firstChild(), *tmp;
	while(sit){
		tmp=(LVItem *)sit->nextSibling();
		if(sit->getTypeOr()==OldTag)delete sit;
		else sit->setTypeOr(OldTag);
		sit=tmp;
	}
//	removeLeft(lvit ? (LVItem *)lvit->nextSibling() : NULL);
	if(msg&128)ORDclose(pdir, 2);
	return pdir;
}
statusBarMsg(filesor->bPanel, noneFile, it->fnam, 0x802020, 1|4);
treeLostDel(it);
return NULL;
}
