/*
	Write by xempo 9 2014
	Free under LGPL
*/

#include <qpainter.h>
#include <qpalette.h>
#include "stocks.h"
#include "ordir.h"
#include "orlcon.h"
#include "dirloop.h"
#include "../rtdata/en/target/stocks.h"
#include "../rtdata/en/target/filesor.h"

#include "inputdlg.h"
#include "stocks.h"

const char fspStocks[]="Stocks", finaStocks[]="FinaStocks";
static const char cashChs[]="Cash", divSyb[]="\\", value0[]="0.0";

QPtrList <FinaStocks> stocksList;

#define __Red  0xd91810


enum Field_pos { Field_achie=3, Field_recentprice=4, Field_buy=5, Field_sale=6,
	Field_stockscount=8,
	Field_count=12 };
enum type_val { type_achie=2, type_buy=3, type_sale=4, type_recentprice=5, price_count=6,
	sub_value=16, total_counts=32,
	type_cash=64, type_cashin=64, type_cashout=65
	};

FinaStocks::FinaStocks(QWidget *par) : QMainWindow(par, finaStocks, WDestructiveClose|WType_TopLevel),
	nodCnt(0), nodPre(0),
	tashCnt(0), tashPre(0),
	t_Money(0), t_exchangVal(0), t_stocksVal(0), surplusVal(0),
	mdf(false),	setCap(false),  subAdding(false),
	utf8code(_setCodec(sp_utf8))
{
    setFont(par->font());
}

void FinaStocks::showTop()
{
if(isMinimized()){
	if(_isMax)showMaximized();
	else showNormal();
	_isMax=16;
	}
else {
	raise(); setActiveWindow();
	}
}


int readNum(__ORD *dir, BYTE *unit)
{
return ((FinaStocks *)dir->pX)->readNumb(dir, unit);
}

inline int FinaStocks::readNumb(__ORD *dir, BYTE *unit)
{
    int i, cntdir=dir->Num_FCUs_Block, unitlen=dir->Num_FCU_Len,/* protect bit flow */
	N, j, mode, field, t, img, recPrice, tprice;
    MAU mau[StocksDAU]; // 0 is stocks(name, summ ...); 1 all kind of fields;     2-5 is field-sub : 
    LVItem *sit, *it;
    for(i=0; i<cntdir; i++,unit+=unitlen)if(*unit==1){
	readFCU(dir,unit, mau, StocksDAU);
	N=*(int *)(unit+FCU_NumPos);
	if(N==-1){
		char cap[1024];
		sprintf(cap, "%s [%s]", stockName, mau[0].buf);
		setCaption( QString::fromUtf8( cap ) );
		setCap=true;
		continue;
		}
	mode=unit[1];
	FastBlock namlst(mau->buf, divSyb);
	t=0;
	if(Cnt>0){
		while( t<Cnt&&N>fieldNodes[t].dyNum) t++;
		it=t<Cnt ? (t>0 ? fieldNodes[t-1].it : NULL) : fieldNodes[Cnt-1].it;
	}
	else it=NULL;

	it=new LVItem(vlist, it, namlst.lstIndex(0) , utf8code);
	for(j=1; j<namlst.count(); j++)it->setText(j, tranText(utf8code, namlst.lstIndex(j)));
	stockNum=0;
	moneyInOut=0;
	dyAchie=0.0;
	dyAchieCount=0;
	for(j=Cnt; j>t; j--)fieldNodes[j]=fieldNodes[j-1];
	fieldNodes[t].it=it;
	fieldNodes[t].num=N;
	fieldNodes[t].dyNum=N;

	it->setRenameEnabled(0,true);
	it->setRenameEnabled(1,true);
	it->setRenameEnabled(2,true);
	Cnt++;
	if(mau[1].len==4&&strcmp(mau[1].buf, cashChs)==0){ // is Cash
		tprice=getMoney(namlst.lstIndex(1));
		if(mau[2].len!=3){  // in
			t_Money += tprice;
			it->setType(type_cashin);
			it->setPixmap(0, *pixmapLoad(cashInImg));
		}
		else { // out
			t_Money -= tprice;
			it->setType(type_cashout);
			it->setPixmap(0, *pixmapLoad(cashOutImg));
		}
		free(mau[1].buf);	free(mau[2].buf);
		continue;
	}
	// if(mode&ORL_OEM)
	it->setType( mode&ORL_OEM ); // 8

	it->setPixmap(0, *pixmapLoad(stocksImg));
	FastBlock fieldVal(mau[1].buf,divSyb);
	sit=NULL;	t=0;
	for(field=0; field<Field_count; field++)
		switch(field){
		case 11 : img=surplusImg;
			goto _jmp_;
		case 10 : img=multipleImg;
			goto _jmp_;
		case 8 : img=stocknumImg;
			goto _jmp_;
		case 7 : img=cost2Img;
			goto _jmp_;
		case 9 : img=totalcostImg;
			goto _jmp_;		
		case 0 :
		case 1 :
		case 2 : img=assetImg+field;
		_jmp_: sit=new LVItem(it, sit, fieldVal.lstIndex(t++)/*fieldNames[field]*/, utf8code);//qWarning("field=%d, %d", field, t);
			sit->setPixmap(0, *pixmapLoad(img));
			if(field<7){
			_jmp2_:	sit->setText(1, QString::fromUtf8(fieldVal.lstIndex(t++)) );
				sit->setRenameEnabled(1, true);
				sit->setType(1);
			}
			else {
				sit->setType(price_count);
				priceCount(field, sit, recPrice);
			}
			break;
		default : sit=subFieldCreat(it, sit, fieldVal.lstIndex(t++), field, mau+field-1 );
			switch(field){
			case Field_achie :  if(fieldVal.count()>17)goto _jmp2_;
				break;
			case Field_recentprice :
				sit->setText(1, QString::fromUtf8(fieldVal.lstIndex(t)) );
				sit->setRenameEnabled(1, true);
				recPrice=getMoney(fieldVal.lstIndex(t++) );
				sit->setType( type_recentprice );
				sit->setRenameEnabled(2, true);
				sit->setText(2,QString::fromUtf8(fieldVal.lstIndex(t++)));
			}
		}
	tprice=recPrice*stockNum;
	t_stocksVal+= tprice;
	t_Money+=moneyInOut;
	surplusVal+=tprice + moneyInOut;
	}
    return Cnt;
}

extern const char slot_save[]; // proedit.cpp
bool FinaStocks::exe(const char *stockNam, const char **stocksCols, int img)
{
int i;
char *chs=catstr(fspStocks, stockNam, '/');
StocksDir=ORDopen(selfDir, chs, DIR_READ);
free(chs);
if(StocksDir==NULL)return false;
stockName=stockNam;
stocksList.append(this);
    _stocks_=charsFromORL(8);
    resize(screenWidth*3/4,screenHeight*3/4);
    setIcon(*pixmapLoad(img));
    tb=new QToolBar("bottom", this, Qt::DockBottom);
    tb->setMovingEnabled(false);
    helpAct=addTA(this, tb, helpImg, helpChs, NULL, slot_help, Key_F1, false, false);
    tb->addSeparator();
    saveAct=addTA(this, tb, saveImg, saveChs, NULL, slot_save, CTRL+Key_W, false, false);
    saveAct->setEnabled(false);
    sbar=new StatusPanel(tb, sbar_Stocks);

    tb->addSeparator();
    upAct=addTA(this, tb, upBtnImg, upTo, NULL, slot_up, CTRL+Key_U, false, false);
    downAct=addTA(this, tb, downBtnImg, downTo, NULL, slot_down, CTRL+Key_D, false, false);
    tb->addSeparator();
    addAct=addTA(this, tb, itemAddImg, addChs, NULL, SLOT(add()), CTRL+Key_A, false, false);
    removeAct=addTA(this, tb, tagRemImg, removeChs, NULL, SLOT(rem()), Key_Delete, false, false);
    mdfAct=addTA(this, tb, genSetImg, mdfChs, NULL, SLOT(mdf()), Key_F2, false, false);
    tb->setStretchableWidget(sbar);

    vlist=new ListContent(this, stocksChs, T_StocksList, (Filesan *)parentWidget());
    vlist->setSorting(-1);
    vlist->setRootIsDecorated(true);
    setCentralWidget(vlist);
    connect(vlist, sig_chsel, this, slot_chsel);
    connect(vlist, sig_doRen, this, slot_doRen);
    connect(vlist, sig_enter, this, slot_vEnter);
    for(i=0; i < 3; i++)
	vlist->addColumn(QString::fromUtf8(stocksCols[i]) );

    sbar->showMsg(countChrs, 99, false);
//    free((void *)_person_[0]);    free((void *)_person_);
/*------------------------------------------*/

subAddAct=addTA(this, tb, subAddImg, subAddChs, NULL, SLOT(subadd()), CTRL+Key_S, false, false);
tb->addSeparator();
priceAct=addTA(this, tb, recpriceImg, updatePrice, NULL, SLOT(price()), Key_F11, false, false);
buyAct=addTA(this, tb, buyImg, buyAllChs, NULL, SLOT(buy()), Key_F12, false, false);
tb->addSeparator();
cashInAct=addTA(this, tb, cashInImg, cashInChs, NULL, SLOT(cashIn()), CTRL+Key_I, false, false);
cashOutAct=addTA(this, tb, cashOutImg, cashInChs, NULL, SLOT(cashOut()), CTRL+Key_O, false, false);

nodCnt=StocksDir->selfnumbs;	nodPre=nodCnt+6;
fieldNodes=(FieldNode *)zalloc(nodPre*sizeof(FieldNode));

StocksDir->pX=this;
Cnt=0;
NumBrowth(StocksDir, readNum);
nodCnt=Cnt;
creatCountField();
if(setCap==false)setCaption( QString::fromUtf8( stockNam ) );
show();
vlist->setSelected(vlist->firstChild(), true);
return true;
}

bool FinaStocks::fspSave()
{
   QListViewItem *it, *sit, *field;
   MAU mau[StocksDAU];
   int i, t, n;
   for(i=0; i<tashCnt; i++)
	NumDel(StocksDir,  tash[i].dyNum);
   if(tashCnt)free(tash);
   mdf=false;
   saveAct->setEnabled(false);
   for(i=nodCnt-1; i>-1; i--){
	if(fieldNodes[i].num!=-1&&fieldNodes[i].num!=fieldNodes[i].dyNum)
		NumRen(StocksDir, fieldNodes[i].num, fieldNodes[i].dyNum);
	if(fieldNodes[i].mdf){
	QCString s0, s1;
	memset(mau, 0, sizeof(mau)); // (sizeof(MAU)*StocksDAU);
	it=fieldNodes[i].it;
	s0=it->text(0).utf8()+divSyb + it->text(1).utf8()+divSyb + it->text(2).utf8();
	mau->buf=(char *)(const char *)s0;
	mau->len=s0.length();
	_mauAlen(mau, 60, 20);
	if( ((LVItem *)it)->getType()&type_cash ){
		mau[1].buf=(char *)cashChs;
		mau[2].buf=(char *)(((LVItem *)it)->getType()!=type_cashout ?  "in" : "out");
		numbWrite(StocksDir, fieldNodes[i].dyNum, mau, 3 ); // fieldNodes[i].dyNum<0 ? NumLast(StocksDir)
		continue;
		}
	n=2;	field=it->firstChild();
	for(t=0; t<Field_count; t++){
		switch(t){
		case Field_achie : 
		case Field_recentprice :
		case Field_buy : 
		case Field_sale :  {
			QCString S;
		 	sit=field->firstChild();
			while(sit){
				S+=sit->text(0).utf8()+divSyb+sit->text(1).utf8()+divSyb;
				switch(t){
				case Field_buy : 
				case Field_sale : S+= sit->text(2).utf8()+divSyb;
				}
				sit=sit->nextSibling();
			}
			mau[n].len=S.length();
			if(mau[n].len){
				mau[n].buf=strdup((const char *)S);	mau[n].len--;
				mau[n].alen=mau[n].len+20;
				}
			else mau[n].buf=NULL;
			n++;
			if(t==Field_achie)goto _jmp2_;
			if(t!=Field_recentprice)goto _jmp1_;
			else s1+=field->text(0).utf8()+ divSyb + field->text(1).utf8() + divSyb + field->text(2).utf8()+divSyb;
			}
			break;
		default : if(t<7)_jmp2_: s1+=field->text(0).utf8()+ divSyb + field->text(1).utf8() + divSyb;
			   else _jmp1_:	s1+=field->text(0).utf8()+ divSyb;
		}
		field=field->nextSibling();
	}

	mau[1].buf=(char *)(const char *)s1;	mau[1].len=s1.length()-1;
	mau[1].alen=mau[1].len+Field_count*StocksDAU;
	numbWrite(StocksDir, fieldNodes[i].dyNum, mau, StocksDAU); // fieldNodes[i].dyNum<0 ? NumLast(StocksDir)
	for(t=2; t<StocksDAU; t++)if(mau[t].len)free(mau[t].buf);
	}
    }
}

bool FinaStocks::event( QEvent *e )
{
int t=9, k, E;
switch( E=e->type() ){
case QEvent::Close :
  if(mdf && (t=infoWidget(NULL, utf8code->fromUnicode(caption()), stocksSave, this ))==0)
	fspSave();
  else if(t==2){
	sysCmdId=-1;
	return false;
	}
  free((void *)_stocks_[0]);
  free((void *)_stocks_);
  ORDclose(StocksDir, 2);
  if(nodCnt)free(fieldNodes);
  stocksList.remove(this);
	break;
case QEvent::ShowMaximized :
case QEvent::ShowNormal : 
	if(_isMax==16){
		appPost(65201, this, parentWidget() );
		}
	_isMax=E!=QEvent::ShowMaximized ? 0 : 1;
	return true;
case QEvent::KeyPress :
	k=((QKeyEvent *)e)->key();
	switch(k){
	case Key_F4 : 
	case Key_F3 : {
		LVItem *it=(LVItem *)vlist->currentItem();
		mdf_val=(k+1-Key_F3);
		t=it->getTypeOr(); // &127;
		if(t!=type_buy&&t!=type_sale){
		    if( k==Key_F3 )
			switch(t){
			case type_cashin :
			case type_cashout :
				money=getMoney(it->text(1));
				break;
			case type_buy|sub_value :
			case type_sale|sub_value : if(mdf_val<2)goto _cnt_;
			case type_recentprice : if(mdf_val==1)
				_cnt_:exchangCount( t!=type_recentprice ? (LVItem *)it->parent()->parent() : (LVItem *)it->parent() );
				// re-get stockNum, moneyInOut for toggle ...
			}
		    it->startRename( mdf_val );
		}
		}
		break;
	case Key_F5 :  if(stocksList.count()>1)stocksList.at(1)->showTop();
		break;
	case Key_Q : if(((QKeyEvent *)e)->state()==ControlButton)QApplication::postEvent(qApp, new QCloseEvent );
	}
	break;
case QEvent::WindowDeactivate :
case QEvent::WindowActivate : // first than WindowActivate //先失去焦点，后再另设焦点
	if(stocksList.count()>1 && stocksList.remove(this) )stocksList.prepend(this);
}
return QMainWindow::event(e);
}

int FinaStocks::getMoney(const char *txt)
{
int i=0;
if(txt&&*txt){
	char tmp[96], *ptr;
	strcpy(tmp, txt),
	ptr=strchr(tmp,'.');
	if(ptr)while( ptr[i]=ptr[i+1] )i++;
	else ptr=tmp+strlen(tmp);
	while(i<2)ptr[i++]='0';
	ptr[i]=0;
	return atoi(*tmp=='0' ? tmp+1 : tmp);
}
return 0;
}

LVItem *FinaStocks::subFieldCreat(LVItem *it, LVItem *sit, const char *chs, int field, MAU *mau)
{
int F, img, type, colsCnt=3, val1;
long long price;
const char *pt0, *pt1;
LVItem *ic=NULL;
FastBlock lst;
if(mau->buf){
	lst.getFromMau(mau);
	lst.memDiv(divSyb);
}
switch(field){
case Field_achie :	colsCnt=2;
	img=achieImg;	type=type_achie;
	break;
case Field_recentprice : colsCnt=2;
	img=recpriceImg;	type=type_recentprice;
	break;
case Field_buy : img=buyImg;	type=type_buy;
	break;
case Field_sale : img=saleImg;	type=type_sale;
}

sit=new LVItem(it, sit, chs, utf8code);
sit->setType(type);
sit->setPixmap(0, *pixmapLoad(img));
for(F=0; F<lst.count()/colsCnt; F++){
	pt0=lst.lstIndex(F*colsCnt);
	ic=new LVItem(sit, ic, pt0, utf8code);
	ic->setType(type|sub_value);
	ic->setText(1, pt1=lst.lstIndex(colsCnt*F+1));
	switch(field){
	case Field_buy : 
	case Field_sale : // img = field!=Field_buy ? saleImg : buyImg;
		ic->setText(2, lst.lstIndex(colsCnt*F+2));
		ic->setRenameEnabled(2,true);
		val1=atoi(pt1);
		stockNum+=field==Field_buy ? val1 : -val1;
		price=getMoney(pt0);
		price*=val1;
		t_exchangVal+= (field != Field_buy ? price : price*1003/1000 );
		moneyInOut+= (field != Field_buy ? price*996/1000 : -price*1003/1000 );
	case Field_recentprice :
		ic->setRenameEnabled(0,true);
		break;
	case Field_achie : sit->setRenameEnabled(1,true);
		if(*pt1&&*pt1!='/'){
			dyAchie=atof(pt1)*100;
			dyAchieCount++;
		}
	}
//	ic->setPixmap(0, *pixmapLoad(img));
	ic->setRenameEnabled(1,true);
	}
// if(type!=2)moneyInOut+=
return sit;
}

void FinaStocks::priceCount(int F, LVItem *sit, int recPrice)
{
  char buf[120];
  static const char fmt[]="%.2f";
  buf[0]=0;
  switch(F){
  case 7 : if(stockNum)sprintf(buf, "%.3f", (float)-moneyInOut/stockNum/100);
	break;
  case 8 :	sprintf(buf, "%lld", stockNum);
	break;
  case 9 : sprintf(buf, fmt, stockNum*recPrice/100);
	break;
  case 10 : if(dyAchie&&dyAchieCount)
		sprintf(buf, "%g", (float)recPrice*dyAchieCount/(dyAchie*4));
	break;
  case 11 : sprintf(buf, fmt, (float)(stockNum*recPrice+moneyInOut)/100);
	if(stockNum*recPrice+moneyInOut!=0){
		LVItem *it, *stocks=(LVItem *)sit->parent();
		sit->setType( stockNum*recPrice+moneyInOut>0 ? price_count|(__Red<<8) : price_count|(0x028602<<8) );
		stocks->setType(stockNum*recPrice+moneyInOut>0 ? (__Red<<8) : (0x028602<<8));
//		stocks->setText(0, stocks->text(0) );
		it=getField(stocks, Field_recentprice);
		it->setType( stockNum*recPrice+moneyInOut>0 ?
			type_recentprice|(__Red<<8) : type_recentprice|(0x028602<<8) );
//		it->setText(0, it->text(0));
	}
  }
  sit->setText(1, buf);
}

LVItem *FinaStocks::getField(LVItem *stock, int idx)
{
LVItem *it=(LVItem *)stock->firstChild();
int t=0;
while( t++ < idx )it=(LVItem *)it->nextSibling();
return it;
}

LVItem *FinaStocks::getStocks()
{
LVItem *stocks=(LVItem *)vlist->currentItem();
while(stocks->parent())stocks=(LVItem *)stocks->parent();
return stocks;
}

FieldNode *FinaStocks::getNode(LVItem *stocks)
{
int i;
for(i=0; i<nodCnt&&fieldNodes[i].it!=stocks; i++);
return fieldNodes+i;
}

void FinaStocks::subCount(LVItem *it1)
{
LVItem *it=(LVItem *)it1->firstChild();
int val1, type=it1->getType();
long long price;
while( it ){
	val1=atoi(it->text(1));
	stockNum+=type==type_buy ? val1 : -val1;
	price=getMoney(it->text(0));
	price*=val1;

	exchangVal+= (type != type_buy ? price : price*1003/1000);
	moneyInOut+= (type != type_buy ? price*996/1000 : -price*1003/1000 );

	it=(LVItem *)it->nextSibling();
}
}

void FinaStocks::exchangCount(LVItem *stock)
{
stockNum=0;
moneyInOut=0;
exchangVal=0;
// dyAchie=0.0;dyAchieCount=0;
orgPrice=getMoney(getField(stock, Field_recentprice)->text(1));
subCount(getField(stock, Field_buy));
subCount(getField(stock, Field_sale));
}

void FinaStocks::achieCount(LVItem *achiefield)
{
LVItem *it=(LVItem *)achiefield->firstChild(), *stocks1;
const char *pt;
dyAchie=0.0;
dyAchieCount=0;
while( it ){
	QCString s(it->text(1));
	pt=(const char *)s;
	if(pt && *pt && *pt!='/' ){
		dyAchie=atof(pt)*100;
		dyAchieCount++;
	}
	it=(LVItem *)it->nextSibling();
}
stocks1=(LVItem *)achiefield->parent();
priceCount(10, getField(stocks1, 10), getMoney(getField(stocks1, Field_recentprice)->text(1)) );
}

LVItem *FinaStocks::lastStocks()
{
return nodCnt>0 ? fieldNodes[nodCnt-1].it : NULL;
}

void FinaStocks::creatCountField()
{
static const int imgs[5]={ countImg, countImg, countImg, countImg, surplusImg };
int i;
char buf[32];
float val;
LVItem *it=lastStocks();
for(i=0; i<5; i++){
	it=new LVItem(vlist, it, _stocks_[Int_field0+Field_count+i]);
	it->setPixmap(0,*pixmapLoad(imgs[i]));
	it->setType(total_counts|i);
	switch(i){
	case 0 : val=(float)t_Money/100;
		break;
	case 1 : val=(float)t_stocksVal/100;
		break;
	case 2 : val=(float)(t_Money+t_stocksVal)/100;
		break;
	case 3 : val=(float)t_exchangVal/100;
		break;
	case 4 : val=(float)surplusVal/100;
	if(surplusVal)it->setType( surplusVal>0 ? total_counts|4|(__Red<<8) : total_counts|4|(0x028602<<8) );
	}
	sprintf(buf, "%.2f", val);
	it->setText(1, buf);
	}
}

void FinaStocks::mdfCountField(int lmt)
{
int t;
char buf[32];
LVItem *it=lastStocks();
it=(LVItem *)(it ? it->nextSibling() : vlist->firstChild());
float val;
for(t=0; t<lmt; t++){
	switch(t){
	case 0 : val=(float)t_Money/100;
		break;
	case 1 : val=(float)t_stocksVal/100;
		break;
	case 2 : val=(float)(t_Money+t_stocksVal)/100;
		break;
	case 3 : val=(float)t_exchangVal/100;
		break;
	case 4 : val=(float)surplusVal/100;
	if(surplusVal)it->setType( surplusVal>0 ? total_counts|4|(__Red<<8) : total_counts|4|(0x028602<<8) );
	}
	sprintf(buf, "%.2f", val);
	it->setText(1, buf);
	it=(LVItem *)it->nextSibling();
	}
}

QMetaObject *FinaStocks::metaObj = 0;
static QMetaObjectCleanUp cleanUp_FinaStocks( finaStocks, &FinaStocks::staticMetaObject );
QMetaObject* FinaStocks::staticMetaObject()
{
  if ( !metaObj ){
    static const QMetaData slot_tbl[] = {
	{ "add()" , &slot_0_0, QMetaData::Private },
	{ "rem()" , &slot_0_0, QMetaData::Private },
	{ "mdf()" , &slot_0_0, QMetaData::Private },
	{ "subadd()" , &slot_0_0, QMetaData::Private },
	{ "chSel()" , &slot_0_0, QMetaData::Private },
	{ "doRen()" , &slot_ptr, QMetaData::Private }, // 5
	{ "help()" , &slot_0_0, QMetaData::Private },
	{ "quitPrg()",&slot_0_0, QMetaData::Private },
	{ "closeAll()", &slot_0_0,  QMetaData::Private },
	{ "recent()",&slot_0_0, QMetaData::Private },
	{ "cashIn()" , &slot_0_0, QMetaData::Private },
	{ "cashOut()" , &slot_0_0, QMetaData::Private },
	{ "Up()" , &slot_0_0, QMetaData::Private }, //12
	{ "Down()" , &slot_0_0, QMetaData::Private },
	{ "enter()", &slot_ptr, QMetaData::Private },
	{"save()", &slot_0_0,  QMetaData::Private },
	{ "buy()" , &slot_0_0, QMetaData::Private },
	{ "price()" , &slot_0_0, QMetaData::Private },
	{ "popAct(int)", &slot_int,  QMetaData::Private }
    };
    metaObj = QMetaObject::new_metaobject(finaStocks, QMainWindow::staticMetaObject(), slot_tbl, 19,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_FinaStocks.setMetaObject( metaObj );
    }
  return metaObj;
}

#ifndef QT_NO_PROPERTIES
bool FinaStocks::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES

LVItem *FinaStocks::backSibling(LVItem *it, int *Idx)
{
int i;
for(i=0; i<nodCnt; i++)
	if(fieldNodes[i].it==it)break;
return (*Idx=--i)<0 ? NULL : fieldNodes[i].it;
}

bool FinaStocks::qt_invoke( int _id, QUObject* _o )
{
static const char newName[]="stocks1", *stckpric;
int sw=_id - staticMetaObject()->slotOffset(),
  i, t, img, Idx, newPrice;
long long tprice, org_exchang, sp0, org_stocksVal, org_money;
LVItem *sit, *it, *stocks1;
switch(sw){
case 10 : 
case 11 : 
case 0 : 
    it=(LVItem *)vlist->currentItem();
    i=it ? it->getTypeOr() /* &127 */ : 0;
    t=i & ~sub_value;
    if(sw==0)switch(t){
	case type_buy :
	case type_sale : goto _sub_add_;
	case type_recentprice : goto _recentPrice_;
	}
    if(i&total_counts){
	it=new LVItem(vlist, lastStocks(),
		sw ? (sw==10 ? cashInChs : cashOutChs) : newName);
	Idx=nodCnt-1;
	}
   else {
	while(it&&it->parent())it=(LVItem *)it->parent();
	it=new LVItem(vlist, backSibling(it, &Idx),
		sw ? (sw==10 ? cashInChs : cashOutChs) : newName);
	}
    it->setRenameEnabled(1,true);
    it->setRenameEnabled(2,true);
    vlist->ensureItemVisible(it);
    vlist->setSelected(it,true);
    if(sw!=0){
	it->setType(type_cash|(sw-10));
	it->setPixmap(0, *pixmapLoad( sw!=11 ? cashInImg : cashOutImg) );
	it->startRename(1);
	money=0;	mdf_val=1;
	goto _skp2_;
 	}
    it->setPixmap(0,*pixmapLoad(stocksImg));
    it->setRenameEnabled(0,true);
    it->setOpen(true);
    sit=NULL;
    for(i=0; i<Field_count; i++)
	switch(i){
	case Field_achie : {
		MAU mau;
		mau.buf=strdup(achieChs);
		mau.len=strlen(mau.buf);
		sit=subFieldCreat(it, sit, _stocks_[Int_field0+i], Field_achie, &mau);
		}
		break;
	case Field_buy :
	case Field_sale :	sit=new LVItem(it, sit, _stocks_[Int_field0+i]);
		sit->setType(i-2); // 3(type_buy) or 4(type_sale)
		sit->setPixmap(0,*pixmapLoad(i==Field_buy ? buyImg:saleImg));
		break;
	case 11 : img=surplusImg;
		goto _jmp_;
	case 10 : img=multipleImg;
		goto _jmp_;
	case 8 : img=stocknumImg;
		goto _jmp_;
	case 7 : img=cost2Img;
		goto _jmp_;
	case 9 : img=totalcostImg;
		goto _jmp_;		
	case Field_recentprice /*4*/ : img=recpriceImg;
		goto _jmp_;
	case 0 :
	case 1 :
	case 2 : img=assetImg+i;
	_jmp_:	sit=new LVItem(it, sit, _stocks_[Int_field0+i], utf8code);
		sit->setPixmap(0, *pixmapLoad(img));
		sit->setText(1,value0);
		sit->setType(1);
		if(i==Field_recentprice){
			sit->setText(2, QDateTime::currentDateTime().toString(p_dtfmt) );
			sit->setRenameEnabled(2,true);
			sit->setType(type_recentprice);
			}
		if(i<7)sit->setRenameEnabled(1,true);
	}
	it->startRename(0);	mdf_val=0;
_skp2_:	if(nodCnt>=nodPre){
		nodPre+=6;
		FieldNode *tmp=(FieldNode *)zalloc(sizeof(FieldNode)*nodPre);
		if(nodCnt){
			memcmp(tmp, fieldNodes, sizeof(FieldNode)*nodCnt);	
			free(fieldNodes);
		}
		fieldNodes=tmp;
		}
	if(Idx>-1){
		if(Idx+1<nodCnt)t=fieldNodes[Idx+1].dyNum;
		else t=fieldNodes[nodCnt-1].dyNum+1;
	}
	else t=0;
	for(i=nodCnt; i>Idx; i--){
		fieldNodes[i]=fieldNodes[i-1];
		fieldNodes[i].dyNum++;
		}
	fieldNodes[++Idx].it=it;
	fieldNodes[Idx].mdf=true;
	fieldNodes[Idx].num=-1;
	fieldNodes[Idx].dyNum=t;
	nodCnt++;
	mdf=true;
	saveAct->setEnabled(true);
	if(sw)goto _chgSel_;
	break;
case 3 :	_sub_add_: it=(LVItem *)vlist->currentItem();
	if(it->getTypeOr()==type_recentprice)goto _recentPrice_;
	stocks1=getStocks();
	strcpy(pricBuf, getField(stocks1, Field_recentprice)->text(1));	strcpy(numBuf, "100");
	_buy_add_: t=it->getTypeOr(); // &127;
	subAdding=true;
	switch(t){
	case type_sale : strcpy(numBuf, getField(stocks1, Field_stockscount)->text(1));
	case type_buy :	exchangCount( stocks1 ); // reset stockNum, moneyInOut
		sit=new LVItem(it, NULL, pricBuf);
		sit->setType(t|sub_value);
		goto _skp_;
	case type_sale|sub_value : strcpy(numBuf, getField(stocks1, Field_stockscount)->text(1));
	case type_buy |sub_value :
		exchangCount( stocks1 ); // reset stockNum, moneyInOut
		sit=new LVItem((LVItem *)it->parent(), it, pricBuf);
		sit->setType(t);
	_skp_:	sit->setText(1, numBuf);
		sit->setText(2, QDateTime::currentDateTime().toString(p_dtfmt));
		sit->setRenameEnabled(0,true);
		sit->setRenameEnabled(1,true);
		sit->setRenameEnabled(2,true);
		sit->startRename(mdf_val=(sw!=16 ? 0:1));
	}
	mdf=true;
	saveAct->setEnabled(true);
	break;
case 2 : // mdf F2
	it=(LVItem *)vlist->currentItem();
	t=it->getTypeOr(); // &127;
	switch(t){
	case type_cashin :
	case type_cashout :
		money=getMoney(it->text(1));
		break;
	case sub_value|type_buy :
	case sub_value|type_sale :
	case type_recentprice : 
		exchangCount( t!=type_recentprice ? (LVItem *)it->parent()->parent() : (LVItem *)it->parent() ); // reset stockNum, moneyInOut
		break;
	}
	it->startRename(mdf_val=(t==1 || (t&type_cash) || t==type_recentprice || t==(type_achie|sub_value) ? 1 : 0));
	break;
case 4 : // change sel
	it=(LVItem *)vlist->currentItem();
_chgSel_:	bool b,  mvable;
	t=it ? it->getTypeOr() /*&127 */ : 0;
	subAddAct->setEnabled( (b=(t==type_buy||t==type_sale||t==type_recentprice)) );
	mdfAct->setEnabled(!b&&t!=2&& 0==(t&total_counts) && (t&price_count)!=price_count);
	mvable=(t==(type_recentprice|sub_value)||
		t==(type_buy|sub_value)||t==(type_sale|sub_value));
	removeAct->setEnabled( (t==0||(t&type_cash)) || mvable );
	upAct->setEnabled( (t==0||(t&type_cash)==type_cash ) &&it!=vlist->firstChild() || (mvable&&it->parent()->firstChild()!=it ) );
	downAct->setEnabled((t==0||(t&type_cash)==type_cash)&&lastStocks()!=it || (mvable&&it->nextSibling()) );
	priceAct->setEnabled( b=((t&total_counts)==0 && (t&type_cash)==0 ) );
	buyAct->setEnabled(b);
	break;
case 1 : 
#define limit  Idx
#define  type  img
	it=(LVItem *)vlist->currentItem();
	mdf=true;
	saveAct->setEnabled(true);
	type=it->getTypeOr(); /*&127; */
	switch(type){
	case 0 : 	// NumDel(StocksDir,  fieldNodes[i].num);
		exchangCount(it);
		t_exchangVal-=exchangVal;
//		newPrice=getMoney(getField(it,Field_recentprice)->text(1));
		tprice=orgPrice*stockNum;
		t_stocksVal-=tprice;
		t_Money-=moneyInOut;
		surplusVal-=tprice+moneyInOut;
_delTopItem_:	mdfCountField(type ? 3 : 5);
		if(tashCnt>=tashPre){
			tashPre+=6;
			FieldNode *tmp=(FieldNode *)zalloc(sizeof(FieldNode)*tashPre);
			if(tashCnt){
				memcmp(tmp, tash, sizeof(FieldNode)*tashCnt);	
				free(tash);
			}
			tash=tmp;
			}
		for(i=0; i<nodCnt&&fieldNodes[i].it!=it; i++);
		tash[tashCnt++]=fieldNodes[i];
		if(nodCnt-i>1)memmove(fieldNodes+i, fieldNodes+i+1, sizeof(FieldNode)*(nodCnt-i-1));
		nodCnt--;
		delete it;
		break;
	case type_cashin :
	case type_cashout : 
		tprice=getMoney(it->text(1));
		t_Money += type==type_cashout ? tprice : -tprice;
		goto _delTopItem_;
	case type_recentprice|sub_value :
		getNode(getStocks())->mdf=true;
		delete it;
		break;
	case type_buy|sub_value :
	case type_sale|sub_value : 
		stocks1=getStocks();
//		for(i=0; i<nodCnt&&fieldNodes[i].it!=stocks1; i++);		fieldNodes[i].mdf=true;
		getNode(stocks1)->mdf=true;
		exchangCount(stocks1);
		sit=it;	it=(LVItem *)it->parent();
		delete sit;
		goto _jmp3_;
	}
	break;
case 5 : it=(LVItem *)vlist->currentItem(); // { "doRen()" , &slot_ptr, QMetaData::Private }
	stocks1=getStocks();
	getNode(stocks1)->mdf=true;	mdf=true;
	saveAct->setEnabled(true);
	type=it->getTypeOr(); // &127;
	switch(type){
	case type_cashin :
	case type_cashout : 
		if(mdf_val!=1)break;
		tprice=getMoney(it->text(1))-money;
		t_Money += type==type_cashin ? tprice : -tprice;
		mdfCountField(3);
		break;
	case type_achie|sub_value : achieCount((LVItem *)it->parent());
		break;
	case type_buy|sub_value :
	case type_sale|sub_value : 
		switch(mdf_val){
		case 0 : if(subAdding){
				mdf_val=1;
				it->startRename(1);
				return true;
			}
		case 1 : break;
		default : goto _skp5_;
		}
		it=(LVItem *)it->parent();
	_jmp3_:	org_stocksVal=orgPrice*stockNum;
		org_money=moneyInOut;
		org_exchang=exchangVal;
		sp0=org_stocksVal+moneyInOut;
		exchangCount(stocks1); // reset stockNum, moneyInOut
		t_stocksVal+=stockNum*orgPrice-org_stocksVal;
		surplusVal+=(stockNum*orgPrice + moneyInOut)-sp0;
		t_exchangVal+=exchangVal - org_exchang;
		t_Money+=moneyInOut-org_money;
		t= type==(type_buy|sub_value) ? Field_buy : Field_sale;
		limit=6;
		newPrice=orgPrice;
		goto _skip2_;
	case type_recentprice :
		if(mdf_val!=1)break;
		achieCount( getField((LVItem *)it->parent(),Field_achie) );
		newPrice=getMoney(it->text(1));
		stockNum=atoi(getField(stocks1, 8)->text(1));
		tprice=( newPrice - orgPrice )*stockNum;
		t=4;	limit=8;
		surplusVal+=tprice;
		t_stocksVal+= tprice;
	_skip2_:	while( t<Field_count/*12*/&&it ){
			if(t>limit&& t!=10/* achie*/ )priceCount(t, it, newPrice);
			it=(LVItem *)it->nextSibling();
			t++;
		}
		mdfCountField();
	_skp5_: subAdding=false;
	}
	break;
case 6 :	ORLLink((Filesan *)parentWidget(), 7, 2/* new wdg */);
	break;
case 7 : QApplication::postEvent(qApp, new QCloseEvent );
	break;
case 8 : appPost(65002, this, parentWidget() );
	break;
case 9 : 
case 18 : stocksList.at(sw!=9 ? _o[1].payload.i : 1)->showTop();
	break;
case 12 :
case 13 : 	mdf=true;
	saveAct->setEnabled(true);
	it=(LVItem *)vlist->currentItem();
	stocks1= (type=it->getTypeOr())==0 ? it : getStocks();
	for(i=0; i<nodCnt && stocks1!=fieldNodes[i].it; i++);
	if(sw==12){
		LVItem *tmp=type ? (LVItem *)it->parent()->firstChild() : (LVItem *)vlist->firstChild();
//		if(it==tmp)break;
		while(tmp!=it){
			sit=tmp;
			tmp=(LVItem *)tmp->nextSibling();			
			}
		sit->moveItem(it);
		if(type==0){
			fieldNodes[i-1].mdf=true;
			fieldNodes[i-1].it=it;
			fieldNodes[i].it=sit;
		}
	}
	else { // down
		sit=(LVItem *)it->nextSibling();
		it->moveItem(sit);
		if(type==0){
			fieldNodes[i].it=sit;
			fieldNodes[i+1].mdf=true;
			fieldNodes[i+1].it=it;
		}
	}
	fieldNodes[i].mdf=true;
	goto _chgSel_;
case 14 : it=(LVItem *)vlist->currentItem();
	it->setOpen(!it->isOpen());
	break;
case 15 : fspSave();
	break;
case 16 : {
	static FastBlock x_lst;
	stocks1=getStocks();
	QString retS( stocks1->text(0) );
	InputDlg buyDlg(this, 6, pms_buy, buyImg);
	if(buyDlg.exe(retS, NULL, &x_lst, NULL, NULL))break;
	strcpy(pricBuf, retS);
	sp0=getMoney(pricBuf);
	if(sp0){
		t=t_Money*1000/(sp0*1003);
		sprintf(numBuf, "%d",  t/100*100);
		it=getField(stocks1, Field_buy);
		goto _buy_add_;
	}
	}
	break;
case 17 : _recentPrice_ : {
	stocks1=getStocks();
	getNode(stocks1)->mdf=true;
	mdf=true;	subAdding=true;
	saveAct->setEnabled(true);
	it=getField(stocks1, Field_recentprice);
	it->setOpen(true);
	exchangCount( stocks1 ); // reset stockNum, moneyInOut	
	sit=new LVItem(it, NULL, it->text(1)/*.local8Bit()*/);
	sit->setType(type_recentprice|sub_value);
	sit->setText(1, it->text(2));
	sit->setRenameEnabled(0,true);
	sit->setRenameEnabled(1,true);
	mdf_val=1;
	it->setText(2, QDateTime::currentDateTime().toString(p_dtfmt));
	it->startRename(1);
	}
	break;
default : QMainWindow::qt_invoke(_id, _o);
}
return true;
}

