/*
	Write by xempo(LinJiangHua)
	Free under LGPL
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <dirent.h>
#include <sys/stat.h>
#include "fmtinp.c"
#include "setargv.c"
#include "memstr.c"
#include "filter.c"
#include "catstr.c"

static __time_t objtm;
static int build;
static const char _target[]="target";
static int testObj(const char *dn, const char *fn, const char *ext, __time_t tm)
{
int rt;
struct stat st;
char *fobj=catstr(dn, fn, '/'),
 *idx=strrchr(fobj, '.');
strcpy(idx+1, ext);
rt=stat(fobj, &st);
free(fobj);
/*printf("%d,%d\n", st.st_mtime, tm);*/
return rt || st.st_mtime<tm;
}

inline void dirmake(const char *dn, const char *cmd)
{
  DIR *dir=opendir(dn);
  struct stat st;
  struct dirent *dent;
  char *fn, *pt, *tg_dn;
  const char *fmt="%s %s --noext -d %s";
  int L=strlen(dn);
  tg_dn=(char *)malloc(L+sizeof(_target)/*-3*/);
  strcpy(tg_dn, dn);
  pt=strrchr(tg_dn, '/');
  strcpy(pt+1, _target);
  while( (dent=readdir(dir)) ){
	fn=dent->d_name;
	if(strcmp(fn, ".")==0 || strcmp(fn, "..")==0 || !namefilters(fn, "*.pts", 1) )continue;
	pt=catstr(dn, fn, '/'); /* 1 read(const), 2 write( no const ) , none => --noext*/
	switch(*fn){
	case '1'  : fmt="%s %s --const -d %s";
		goto _add1_;
	case '2' :  /* generial no use  thus */
	case '3' : fmt="%s %s -d %s";
		_add1_: fn++;
	}
	stat(pt, &st);
	if(S_ISREG(st.st_mode) && st.st_mtime > objtm ){
		if(testObj(tg_dn, fn, "h", st.st_mtime) || testObj(tg_dn, fn, "fsd",st.st_mtime) ){
			char buf[2048];
			sprintf(buf, fmt, cmd, pt, tg_dn);
			system(buf);
			}
		build=1;
	}
	free(pt);
	}
  free(tg_dn);
  closedir(dir);
}

int main(int argc, char **argv)
{
static const char msg[]="Usage : dirpts [objfile] [dir] [\"cmd\"]\n\tMust 3 parameters";
if(argc>3){
  struct stat st, subst;
  if(stat(argv[1], &st)==0)objtm=st.st_mtime;
  DIR *dir=opendir(argv[2]);
  if(dir==NULL){
	perror(argv[2]);
	return;
	}
  struct dirent *dent;
  char *fn, *pt;
  while( (dent=readdir(dir)) ){
	fn=dent->d_name;
	if(strcmp(fn, ".")==0 || strcmp(fn, "..")==0 )continue;
	pt=catstr(argv[2], fn, '/');
	stat(pt, &st);
	if(S_ISDIR(st.st_mode)){
		char *sub=catstr(pt, "pts", '/');
		if(stat(sub, &subst)==0 && S_ISDIR(subst.st_mode))dirmake(sub, argv[3]);
		free(sub);
		}
	free(pt);
	}
  closedir(dir);
  if(build)return 0;
  }
else puts(msg);
return 1;
}
