/*
	Write & edit by Linjianghua(xempo)
	Free under LGPL
*/

#define	BOOL 	int
#define	True	1
#define	False	0

#include <sys/stat.h>
#include <dirent.h>
#include <signal.h>

#include "readfile.c"
#include "memstr.c"
#include "strcut.c"
#include "fmtinp.c"
#include "setargv.c"
#include "filter.c"

static const char operaChs[]="operator", DEF[]="define";

#define OPE_LEN sizeof(operaChs)-1
#define DEF_LEN  sizeof(DEF)-1

enum ZX { _line1='/', _line2='/',
	_zx1='/',   _zx2='*',   zx1='*', zx2 ='/'
};

inline unsigned int pureText(char *txt)
{
unsigned int i, j, len, zxpos, yhpos, /*  DOS enlarge to 64k*/
	zxcn=0, yhcn=0;
BOOL  zxMsg=False, yhMsg=False;
for(i=0; txt[i]; i++){
  if(zxMsg){
	if(txt[i]=='\n' )zxcn++;
	if(txt[i]==zx1&&txt[i+1]==zx2){
		len=i+2-zxpos;
		strcut(txt+zxpos,len-zxcn);
		for(j=0; j<zxcn; j++)txt[zxpos+j]='\n';
		if(i>len-zxcn)i-=len-zxcn;
		else i=0;
		zxcn=0;	zxMsg=False;
		}
	}
  else if(txt[i]=='\"'){
	if(i==0||txt[i-1]!='\\'){
		if(yhMsg){
			len=i+1-yhpos;
			strcut(txt+yhpos,len-yhcn);
			for(j=0; j<yhcn; j++)txt[yhpos+j]='\n';
			if(i>len-yhcn)i-=len-yhcn;
			else i=0;
			yhcn=0;	yhMsg=False;
			}
		else {
			yhpos=i; yhMsg=True;
			}
	}
             }/*  txt[i]=='\"' */
            else if(yhMsg){
		if(txt[i]=='\n' )yhcn++;
		}
	   else  {
		if(txt[i]==_zx1&&txt[i+1]==_zx2){
			zxpos=i;
			zxMsg=True;
		}
		else if(txt[i]==_line1&& txt[i+1]==_line2){
			j=i+2;
		_del_:	while( txt[j]!='\n'&&txt[j]!=0)j++;
			strcut(txt+i, j-i);
			}
		          else if(txt[i]=='#' && (i==0||txt[i-1]==10) ){
			for(j=i+1; txt[j]==32; j++);
			if(memcmp(DEF, txt+j, DEF_LEN)||txt[j+DEF_LEN]!=32 )goto _del_;
			}
		}
}
return i;
}

#define	 TypeCount		6
#define  Type_Normal    TypeCount
static int total_KW, counting_KW,
	orl_num, noneCnt, *Index, vose;
static FILE *posfp, *funfp;
static const char WB[]="wb", structChs[]="struct", unionChs[]="union",
	*__TypeChs[TypeCount]={ "template", "enum",  "class", structChs, unionChs, "typedef" };

enum Types { Type_Template, Type_Enum, Type_Class, Type_Struct, Type_Union  };

static char *srcNam;

/*inline void _handle(int num)
{
printf("Memory error, exiting \"%s\" ...\ntotal : %d , error in line : %d\n" , srcNam, total_KW+counting_KW, *Index);
exit(20);
}*/

static const char *isKeyword(const char *txt, int len, const char *key)
{
const char *ptr;
int L;
return ( (ptr=memstr(txt, len, key, L=strlen(key), 2))!=NULL &&
		(ptr[-1]==10||isSpace(ptr[-1])||ptr==txt) &&
		(ptr[L]==10||isSpace(ptr[L])||ptr[L]=='<') ) ? ptr : NULL;
}

static const BOOL dwrite(const char *txt, int len, int pos)
{
if(len>0 && memstr(txt, len, operaChs, OPE_LEN, 3)==NULL){
	int i;
	while(len>0 && txt[len-1]==')')len--;
	for(i=0; txt[i]=='('; i++);
	if(len-i>0){
		int j;
		for(j=0; j<len-i; j++)if(txt[i+j]==';'){
			char *buf=(char *)malloc(len-i+2);
			memcpy(buf, txt+i, len-i);
			buf[len-i]=0;
			printf("%s\nDevelop on \"%s\" ...\ntotal : %d , error in line : %d\n" ,
				buf, srcNam, total_KW+counting_KW, *Index);
			free(buf);
			/* exit(20); */
			return False;
			}
		fprintf(posfp, counting_KW ? ",%d" : "%d", pos);
		if(counting_KW++>0)fwrite(":", 1, 1, funfp);
		fwrite(txt+i, len-i, 1, funfp);
		return True;
		}
	}
return False;
}

#define  calcLineOff(N)  for(ln=0, k=N; k!=mIdx; k++) \
			if(pt[k]==10)ln++;


static int doCvt(const char *dirsrc, const char *filters, int msg)
{
  char *pt, *ptr, *buf;
  int  dirLen, lines, ln, kuo;
  unsigned int  pos_idx, fun_idx,
	_d, namIdx, unitBegin, y, k, j, n, fileLen;
  struct stat st;
  struct dirent *dstru;
  DIR *dir;
  Index=&lines;
  if(stat(dirsrc, &st)){
	perror(dirsrc);
	return -1;
	}
  if(!S_ISDIR(st.st_mode)){
	srcNam=(char *)dirsrc;	dir=NULL;
	goto _done_;
	}
  if((dir=opendir(dirsrc))==NULL){
	perror(dirsrc);
	return -1;
	}
  dirLen=strlen(dirsrc);
  srcNam=(char *)malloc(dirLen+258);
  strcpy(srcNam, dirsrc);
  if(srcNam[dirLen-1]!='/')srcNam[dirLen++]='/';
_start_:  if(dir){
    if( (dstru=readdir(dir)) ){
    ptr=dstru->d_name;
    if((ptr[0]=='.' && (ptr[1]==0 || ptr[1]=='.'&&ptr[2]==0 )) )goto _start_;
    strcpy(srcNam+dirLen, ptr);
    stat(srcNam, &st);
    if(S_ISDIR(st.st_mode)){
	if(msg&1)doCvt(srcNam, filters, msg);
	}
    else {
	unsigned int mIdx;/* mem index */
	char buff1[1200], buff2[40];
	if( namefilters(ptr, filters, 1|(msg&2))==0 )goto _start_;
/*________________________________________________________ */
_done_:	if( !(buf=ReadFile(srcNam, &fileLen)) )return 3;
	if(dir&&vose)printf("Get from \"%s\" ...\n", srcNam);
	if( (fileLen=pureText(buf))<1 ){
		if(vose)printf(" ** %s \n    is none !\n", srcNam);
		noneCnt++;
		goto _start_;
	}
	pt=buf;
	for(j=fileLen-1; (pt[j]==10); fileLen--){
		pt[j]=0;
		if(j==0)goto _start_;
		else j--;
		}
  pos_idx=ftell(posfp);	fun_idx=ftell(funfp);
  sprintf(buff1, "numbset %d -t=vi\n{\n%s\n}\n{\n", orl_num, srcNam);
  fseek(posfp, pos_idx+strlen(buff1), 0);
  sprintf(buff2, "write.m: %d ", orl_num);
  fseek(funfp, fun_idx+strlen(buff2), 0);
  counting_KW=0;  	lines=0;
  unitBegin=0;  mIdx=0;
  while(mIdx<fileLen){
	switch(pt[mIdx]){
	case '\n' : lines++;
		break;
	case ';' :  /* baseUnit  */
		while(pt[unitBegin]==10||isSpace(pt[unitBegin]))unitBegin++;
		j=unitBegin;
		while(pt[j]!=',' &&pt[j]!='('&&pt[j]!='='&&j<mIdx)j++;
_loop1_:	namIdx=j-1;
		while(isSpace(pt[namIdx])||pt[namIdx]==10)namIdx--;
		if(pt[namIdx]==']'){ /* [xx]  */
			while(pt[--namIdx]!='[');
			_d=namIdx;
			}
		else _d=namIdx+1; /*  Name end  */
		if(pt[j]=='('){
		      y=j;
		      while(pt[++y]==10||isSpace(pt[y]));
		      if(pt[y]=='*'){ /*  (*func)(...)  */
			while(pt[++y]==10||isSpace(pt[y]));
			n=y;
			while(pt[++y]!=')' && pt[y]!='('); /* as:  extern int (*XSetExtensionErrorHandler(int (*handler)(Display *,  char *,   char *   ) ) )
					 (Display *,char *,char *);*/
			kuo=pt[y]=='(' ? 2:0;
			j=y;
			while(pt[--y]==10||isSpace(pt[y]));
			calcLineOff(n)  /* get ln */
			dwrite(pt+n, y+1-n, lines-ln);
			goto _through_syb2;
			}
		}
		while(namIdx>=unitBegin&&(notSpace(pt[namIdx])&&pt[namIdx]!=10&&pt[namIdx]!='*'&&pt[namIdx]!=','))namIdx--; /* Name begin */
		namIdx++;
		calcLineOff(namIdx)  /* get ln */
		if(dwrite(pt+namIdx, _d-namIdx, lines-ln)==False){
			unitBegin=mIdx+1;
			goto _Loop_;
			}
		switch(pt[j]){
		case '('  : kuo=1;
	_through_syb2: while(++j<mIdx){
			switch(pt[j]){
			case '(' : kuo++;
				break;
			case ')' : if(--kuo==0){
					while(pt[++j]==10||isSpace(pt[j]));
					if(pt[j]=='('){
						kuo=1;
						break;
					}
					kuo=0;
					while(j<mIdx){
						switch(pt[j]){
						case '(' : kuo++;
							break;
						case ')' : --kuo;
							break;
						case ',' : if(kuo==0)goto _jmp2_;
						}
						j++;
					}
					goto _jmp2_;
					}
				}
			}
		break;
		case ':' :
		case '=' : while(++j<mIdx && pt[j]!=',' && pt[j]!='(' && pt[j] != '=' );
		}
_jmp2_:		unitBegin=++j;
		if(j<mIdx){
			kuo=0;
			k=pt[j-1];
			while(j<mIdx){
				switch(pt[j]){
				case '(' : kuo++;
					break;
				case ')' : if(--kuo==0)unitBegin=j+1;
					break;
				case '=' : 
				case ',' : if(kuo==0)goto _loop1_;
				}
				j++;
			}
			if(k==',')goto _loop1_;
		}
		else unitBegin=mIdx+1;
		break;	 /* baseUnit end */
	case '#' : for(n=mIdx+1; isSpace(pt[n]); n++);
		if( (mIdx==0||pt[mIdx-1]==10) && memcmp(pt+n, DEF, DEF_LEN)==0){
		  for(n+=DEF_LEN; isSpace(pt[n]); n++);
		  namIdx=n;
		  while(notSpace(pt[n])&&pt[n]!='('&&n<fileLen){
			if(pt[n]==10){ lines++; break; }
			n++;
			}
		  _d=n;
		  if(pt[n]=='('){
		      kuo=1;
		      while(++n<fileLen){
			switch(pt[n]){
			case '(' : kuo++; break;
			case 10 : lines++; break;
			case ')' : if(--kuo==0)goto _jmp3_;
			}
		      }
		  }
_jmp3_:		  dwrite(pt+namIdx, _d-namIdx, pt[n]==10 ? lines-1 : lines);
		  while( ++n<fileLen )
		      if( 10==pt[n]){
			lines++;
			for(j=n-1;j>0&&isSpace(pt[j]);j--);
			if(pt[j]!='\\')goto _brk_;
			}
		} /* end if  */
	_brk_:	mIdx=n;	unitBegin=mIdx+1;
		break;
	case '{' : { /* kuo=1; and {=' '  remember pos(mIdx). when go } and kuo==0, process something(...), and go to mIdx, continue  normal(...)*/
		int  __type=0, __syb=0, _line=0, head_off=0;
		register int __mIdx=mIdx;
		kuo=1;	pt[__mIdx]=32;
		while(pt[--__mIdx]==10||isSpace(pt[__mIdx]))if(pt[__mIdx]==10)head_off++;
		if(pt[__mIdx]==')') /* inline */
			goto _inline_;
		while( __type<TypeCount && !isKeyword(pt+unitBegin, mIdx-unitBegin, __TypeChs[__type]) )__type++;

		switch(__type){
		case Type_Template :
			for(n=unitBegin; pt[n]!='>'; n++){
				if(pt[n]==10)lines++;
				}
			n++;
			while(pt[n]==10||isSpace(pt[n])){
				if(pt[n]==10)lines++;
				n++;
				}
			while(notSpace(pt[n])){
				if(pt[n]==10){lines++; break; }
				n++;
				}
/*-----------------------------------------------------------------------------------------------------*/
			while(pt[n]==10||isSpace(pt[n])){
				if(pt[n]==10)lines++;
				n++;
				}
			for(j=n; notSpace(pt[j])&&pt[j]!='('; j++)
				if(pt[j]==10){ lines++; break; }
			if(memcmp(pt+n, operaChs, OPE_LEN)!=0)dwrite(pt+n, j-n, lines); /* write 2nd  */
			for(n=mIdx+1 ; n<fileLen; n++)
			  switch(pt[n]){
			  case '{' : kuo++;
				break;
			  case 10 : lines++; break;
			  case '}' : if(--kuo==0){
					while(pt[++n]==10||isSpace(pt[n]));
					while( pt[n]!=';'&& n<mIdx ) n++;
					mIdx=n+1;
					unitBegin=n;
					goto _Loop_;
				}
			  }
			break;
		case Type_Class : ptr=memstr(pt+unitBegin, mIdx-unitBegin, ":", 1, 1);
			if(ptr==NULL)ptr=pt+__mIdx+1;
			__syb=0xff;
			while( *(--ptr)==10 || isSpace(*ptr) )if(*ptr==10)_line--;
			for(_d=0; notSpace(*ptr);  _d++, ptr--)
				if(*ptr==10){ _line--; break; }
			dwrite(ptr+1, _d, lines+_line-head_off);
			break;
		case Type_Normal :/*	n=__mIdx+1;  only proc inline */
			while(/*pt[__mIdx]!=')'&&*/__mIdx>unitBegin){
			    if(pt[__mIdx]==')')_inline_:{
				k=1;
				while(__mIdx>unitBegin)
				switch(pt[--__mIdx]){
				case ')' : k++;
					break;
				case 10 : _line--;
					break;
				case '(' : if(--k==0){
					while(pt[--__mIdx]==10||isSpace(pt[__mIdx]))if(pt[__mIdx]==10)_line--;
					j=__mIdx;
					while(pt[--__mIdx]!=10 &&notSpace(pt[__mIdx])&&pt[__mIdx]!='*'&&pt[__mIdx]!='&');
					if(isKeyword(pt+__mIdx+1, j-__mIdx, "__NTH")==NULL)
						dwrite(pt+__mIdx+1, j-__mIdx, lines+_line-head_off);
					for(n=mIdx+1 ; n<fileLen; n++)
					switch(pt[n]){
					case '\n' : lines++;
						break;
					case '{' : kuo++;
						break;
					case '}' : if(--kuo==0){
						mIdx=n;	goto _ex_loop_;
						}
					}
				     }
				}
				break;
			    } /* _inline_  end */
			    __mIdx--;
			}
		} /* end switch(__type) */
		for(n=mIdx+1 ; n<fileLen; n++)
		switch(pt[n]){
		case '{' : kuo++;
			break;
		case ':' : if(__type==Type_Class)/* class, like  public: or private : */
				pt[n]=32;
			else pt[n]='=';
			break;
		case 10 : _line++;
			break;
		case '}' : if(--kuo==0){ /* 解括号成功 */
			pt[n]=32;
			if(__type==Type_Normal)goto _ex_loop_;
			k=n;
			while(pt[++n]==10||isSpace(pt[n]))if(pt[n]==10)_line++;
			for(j=n; pt[j]!=';'&&j<fileLen; j++);
			if(__type!=Type_Enum)pt[j]=32; /* enum reserve ';'  */
			if(__syb>0xf0)goto _ex_loop_;
			namIdx=j-1;
			while( k!=namIdx&&(isSpace(pt[namIdx])||pt[namIdx]==10) )namIdx--;
			j=namIdx+1;
			while(notSpace(pt[namIdx])&&pt[namIdx]!=10&&pt[namIdx]!='*'&&k!=namIdx)namIdx--;
			namIdx++;	
			if(j-namIdx>0)dwrite(pt+namIdx, j-namIdx, lines+_line);
/*			else { */
			for(_d=__mIdx++; notSpace(pt[_d]) && pt[_d]!=10; _d--); /* goto head  */
			switch(__type){
			case Type_Struct/* 3 */  : if(memcmp(pt+(_d+1), structChs, 6))goto _dwt_;
				break;
			case Type_Union/* 4 */: if(memcmp(pt+(_d+1), unionChs, 5))
				_dwt_:	dwrite(pt+(_d+1), __mIdx-(_d+1), lines-head_off);
			}
			_ex_loop_: unitBegin=mIdx+1;
			goto _Loop_;
			}
		  }
		}/*______pt[mIdx]=={' end _____________________ */
	}
_Loop_:   mIdx++;
  }

  if(counting_KW){
	fprintf(funfp,"\n\n");
	fprintf(posfp,"\n}\n\n");

	fseek(funfp, fun_idx, 0);
	fseek(posfp, pos_idx, 0);

	fprintf(posfp, buff1);
	fprintf(funfp, buff2);
	fseek(posfp, 0, 2);
	fseek(funfp, 0, 2);
	orl_num++;
	if(dir&&vose)printf("    ==> %d\n", counting_KW);
	total_KW+=counting_KW;
	}
  else {
	fseek(funfp, fun_idx, 0);
	fseek(posfp, pos_idx, 0);
	}
  }
  goto _start_;
  }
  if(dir)closedir(dir);
  }
return 0; /* success */
}


#define	outfile	dyVar[0]
#define	dstdir	dyVar[1]
#define  varsCnt	2

#define  pmsCnt	6
#define initval -1

#define noWarn() (parasVal[2]==0)

int main(int argc, char **argv)
{
static const char usageChs[]="Free software\n\
Cvt C/C++ head file for runtime-help\n\
Usage : mkhelp [dir(file)] | [-o <out-file>|-d <out-dir>] | [--flt=<xxx>|--flt-cs=<xxx>]\n\
      |[--vose] |[--sub] |[--nowarn] |[--disnw]\n\
Options :\n\
      dir(file) is source(input)\n\
      -d follow <out-dir>\n\
      -o follow <out-file>\n\
      --vose : show message\n\
      --sub : include subdir\n\
      --nowarn : no warn for source\n\
      --disnw : disable next warn \n\
      --flt=<xxx> : set filters\n\
      --flt-cs=<xxx> like above, but filters is case sen\n\
      default create \"helpfun.rls\" & \"helppos.rls\"\n";

if(argc>1){
  static const char *paras[pmsCnt]={ "--vose" , "--sub", "--nowarn", "--disnw" , "--flt=", "--flt-cs=" }, /* save parasVal[] */
	*vars[varsCnt]={"-o", "-d" },
	*lostdst[varsCnt]={"A file must follow \"%s\" as outfile !\n",
		"A dir must follow \"%s\" for out !\n",
		},
	*warnMult[varsCnt]={
		"Out file has specied \"%s\", \"%s\" not be use !\n",
		"Out dir has specied \"%s\", \"%s\" not be use !\n",
		};
  char *pt;
  struct stat st1;
  int pmIdx, *pmpos, j, i,
	parasVal[pmsCnt];  /* => params index; */
  const char  *dyVar[varsCnt],  *dirsrc=NULL, *filters1=NULL, *filters2=NULL,
 *funfile="helpfun.rls", *posfile="helppos.rls"; /*default create 2 files */
 memset(dyVar, 0, varsCnt*sizeof(char *));
 memset(parasVal, 0, sizeof(parasVal));
 pmpos=(int *)malloc(sizeof(int)*(argc-1));
 for(i=0; i<argc-1; i++)pmpos[i]=initval;
 pmIdx=0;
 for(j=0; j<varsCnt; j++){
   for(i=1; i<argc; i++)
	if(strcmp(vars[j], argv[i])==0){
	 if( i+1>=argc ){
		if(dyVar[j]==NULL){
			printf(lostdst[j], vars[j]);
			pmpos[pmIdx++]=i;
		}
		continue;
		}
	 pmpos[pmIdx++]=i++;/* follow xxx */
	 if(j==1){
		if( stat(argv[i], &st1) || S_ISDIR(st1.st_mode)==0 )
		    printf("\"-d\" specied \"%s\" is not existed dir !\n", argv[i]);
		else if(outfile)printf("Outfile has been \"%s\", it also include path, ignore \"-d\".\n", outfile);
			else goto _jmp_;
		}
	 else {
	 _jmp_:	if(dyVar[j])printf(warnMult[j], dyVar[j], argv[i]);
		else dyVar[j]=argv[i];
	 }
	 pmpos[pmIdx++]=i;
	 break;
	}/* for(i) */
 } /* for(j) */

 for(j=1; j<argc; j++)
	for(i=0; i<pmsCnt; i++)
		if( (memstr(argv[j], 0,paras[i], 0, 3)) ){
			switch(i){
			case 4 : filters1=argv[j]+4; /* --flt= */
				break;
			case 5 : filters2=argv[j]+6; /* --flt-cs= */
				break;
			default :
				if(msg_memstr==0)continue;
				parasVal[i]=1;
			}
			pmpos[pmIdx++]=j;
		}

 for(i=1; i<argc; i++){
    for(j=0; j<pmIdx&&pmpos[j]!=i; j++);
    if(j>=pmIdx){/* above 2 sen is check argv[i] is no use yet */
	pt=argv[i];
	if( dstdir!=pt && outfile!=pt && stat(pt, &st1)==0 ){
		if(dirsrc)printf("Source has been \"%s\", the \"%s\" ignore\n", dirsrc, pt);
		else dirsrc=pt;
		pmpos[pmIdx++]=i;
	}
    }
  }

 if(pmIdx<argc-1)for(i=1; i<argc; i++){
	for(j=0; j<pmIdx&&pmpos[j]!=i; j++);
	if( j>=pmIdx /* above 2 sen is check argv[i] is no use yet */
	   && dirsrc && noWarn() )
		printf("** Warn ! \"%s\" is not use param\n", argv[i]);
	}

 if(dirsrc==NULL){
	printf( "No source dir input\n" );
	if(parasVal[2]==0)printf(usageChs);
	if(parasVal[3]==0)return 0;
	}

   if(outfile){
	    posfile=catstr(outfile, "pos", '.');
	    funfile=catstr(outfile, "fun", '.');
	}
   else if(dstdir){
	    posfile=catstr(dstdir, posfile, '/');
	    funfile=catstr(dstdir, funfile, '/');
	}

    posfp=fopen(posfile,WB);
    if(posfp==NULL){
	perror( posfile );
	return 4;
	}
    funfp=fopen(funfile,WB);
    if(funfp==NULL){
	perror( funfile );
	return 5;
	}

/*	signal(SIGSEGV, _handle); */
  vose=parasVal[0];
  if((pt=strchr(*argv,'/'))){
	_ProgPath=*argv; *pt=0;
	}
  if(filters2){
	parasVal[1]|=2;
	if(filters1)printf(" ** Warn : --flt & --flt-cs all define, use --flt-cs=%s\n", filters2);
	}
  doCvt(realpath(dirsrc,NULL), filters2 ? filters2 : filters1, parasVal[1] );
  fclose(funfp);
  fclose(posfp);
  if(orl_num)printf("Count : %d, created =>\n  %s\n  %s\n", total_KW, funfile, posfile);

  printf("%d file(s) have C define !\n%d file(s) none !\n", orl_num, noneCnt);
}
else printf(usageChs);
return 0;
}
