/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2010, 2014, 2015
  Free under LGPL
*/

#include "jxswitch.h"
#include "options.h"
#include "numbtype.h"
#include "normal.h"
#include "stdfun.h"
#include "ordir.h"
#include "dirext.h"
#include "fculoop.h"
#include "infor.h"
#include "../objcom/comm.h"
#include "conspace.h"
#include "write.h"
#include "rebuild.h"

static __ORD *src_dir;
static __ORL *dstlib;
static int _over;
static BOOL vbs;

int copyCnt;

BOOL getSpace(const char *extparm,int *s,int *d)
{
if(extparm==NULL||*extparm==0)return False;
int i, val=-1, len=extParaLen(extparm);
*s=-1; *d=-1; /* -1 mean curLib */
for(i=0;i<len;i++)
  if(extparm[i]=='.'||i==0){
	if(extparm[i]=='.')i++;
	if(extparm[i]>47&&extparm[i]<58||extparm[i]=='-'||extparm[i]=='+'){
	    val=atoi(extparm+i);
	    if(*s>-1)*d=val;
	    else *s=val;
	}
	}
 return *s!=-1||*d!=-1 ? True : False;
}

int selSpace(int sel)
{
if(sel>-1){
    if(sel>LASTSPACE || workspace[sel]==NULL){ 
_nowksp_:ORtips(52,1); 
	return -2;
	}
}
else if(sel<-1)goto _nowksp_;
return sel; /* -1 mean curLib */
}

static BOOL fixSpaces(__ORL **s_lib, __ORL **d_lib, const char *extparm)
{
int s,d;
if(getSpace(extparm,&s,&d)){
  if((s=selSpace(s))>-1)*s_lib=workspace[s];
  if((d=selSpace(d))>-1)*d_lib=workspace[d];
  if(s<-1 || d <-1 )return False;
}
return True;
}

static int baseCopy(__ORD *s_dir,__ORD *d_dir,int srcnmb,int dstnmb,BYTE *srcStat)
{
if(s_dir==d_dir /* own_adr will same as workspace[...]->root */
	&& srcnmb==dstnmb){
	defaultHB(SelfCpy_18);
	return 0;
	}
char *spt, *dpt;
MAU *Sends;
BYTE *stat;
int n=s_dir->DAUC, rt=0;
Sends=MAUalloc(n);
if(srcStat){ stat=srcStat; readFCU(s_dir,srcStat,Sends,n); }
else stat=NumRead(s_dir,srcnmb,Sends,n);
if(stat){
	BYTE *fmtStat=(BYTE *)malloc( s_dir->Num_FCU_Len );
	memcpy(fmtStat, stat, FCU_NumPos);
	if(isType(s_dir->Format))
		memcpy(fmtStat+FCU_NumPos, stat+FCU_TypePos(s_dir->Format), s_dir->DAUC );
	else memset(fmtStat+FCU_NumPos, _void, s_dir->DAUC );
	fmtFCU fmt={ fmtStat, dstnmb, 8, 0 };
	if((rt=wnfcu(d_dir, &fmt, Sends,n))!=0 && vbs ){
	    spt=ORDpath(s_dir, src_dir, 0);
	    dpt=ORDpath(d_dir,dst_dir,0);
	    char buf[1024];
	    sprintf(buf, "%s/%d ==> %s/%d", spt, srcnmb, dpt, dstnmb);
	    free(spt);	free(dpt);
	    msgShow(buf);
	}
	free(fmtStat);
	if(stat!=srcStat)free(stat);
	freeMAU(Sends,n);
	}
else reportBug();
return rt;
}

inline int copyNum(__ORD *sdir,BYTE *dsb)
{
  __ORD *ddir=dst_dir;
  if(sdir!=ddir /*|| sdir->own_adr!=ddir->own_adr  own_adr will same as workspace[...], like slib->own_adr== dlib->own_adr*/){
      BYTE *unit=dsb;
      int i, numb;
      BOOL zero;
     if(sdir->own_adr!=src_dir->own_adr){
	char *dirnam=ORDpath(sdir, src_dir, 1);
	ddir=DirOpen(dst_dir,dirnam);
	free(dirnam);
	if(idxdscpt<0x7ffd){ reportBug(); ddir=dst_dir; idxdscpt=0x7fff; }
	}
     zero=isZero(sdir->Format);
     for(i=0; _over!=Esc&&i<sdir->Num_FCUs_Block; i++,unit+=sdir->Num_FCU_Len){
	if(zero)numb=sdir->NumbForZero ++;
	if(*unit==1 ){
		if(!zero)numb= *(int *)(unit+FCU_NumPos);
		if(baseCopy(sdir,ddir,numb,numb,unit))/* copy can change dir->NumbForZero */
	  		copyCnt++;
 /* because don't break copys, so ignore err, don't OPM like rebuild */
	}
	}
    if(ddir!=dst_dir)ORDclose(ddir, 1);
/* every workspace->CurDir must exist, CurLib only is one of workspace */
  }
  return (_over!=Esc ? 1:0);
}

inline int copyORD(__ORD *pcdir,__ORD *sdir)
{
char *dirnam;
un_Int lst[pd_param_cnt];
if(_over==Esc ||
 (pcdir->lib==dstlib && sdir==dst_dir))/* defence self-copy loop */
/*  own_adr will same as workspace[...], like slib->own_adr== dlib->own_adr*/
	return 0;
dirnam=ORDpath(sdir,src_dir,1);
getPdPara(sdir, lst);
pcdir=ORDcreat(dst_dir, dirnam/*src_dir? dirnam:dirnam+1*/,lst);
free(dirnam);
/* if(pcdir){ this error ought to no happen, as ORDcopy(...) have limit */
ORDclose(pcdir, 1);
return 1;
}

/*   ORDcopy & NumCopy follow :  */
void ORDcopy(__ORL *curlib, int n,char **pm, const char *extparm)
{
  __ORL *s_lib=curlib, *d_lib=curlib;
  __ORD *ddst, *sdir;
  int msg, i;
  if(fixSpaces(&s_lib, &d_lib, extparm)==False)return;
  if(d_lib==NULL||s_lib==NULL){ ORtips(NoBuff_2,1); return; }
  static const char *cploop[6]={"-n", "-d", "-i", "-t", "-r", "-v" },
	*_cploop[6]={"--num", "--dir", "--include", "--total", "--reply", "--verbose"};
//  "--reply", "--verbose"  ==> 1024<<0, 1024<<1, 1024<<2... 
  int brwVal[6];
  memset(brwVal, 0, sizeof(int)*6);
  ProcOpt optBrows={ 6, cploop, _cploop, brwVal,	0, NULL, 0	};
  arglists *alst=procParas(n, pm, &optBrows, NULL);
  switch(alst->argc){
  case 0 : 
  case 1 : ORtips(58-alst->argc, 1);
	showUsage(ORL_dircp);
	argsFree(alst);
	return;
// case 2 : break;
  default : unPara(alst, 3);
  }
  msg=0;  _over=0;  vbs=0;
  for(i=0; i<6; i++)if(brwVal[i])
		switch(i){
		case 3 : msg=7;
			break;
		case 4 : _over='a';
			break;
		case 5 : vbs=True;
			break;
		default : msg|=1<<i;
		}

  sdir=ORDopen(s_lib->CurDir, alst->argv[0], DIR_BROW);
  argsFree(alst);
  if(idxdscpt>0x7ffd){
    un_Int lst[5];
    getPdPara(sdir, lst);
    ddst=DirOpen(d_lib->CurDir,pm[1]);
    if(idxdscpt>0x7ffd){
	if(/* ddst&& */d_lib==s_lib&&ddst->own_adr==sdir->own_adr){
		defaultHB(SelfCpy_18); return;
		}
	char *ptr;
	__ORD *_dir;
	if(pm[0][0]=='.'&&pm[0][1]==0)pm[0]=s_lib->CurDir->name;
	if( (ptr=(char *)separChr(*pm)) )ptr++;
	else ptr=*pm;
	_dir=ORDcreat(ddst, ptr, lst);
	if(idxdscpt<0x7ffd){
		char buf[1024];
		sprintf(buf, "%s/%s", pm[1], ptr);
		PrnTxt(0, 31, buf);
		goto _err_msg_;
		}
	ORDclose(ddst,1);
	ddst=_dir;
    }
    else ddst=ORDcreat(d_lib->CurDir,pm[1],lst);
    if(idxdscpt<0x7ffd){
	printf(pm[1]); /* here can't ignore */
	goto _err_msg_;
	}
    else {
	src_dir=sdir;  dst_dir=ddst; /* dir->NumbForZero=0;*/
	dstlib=d_lib; /*CurLib=curlib; above 3 var is extern */
	copyCnt=0;	
	if((msg&3)==0)msg=1;
	ORDbrowth(sdir,msg,copyNum,copyORD);
//	if(ORDbrowth(...)==0)reportBug(); above have limit, so here no thus
	if(getMsg){
		char buf[128];
		sprintf(buf, "  Total copy %d\n", copyCnt);
		msgShow(buf);
		}
	else printf("  Total copy \033[7m %d \033[0m\n",copyCnt);
	ORDclose(ddst,1);
    }
/*    if(isNormDir(sdir)&&sdir!=s_lib->CurDir)*/ ORDclose(sdir,2);
  }
  else {
	_err_msg_: reportBug();
	showUsage(ORL_dircp);
	}
}

void NumCopy(__ORL *curlib,char **pm, const char *extparm)
{
  int srcnmb, dstnmb;
  __ORL *s_lib=curlib, *d_lib=curlib;
  __ORD *d_dir, *s_dir;
  char *dstpth, *srcpth=divPath(*pm,&srcnmb);
  if(numNone){
	char buf[800];
	sprintf(buf, " Source: %s  ", *pm);
	PrnTxt(0,31,buf);
	ORtips(WrongOpera_22, NoQust);	showUsage(ORL_cp);
	return;
	}
  if(fixSpaces(&s_lib,&d_lib,extparm)==False)return;
  if( d_lib==NULL || s_lib==NULL){ ORtips(NoBuff_2,1); return; }
  s_dir=DirOpen(s_lib->CurDir,srcpth);
  if(idxdscpt>0x7ffd){
     dstnmb=srcnmb; _over=0;
     dstpth=divPath(pm[1],&dstnmb);
     d_dir=DirOpen(d_lib->CurDir,dstpth);
     if(idxdscpt>0x7ffd){
	baseCopy(s_dir,d_dir,srcnmb,dstnmb,NULL);
	ORDclose(d_dir,1);
     }
     else msgShow(pm[1]);
     ORDclose(s_dir, 2);
  }
  else msgShow(*pm);
  if(idxdscpt<0x7ffd){
	defaultHB(/*PthInv_7*/idxdscpt);
	showUsage(ORL_cp);
	}
}

