/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2011
  Free under LGPL
*/

#include "normal.h"
#include "stdfun.h"
#include "dirloop.h"
#include "dirext.h"
#include "orlio.h"
#include "conspace.h"
#include "infor.h"
#include "fculoop.h"
#include "rebuild.h"
#include <sys/stat.h>

static BOOL fit_msg;

static int numCmpr(__ORD *dir,BYTE *readUnit)
{
 BYTE *writeUnit;
 int numb, j, i, n, clen, num_block, baseFCULen;
 MAU *mau;
 BOOL zero;
 unsigned int  Len;
 if(dir->lib->sys_Id_done){
	n=1;	num_block=SYS_ID_BLOCK;
	zero=True;	clen=FCU_NumPos+sizeof(DAU);
	LibCmpr->sys_Id_done=True; /* dst_dir->lib */
	}
 else {
	n=dir->DAUC,	num_block=dir->Num_FCUs_Block,
	zero=isZero(dir->Format),	clen=dir->Num_FCU_Len;
	}
 mau=(MAU *)malloc(sizeof(MAU)*n);
 baseFCULen=zero? FCU_NumPos : FCU_NumPos+sizeof(int);
 for(i=0; i<num_block; i++, readUnit+=clen){
	if(zero)numb=dir->NumbForZero++;
	if((*readUnit&3)==1 ){
		if(!zero)numb=*(int *)(readUnit+FCU_NumPos);
		writeUnit=seekFCU(dst_dir,numb,NULL, NUMB_WRITE );	// must set FCU_dyw, so call it 
		addFCT(dst_dir,writeUnit);
		if((*readUnit>>2)>0){
			memcpy(writeUnit,readUnit, clen);
			goto _jmp_;
			}

		readFCU(dir,readUnit,mau,n);
		if(fit_msg)
			for(j=0; j<n; j++)
				if(mau[j].buf && mau[j].alen-mau[j].len>160&&mau[j].len*10/mau[j].alen<7)
					mau[j].alen=mau[j].len;
		memcpy(writeUnit,readUnit, baseFCULen);

		Len=0;
		for(j=0; j<n; j++){
			writeDAU(dst_dir, writeUnit, mau+j, j);
			Len+=mau[j].len;
			}
		freeMAU(mau, -n);
		if(Len)_jmp_: writeFCU(dst_dir, writeUnit, 0);
		free(writeUnit);
	}
//  because don't break copys, so ignore err 
 }
 free(mau);
 LibCmpr->sys_Id_done=False;
 return 1;
}

static int ReFixLen(int cnt,int use)
{
if(use<30){
	if(cnt<use)cnt=use;
	}
else if(use>30&&use<80)cnt=use/2;
          else if(use>80&&cnt<32)cnt=32;
return cnt;
}

void getPdPara(__ORD *dir, un_Int *lst)
{
   *lst=dir->Format;
   lst[1]=fit_msg? ReFixLen(dir->Num_FCUs_Block,dir->selfnumbs) : dir->Num_FCUs_Block;
   lst[2]=fit_msg? ReFixLen(dir->Dir_FCUs_Block,dir->selfdirs) : dir->Dir_FCUs_Block;
   lst[3]=dir->DAUC;
   lst[4]=dir->mode;
}

static int pdCmprs(__ORD *pcdir,__ORD *dir)
{
un_Int lst[pd_param_cnt];
char *dirnam;
ORDclose(dst_dir, 0);
dirnam=ORDpath(dir,NULL,0);
getPdPara(dir,lst);
dst_dir=ORDcreat((__ORD *)LibCmpr,dirnam,lst);
free(dirnam);
return 1;
}

char *fixpath(const char *pthnam, const char *tmp)
{
int nnam=0, dirlen, i;
char *fcreat, *ptr=(char *)separChr(pthnam);
dirlen=ptr ? ptr-pthnam+1 : strlen(pthnam);
fcreat=(char *)malloc(dirlen+96);
for(i=0; i<dirlen; i++)fcreat[i]=pthnam[i];
do
	(void)sprintf(fcreat+dirlen, "%d%s", ++nnam, tmp);
while(access(fcreat, F_OK)==0);
return fcreat;
}

static const char compfile[]="rebuild.orl";
__ORL *ORLrebuild(__ORL *send,const char *filenam, int msg)
{/* if cmpr send, then return send, else return NULL */
  int rt;
  un_Int lst[pd_param_cnt+2];
  dskadr_t diradr;
  __ORD *dir1;
  char *ptr;
  const char *ftmp, *lnktmp;
  struct stat64 sst, cmpst;
  if(filenam){
	send=ORLuse(filenam, (OpenSpace)(OpenLastDir|CompactMsg|ORLerror|FastBuf));
	if(send==NULL)return NULL;
	if(send->openTimes)filenam=NULL;
	}
  else if(send->openMode&OpenAlway){
		idxdscpt=48;
		ORtips(48, True);
		return NULL;
	}
  lnktmp=realpath(send->fname, NULL);
  ftmp=fixpath(lnktmp, compfile);
  fit_msg=msg&OptiFit;

  getPdPara((__ORD *)send,lst);
  lst[pd_param_cnt]=((__ORD *)send)->zSize;
  lst[pd_param_cnt+1]=True;
  LibCmpr=ORLcreat(ftmp, lst);
  if(LibCmpr==NULL){
	if(filenam)ORLclose(send,NULL);
	_err_: PrnTxt(0, 31, ftmp); ORtips(idxdscpt,1);
	send=NULL;
	goto _ex_;
	}
  fstat64(send->fpt->_fileno, &sst);	fstat64(LibCmpr->fpt->_fileno, &cmpst);
  if(cmpst.st_uid!=0 && cmpst.st_uid!=sst.st_uid){
	idxdscpt=NoFileRight_30;
	goto _err_;
	}
  if(msg&ShowTips){
	msgShow( filenam? send->fname : SPC );
	msgShow("  rebuild ...");
	}
  dst_dir=(__ORD *)LibCmpr;
  send->sys_Id_done=True;
  NumBrowth((__ORD *)send, numCmpr); // sys_id, content above 1 line
  rt=ORDbrowth((__ORD *)send,7,numCmpr,pdCmprs);
  ORDclose(dst_dir, 0);

  ptr=ORDpath(send->CurDir,NULL,0);
  dir1=DirOpen((__ORD *)LibCmpr,ptr);
  free(ptr);
  diradr=dir1->own_adr;
  LibCmpr->DefaultDir=diradr;
  ORLclose(LibCmpr,NULL);
  LibCmpr=NULL;/* this is flags, must clear it */
  if(rt){
	int i=send->openIdx;
	ORLclose(send,NULL);
	remove(lnktmp);
	rename(ftmp, lnktmp);
	if(cmpst.st_uid!=sst.st_uid)
		chown(lnktmp, sst.st_uid, sst.st_gid);
	if(cmpst.st_mode!=sst.st_mode)
		chmod(lnktmp,sst.st_mode);
	if(filenam==NULL){
		send=ORLopen(lnktmp, DectName);
		workspace[i]=send;
		send->openIdx=i;
		send->DefaultDir=diradr;
		send->fname=lnktmp;
		readCORD(send);
		goto _jmp_;
	}
  }
_ex_:  free((void *)lnktmp);
_jmp_:  if(ftmp!=compfile)free((void *)ftmp);
  return 	filenam ? NULL:send;
}

