/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2010, 2014
  Free under LGPL
 */

#include "jxswitch.h"
#include "stdfun.h"
#include "ordir.h"
#include "read.h"
#include "write.h"
#include "script.h"
#include "conspace.h"
#include "infor.h"
#include "dlist.h"
#include "dialogid.def"
#include "../objcom/comm.h"

extern const char SPC[]; // in dirloop

int bakdscpt=0x7fff, lock;

#include "input.c"

const _Int *kval;
const char *comchs, logChs[]="//Log", **rt_msg;
char cfgval[8];
/* BOOL errSig_space; */

void runLog(const char *chs)
{
#ifdef		_Single
if( workspace[0]->openMode&OpenAlway ){
	MAU mau;
	mau.buf=(char *)chs; mau.len=0; mau.alen=0;
	NumInsLmt((__ORD *)workspace[0], logChs, &mau, 0/* append mode */, 80);
	}
#endif
}

int indexUsage(int nCom, const _Int *coms)
{  
int i;
for(i=0; coms[i]; i++)if(nCom==coms[i])return i;
return -1;
}

char *HBinfo(int idx,BOOL root)
{
#ifndef		_Single
if(workspace[0]->openMode&OpenAlway){
  MAU send;
  BYTE *stat;
  bakdscpt=idxdscpt;
  __ORD *dir=root? (__ORD *)workspace[0] : ORDopen((__ORD *)*workspace, "Usage", DIR_READ);
  if((stat=NumRead(dir, idx, &send,1)))free(stat);
  if(root==False){
	ORDclose(dir, 1);
/*	errSig_space=True; for mult workspace show */
	}
  return send.buf;
}
#endif
return NULL;
}

void showUsage(int nCom)
{
char *pt=GetUsage(indexUsage(nCom, kval));
if(pt){
	msgShow(pt);	free(pt);
	}
}

void scriptTips(int msg)
{
if(diguei && isRS){
   sprintf(OutBuf,"  >> %s %d: ",scpfname,scpline);
   if(getMsg){
	sprintf(OutBuf, msg>1 ? "%s %d\n" : "%s %d",scpfname,scpline);
	PrnTxt(0,33, OutBuf);
	if(msg>1){
		switch(popMsg(scpbuf, NULL, ScriptErrorId, orlX)){
		case 1 :  CommNumb=Quit_Script_Run; /* quit this script */
		break;
		case 0 :  CommNumb=End_Script_Run; /* abort  all script */
		}
	}
	else getMsg(scpbuf);
	}
   else {
	char tmp[8];
	printf("\033[33;1m%s   \033[0;7m%d\033[0m : ",scpfname,scpline);
	printf(msg>1 ? "%s\n%s\n":"%s%s\n",scpbuf, msg>1 ? quitScp:SPC);
	if(msg>1)switch(inCon(tmp,4)){
		case 'q' : CommNumb=ORL_quit; /* quit all script */
			break;
		case 'e' :  CommNumb=End_Script_Run; /* abort this script */
		}
	}
   strcat(OutBuf, scpbuf);
   runLog(OutBuf);
	}
}

const char *pErrParam;
void errInfo(int idx, const char *pm)
{
PrnTxt(1, 32,pm); 
pErrParam=pm;
ORtips(idx,4);
}

void CHBinfo(const int idx, const char *txt)
{
char *pt=idx>-1 ? GetHB(idx) : "** ";
printf("\033[31m%s  \033[0m%s\n", pt, txt);
if(idx>-1&&pt)free(pt);
}

int ORtips(int idx,int msg)
{ // msg 2|1 : no WarnStyle | no quest
char  *pt;
idxdscpt=idx;
pt=GetHB(idx);
if(msg&NoWarn){
	if(pt){
		int x=popMsg(pt, NULL, msg&NoQust ? -3 : 0, orlX);
		free(pt);
		return x;
	}
	return -1;
}

if(msg)PrnTxt(2, 31,"**");
if(pt){
	sprintf(OutBuf,"  %s%c", pt, ErrParam);
	msgShow(OutBuf);
	if(cfgval[1]){
		sprintf(OutBuf,"  %s  ** %s%c", msg&showParam? pErrParam:SPC, pt, ErrParam);
		runLog(OutBuf);
		}
	free(pt);	ErrParam=32;
}
else {
	char buf[64];
	sprintf(buf, "  No about message: %d",idx);
	msgShow(buf);
}
/* if(rtlout!=stdout)fprintf(rtlout,"\n\n"); */
scriptTips(2);
return 0;
}

void defaultHB(int idx)
{
ORtips(idxdscpt<0x7ff0? idxdscpt:idx,1);
}
//#define reportBug() defaultHB(28)

int putMsg(const char *txt, const char *cap, int fg, void *p)
{
static const int keys[7]={ Esc, 'n', 'y', 'e', 's', 'q', 0 };
int code=1;
if(cap)msgShow(cap);
if(txt)printf(txt);
  while(fg>-1 && isdone(code,keys)==False){
	char bu[8];
	code=inCon( bu,7);
	}
return code;
}

