/*
	Write & edit by Linjianghua 2004-2006, 2008-2012, 2014, 2015
	Copyright Linjianghua(Xempo)
	Free under LGPL
*/

#include <sys/stat.h>
#include <sys/errno.h>
#include "orlio.h"
#include "ordir.h"
#include "script.h"
#include "infor.h"
#include "write.h"
#include "numbtype.h"
#include "options.h"
#include "../objcom/comm.h"
#include "stdfun.h"
#include "../dialogid.def"

int OverWrite, CommNumb;
static const char finclude[]="#include=";
char *InpBuf, *OutBuf;

void (*consWrite)(__ORD *dir, const char *txt);

#define IncludeLen	sizeof(finclude)-1

void sysIdWrite(__ORL *lib, int num, MAU *mau)
{
lib->sys_Id_done=True;
NumWrite((__ORD *)lib, num, mau, 1);
lib->sys_Id_done=False;
}

inline char *isLoadFile(MAU *pdat,char *fnam, int type)
{
char *pf;
int len;
if(fnam==NULL)return NULL;
if(type!=_file){
	if(memcmp(fnam,finclude,IncludeLen))return NULL;
//	else #include=...
	pf=fnam+IncludeLen;
	}
else pf=fnam;
while(*pf==32||*pf==9)pf++;
len=strlen(pf)-1;
while(strchr(divsyb,pf[len]))len--;
pf[len+1]=0;
pdat->buf=ReadFile(pf,(unsigned int *)&pdat->len, False, orlX, &orlPaths);
return pdat->buf;
}

int putMAU(MAU *mau,char *buf,int type)
{
if(buf){
  char *pt=NULL, *ptr;
  mau->alen=0;
  while( (ptr=isLoadFile(mau,buf,type)) ){
	if(pt)free(pt);
	pt=ptr;	buf=pt;
	if(type==_file)type=_void;
	}
  if(pt==NULL)pt=buf;
  if(type==_file)type=_sold;/* parm: .f to fail to load file that must process */

  if(*pt){
    int L;
    const char *pdat;
    if(mau->buf!=pt){/* in script, numbset will have -l:??? , so use thire len */
	mau->buf=pt;
	mau->len=strlen(pt);
    }
    switch(type){
    case _void : return _void;
    case _sold : 	/* only use text-sold, free hand */
	if( (pdat=getints(pt, &type)) ){
_IntType:	while(*pdat==32||*pdat==9)pdat++;
		mau->buf=(char *)atoi_lst(pdat, &L, type); /* script can't free(pt) */
		mau->len=L*intType[type];
		goto _exit_;
	}
	for(buf=pt;strchr(divsyb,*buf);buf++);
	if(buf>pt){
		mau->len-=buf-pt;
		memmove(pt,buf,mau->len);
		}
	for(buf=pt+mau->len-1;strchr(divsyb,*buf)&&buf>pt; buf--)mau->len--;
    case _txt : type=_void;
	mau->len=FmtTxt(pt,mau->len);/* txt for disk, use for number in script */
	break;
    case _separa : /*mau->len=*/fmtinp(buf, NULL, memSepara, 0);
	break;
    default : if(type<Int_TypeCount){ pdat=pt;  goto _IntType; }
    }
_exit_:  if(pt!=buf&&IsIntType(type))free(pt);
  }
}
return type;
}

#define _beyound 0xffffffff

/* Write Numb FCU */
BOOL wnfcu(__ORD *dir, fmtFCU *sendFcu, MAU *mau, int n)
{
  static const int abortkeys[]={ 'q', 'n', 's' , Esc,
			4, 1, 3, 0xfff0fff0,
			0 };
  __ORL *lib=dir->lib;
  int msg=sendFcu->msg;
  BYTE *unit=writeInit(dir, sendFcu->numb, mau, n);
  if(unit){
    int i, idxbak=idxdscpt; //  use for over_write 
    time_t  mtm;
    unsigned int len;
    if(idxbak<0x7ffd){
      char infobuff[400], *pth, pth1[300];
      if(idxbak==I_OverWriteNum)
	switch(OverWrite){
	case 'q' : CommNumb=Quit_Script_Run; // in script
	case 4 : // &C
	case 's' :
	case 3 : // &Skip
	case 0xfff0fff0 : // NO_BTN_ID
	case Esc  : _fail: free(unit); return False;
	case 'a' :
	case 2 : break;
	default : {
		int tmp=lib->FCU_dyw;
		pth=ORDpath(dir,NULL/*lib->CurDir*/,1);
		scriptTips(0);
		(void)sprintf(pth1, pth[1]!=0 ? "%s/%d" : "%s%d", pth, sendFcu->numb);
		(void)sprintf(infobuff, rt_msg[6], pth1);
		OverWrite=popMsg(infobuff, NULL, OverWriteId, orlX);
		lib->FCU_dyw=tmp;
		free(pth);
		if(isdone(OverWrite,abortkeys))goto _fail;
		}
	}
     else { ORtips(idxdscpt, 1); goto _fail; }
    }
    unit[1]=sendFcu->format[1]; /* |(unit[1] & 0xff-15 ); reserve org attrib, not need */
    if(isType(dir->Format)){
	   int tPos=FCU_TypePos( dir->Format );
	   BYTE *pt=unit+tPos;
	   for(i=0;i<n;i++)
		pt[i]=sendFcu->format[tPos+i];
	}
   idxdscpt=idxbak; // for follow writeFCU
   addFCT(dir, unit);
   switch(msg){
   case ARCH_LZMA :
   case ARCH_GZIP :
   case ARCH_BZIP2 : 
   case ARCH_NORM  : {
	struct archstat archst;
	struct stat64 st;
	const char *fn, *cmds, *tmp1, *tmp2;
	static const char CmprTmp[]="CmprTmp",
		*cmdstr[3]={"bzip2 -zc%d", "gzip -c%d", "lzma -zc%d" };
	char txt[16];
	fn=mau->buf;
	stat64(fn, &st);
	archst.uid=st.st_uid;
	archst.gid=st.st_gid;
	archst.mode=st.st_mode;
	mtm=st.st_mtime;
	if(st.st_size>4000000){
		tmp2=catstr("Wait for arching",  fn, 32);
		msgShow(tmp2);
		free((void *)tmp2);
		}
	if(msg>ARCH_NORM){
		char fmtchs[20];
		i=sprintf(fmtchs, cmdstr[(msg>>11)/2], sendFcu->extVal);
		if(sendFcu->extVal==0)fmtchs[i-1]=0;
		tmp1=catstr( fmtchs, fn, 32);
		tmp2=catstr(tmp1, ">", 32);
		fn=CmprTmp; i=0;
		while(access(fn, F_OK)==0 && i<20000){
			(void)sprintf(txt, "%s%d", CmprTmp, ++i);
			fn=txt;
			}
		cmds=catstr(tmp2, fn, 32);
		free((void *)tmp2);
		i=system(cmds);
		free((void *)cmds);
		if(i){
			msgShow(tmp1);
			msgShow("Fail to arch ...");
		}
		free((void *)tmp1);
		if(i)goto _skip_;
		}
	BYTE *daupos; //=unit+ FCU_DAUPos(dir, 0);
	char *buff;
	unsigned int alen, pre_len;
	dskadr_t *padr=getDAU(dir, unit, &alen, &len, 0);
	daupos=(BYTE *)padr;
	FILE *fp=fopen64(fn, "rb");
	if(fp==NULL){
		msgShow(fn);
		ORtips(0, 1);
		goto _skp1_;
	}
	fstat64(fp->_fileno, &st);
	if(st.st_size >= _beyound){
		msgShow(fn);
		msgShow("beyound 4G, wait !");
		fclose(fp);
		if(msg>ARCH_NORM)remove(fn);
_skp1_:		idxdscpt=0;
		goto _ex1_;
		}
	if( idxdscpt==I_OverWriteNum/*||isZero(pdp->Format)*/){
		dir->selfsize-=len;
		lib->useSize-=len;
	} /* overwrite */

	len=st.st_size;
	pre_len=len > mau->alen ? len : mau->alen;
	setLenDAU(daupos, len);
	if(pre_len>alen){
		setAlenDAU(daupos, pre_len);
		*padr=lib->fsz;
		lib->fsz+=pre_len;
	}
#define  buflen  16384
	fseek(lib->fpt, *padr, 0);
	fwrite(&archst, sizeof(struct archstat), 1, lib->fpt);
	dir->selfsize+=len+sizeof(struct archstat); /* selfsize is tab data's size,not disksize, deffenct lib->fsz */
	lib->useSize += len+sizeof(struct archstat);
	lib->fsz+=sizeof(struct archstat);
	buff=(char *)malloc(pre_len > buflen ? buflen : pre_len);
	while(pre_len>0){
		len=pre_len > buflen ? buflen : pre_len;
		fread(buff, len, 1, fp);
		fwrite(buff, len, 1, lib->fpt);
		pre_len-=len;
	}
	fclose(fp);
	free(buff);
	if(msg>ARCH_NORM)remove(fn);
	if(dir->DAUC>1){
		MAU m;
		tmp1=separChr(mau->buf);
		if(tmp1){
			m.buf=(char *)tmp1+1;
			m.len=strlen(tmp1+1);
			m.alen=0;
			}
		writeDAU(dir, unit, tmp1 ? &m : mau, 1);
		}
	unit[1]|=msg>>6;
	_ex1_ :	if(fn!=mau->buf&&fn!=CmprTmp&&fn!=txt)free((void *)fn);
		if(idxdscpt<0x7ff0&&idxdscpt!=I_OverWriteNum)goto _skip_;
   }
   break;
   case 8 : /* copy */
	memcpy(unit+FCU_TimePos, sendFcu->format+FCU_TimePos, OrlTmLen);
	mtm=1;
	goto _jmp3_;
   default : {
	mtm=0;
_jmp3_:	len=0;
	if(n > dir->DAUC)n=dir->DAUC;
	for(i=0; i<n; i++){
		writeDAU(dir,unit,mau+i, i);
		len+=mau[i].len;
		}
	if(len==0)goto _skip_;
   }
   }
   writeFCU(dir, unit, mtm);
_skip_:   free(unit);
   return True;
  }
  else reportBug();
  return False;
}

int NumInsLmt(__ORD *dir0, const char *dirnam, MAU *mau,int nmb, int cnlmt)
{/* limit nmb, if nmb >=cntlmt, cut the first, then write cntlmt-1, such as log only recieve 80. */
__ORD *dir=DirOpen(dir0, dirnam);
if(dir){
 __ORL *lib=dir->lib;
 if(nmb<1){
	seekFCU(dir,0,NULL,NUMB_LAST);  /* append */
	nmb=dir->NumbForZero;
 }
 if(/*nmb>=dir->Num_FCUs_Block*cnlmt*/ nmb>=cnlmt){
   dskadr_t adr, padr, pos;
   BYTE *fcu, *unit;
   int i, cnt, len=dir->Num_FCUs_Block*dir->Num_FCU_Len+sizeof(dskadr_t);
   fcu=(BYTE *)malloc(len);
   unit=fcu;
   nmb-=dir->Num_FCUs_Block;
   adr=dir->numb_FCT;
   dkread(lib,adr,unit,len,1);
   for(cnt=0,i=0;i<dir->Num_FCUs_Block;i++,fcu+=dir->Num_FCU_Len)
	if((*fcu&3)==1){
		setDelTag(*fcu); cnt++;
		DFCUmdf(dir, fcu, adr+i*dir->Num_FCU_Len,-1);
		}
   padr=*(dskadr_t *)fcu; /* first block next-ptr become first  */
   dir->numb_FCT=padr;
   while( padr>0 ){
	pos=padr+len-sizeof(dskadr_t);
	dkread(lib, pos, &padr, sizeof(dskadr_t),1);
   }
   dkwrite(lib,pos,&adr,sizeof(dskadr_t));
   *(dskadr_t *)fcu=0; /* last next-ptr set 0 */
   dkwrite(lib, adr+len-sizeof(dskadr_t), fcu, sizeof(dskadr_t));
#ifndef _NONE_FAST_PAGE_
   memset(dir->zcache,0,sizeof(ZeroCache)*dir->zSize);
   for(i=0; i<dir->zSize; i++)
      if(dir->zcache[i].pd_adr==dir->own_adr){
	if(dir->zcache[i].pFCT==adr)dir->zcache[i].pd_adr=0;
	dir->zcache[i].NumbForZero-=cnt;
	}
#endif
   free(unit);
  }
  NumWrite(dir, nmb++, mau, dir->DAUC);
  ORDclose(dir,1);
}
return nmb;
}

#define  arch_count  4
static const int archVals[arch_count]={ ARCH_NORM, ARCH_BZIP2, ARCH_GZIP, ARCH_LZMA };
void NumInsert(__ORD *dir, int cn, char **pms, const char *extparm, int nCom, int env)
{ // if want to write the data with space, use "write 0" [ENTER]
// and Data: use "   Free Star Plu     "[ENTER]
  un_Int style;
  int nmb, b, n, cnt, tPos, msg, depth;
  MAU *mau;
  char **pmlst;
  BYTE initType;/* free input, normal-console is text-mode */
  if(nCom==ORL_arfile){
#define  mu1  5
	static const char *para[mu1]={ "-B", "-G", "-L", "-1", "-9" },
		*_para[mu1]={ "--bzip2", "--gzip", "--lzma", "--fast", "--best" };
	static const int inv[3]={0,1,2};
	int val[mu1];
	memset(val, 0, sizeof(int)*mu1);
	ProcOpt opt={ mu1, para, _para, val, 3, inv, 0 };
	arglists *alst=procParas(cn, pms, &opt, NULL);
	if(alst==NULL)return;
	if(alst->argc==0){
		ORtips(I_None_58, 1); showUsage(ORL_arfile);
		return;
		}
	for(b=0; b<3&&val[b]==0; b++);
	if(b>2)msg=ARCH_NORM;
	else msg=archVals[b+1];
	depth=val[3] ? 1 : (val[4] ? 9 : 0);
	for(b=0; b<alst->argc; b++)pms[b]=(char *)alst->argv[b];
	argsFree(alst);
	}
  else  msg=(nCom>ORL_arfile&&nCom<-480) ? archVals[nCom-ORL_arfile] : 0;

  cnt=0;
  if(nCom==ORL_append){/* It's not clear what append specify dir */
	if(isNormDir(dir))dir->otherOpen++;
	append:  nmb=NumLast(dir);
	}
  else {
	char *nam=divPath(*pms, &nmb);
	if(numNone==False)cnt=1;
	if(nam){
		dir=ORDopen(dir,nam, DIR_BROW);
		if(idxdscpt<0x7ffd){ reportBug(); return; }
		}
	else if(isNormDir(dir))dir->otherOpen++;
	if(nCom==ORL_add ){
		cnt=1;
		goto append;
		}
	}
//  OverWrite=0; // no init, as in main() have done
  style=dir->Format; n=dir->DAUC;
#define  dau  b
  dau=n;
  if(pms&&pms[cnt])pmlst=setargv(pms[cnt], " \t", &n);
  else pmlst=(char **)zalloc( dau*sizeof(char *) );
  initType= nCom==ORL_write ? _void : _sold; // write==insert.v
     BYTE *type, *pmstat;
     if((nCom==ORL_append||nCom==ORL_add)&& !isZero(style)){
	ORtips(47, 1);	goto _ex_;
	}
    if(pmlst[0]==NULL){
	if(getMsg){
		char *buf=(char *)malloc(0x7fff);
		int i, L;
		static const char nmbset[]="numbset ? -t=";
		if(!(nCom!=ORL_append && nCom!=ORL_add && numNone))L=sprintf(buf, "numbset %d -t=", nmb);
		else {
			strcpy(buf, nmbset);
			L=sizeof(nmbset)-1;
		}
		for(i=0; i<dau; i++)buf[L+i]='v';
		buf[L+i]=0;
		for(i=0; i<dau; i++)strcat(buf, "\n{\n}");
		consWrite(dir, buf);	//	free(buf); will be do
		CommNumb=0x7ff0; // change org cmd
		goto _ex_;
	}
	else {
	int key;
	showUsage(nCom);
	if(nCom!=ORL_append && nCom!=ORL_add && numNone){
		printf("Numb : ");
		key=inCon(InpBuf, 2047);
		if(key==Esc)goto _jmp_;
		nmb=atoi(InpBuf);
	}
	cnt=-1;
	while(++cnt<dau){
		printf("Data:");
		key=inCon(InpBuf, 2047);
		if(key==Esc){
		_jmp_:	CommNumb=key; goto _ex_;
		}
		pmlst[cnt]=strdup(InpBuf);
		}
	initType=_void;
	}
      }
      else cnt=n;

    tPos=FCU_TypePos( style );
    type=(BYTE *)zalloc(cnt*2+tPos); pmstat=type+cnt;
    mau=MAUalloc(cnt);
    int j, *ipt=(int *)zalloc(sizeof(int)*dau);
    pmstat[1]=extendPara(extparm, type, ipt, cnt, initType);
    for(j=0; j<cnt; j++)mau[j].alen=ipt[j];
#undef  dau
    free((void *)ipt);
    if( CommNumb==Quit_Script_Run || CommNumb==End_Script_Run ) goto _skp_;
    for(b=0; b<cnt; pmstat[ tPos+b++ ]=(n ==_file? _void:n) )
	if((n=type[b])!=_none){
		if(n==_separa)*memSepara=type[b+cnt];
		if(n!=_void)fmtvalue(pmlst[b], 1);
		n=putMAU(mau+b,pmlst[b],n);
		}
    if((env&append_Mode)==append_Mode)nmb=NumLast(dir);

    fmtFCU fmt={ pmstat, nmb, msg, depth } ;
    wnfcu(dir, &fmt, mau,cnt);

    for(n=0;n<cnt;n++)
	if(/*mau[n].buf&&mau[n].buf!=pmlst[n]*/
		(b=pmstat[tPos+n])==_file || b<Int_TypeCount )free(mau[n].buf);
_skp_:    free(type);      free(mau);
_ex_:	ORDclose(dir,1);
free(pmlst);
}

#include "ardir.c"
